#ifndef BASICPITCHCALCULATION_HPP
#define BASICPITCHCALCULATION_HPP

#include<iostream>
#include<fstream>
#include<string>
#include<sstream>
#include<vector>
#include<stdio.h>
#include<cmath>
#include<cassert>
using namespace std;

inline string PitchToSitch(int p){//pithc to spelled pitch (sitch)
	int q=(p+120)%12;
	string qstr;
	stringstream ss;
	switch(q){
		case 0 : qstr="C"; break;
		case 1 : qstr="C+"; break;
		case 2 : qstr="D"; break;
		case 3 : qstr="E-"; break;
		case 4 : qstr="E"; break;
		case 5 : qstr="F"; break;
		case 6 : qstr="F+"; break;
		case 7 : qstr="G"; break;
		case 8 : qstr="G+"; break;
		case 9 : qstr="A"; break;
		case 10 : qstr="B-"; break;
		case 11 : qstr="B"; break;
	}//endswitch
	ss.str(""); ss<<qstr<<(p/12-1);
	return ss.str();
}//end PitchToSitch

inline int SitchToPitch(string sitch){
	int p_rel,p;
	if(sitch[0]=='C'){p_rel=60;
	}else if(sitch[0]=='D'){p_rel=62;
	}else if(sitch[0]=='E'){p_rel=64;
	}else if(sitch[0]=='F'){p_rel=65;
	}else if(sitch[0]=='G'){p_rel=67;
	}else if(sitch[0]=='A'){p_rel=69;
	}else if(sitch[0]=='B'){p_rel=71;
	}else{p_rel=60;
	}//endif
	sitch.erase(sitch.begin());
	int oct=sitch[sitch.size()-1]-'0';
	sitch.erase(sitch.end()-1);
	p=p_rel+(oct-4)*12;
	if(sitch==""){p+=0;
	}else if(sitch=="+"){p+=1;
	}else if(sitch=="++"){p+=2;
	}else if(sitch=="-"){p-=1;
	}else if(sitch=="--"){p-=2;
	}//endif
	return p;
}//end 

inline int SitchToSitchHeight(string sitch){
  int oct=sitch[sitch.size()-1]-'0';
  char sitchClass=sitch[0];
  int ht;
  if(sitchClass=='C'){ht=0;
  }else if(sitchClass=='D'){ht=1;
  }else if(sitchClass=='E'){ht=2;
  }else if(sitchClass=='F'){ht=3;
  }else if(sitchClass=='G'){ht=4;
  }else if(sitchClass=='A'){ht=5;
  }else if(sitchClass=='B'){ht=6;
  }else{ht=0;
  }//endif
  return ht+7*(oct-4);
}//end SitchToSitchHeight

inline int SitchToAcc(string sitch){
  string accLab=sitch.substr(1,sitch.size()-2);
  if(accLab==""){return 0;
  }else if(accLab=="+"){return 1;
  }else if(accLab=="++"){return 2;
  }else if(accLab=="-"){return -1;
  }else if(accLab=="--"){return -2;
  }else{return 0;
  }//endif
}//end SitchToAcc

#endif // BASICPITCHCALCULATION_HPP





























