#ifndef METRICALHMM_HPP
#define METRICALHMM_HPP

#define printOn false

#include<iostream>
#include<string>
#include<sstream>
#include<cmath>
#include<vector>
#include<fstream>
#include<cassert>
#include "Transcr_v160315.hpp"
using namespace std;

double LogAdd(double d1,double d2){
  //log(exp(d1)+exp(d2))=log(exp(d1)(1+exp(d2-d1)))
  if(d1>d2){return d1+log(1+exp(d2-d1));
  }else{return d2+log(1+exp(d1-d2));
  }//endif
}//end LogAdd
void Norm(vector<double>& vd){
  double sum=0;
  for(int i=0;i<vd.size();i+=1){sum+=vd[i];if(vd[i]<0){cout<<"negative weight!"<<endl;}}
  for(int i=0;i<vd.size();i+=1){vd[i]/=sum;}
  return;
}//end Norm
void Lognorm(vector<double>& vd){
  double tmpd=vd[0];
  for(int i=0;i<vd.size();i+=1){if(vd[i]>tmpd){tmpd=vd[i];}}//endfor i
  for(int i=0;i<vd.size();i+=1){vd[i]-=tmpd;}//endfor i
  tmpd=0;
  for(int i=0;i<vd.size();i+=1){tmpd+=exp(vd[i]);}//endfor i
  tmpd=log(tmpd);
  for(int i=0;i<vd.size();i+=1){vd[i]-=tmpd;if(vd[i]<-200){vd[i]=-200;}}//endfor i
}//end Lognorm

class Prob{
public:
  vector<double> P;
  vector<double> LP;

  void Normalize(){
    Norm(P);
    PToLP();
  }//end Normalize

  void PToLP(){
    LP.clear();
    LP.resize(P.size());
    for(int i=0;i<P.size();i+=1){
      LP[i]=log(P[i]);
    }//endfor i
  }//end PToLP

  void LPToP(){
    P.clear();
    P.resize(LP.size());
    for(int i=0;i<LP.size();i+=1){
      P[i]=exp(LP[i]);
    }//endfor i
  }//end LPToP

};//endclass Prob


class MetricalHMM_duple{
public:
  int TPQN;
  Transcr data;

//  vector<int> nv;
  int numMetricalPos;
  int numBarJump;
  int numStates;//=numMetricalPos*numBarJump, metPos=state%numMetricalPos, barJump=state/numMetricalPos

  vector<Prob> trProb;//s_n -> s_n+1
  Prob trIniProb;
  vector<Prob> trMetProb;//s_n -> s_n+1
  Prob barJumpProb;

  vector<int> effGrids;//effGrids[i] is an allowed position on the grid
  vector<vector<int> > effGridIntervals;//effGridIntervals[i][j] is the position effGrids[j] of an allowed interval effGrids[j]->effGrids[i]

  double Sigma_t;//オンセット時刻のノイズの分散
  double lambda;//chordalIOIのscale parameter
  vector<double> secPerQN;
  vector<Prob> tempoTrProb;
  Prob tempoTrIniProb;
  int numTempoState;
  double minSecPerQN,maxSeqPerQN;
  int truncatedWidth;
  double outerLP;
  double fac_t;


  MetricalHMM_duple(){
    Init();
  }//end MetricalHMM_duple
  ~MetricalHMM_duple(){
  }//end ~MetricalHMM_duple

  void Init(){
if(printOn){cout<<"###Init###"<<endl;}

    TPQN=24;
    numMetricalPos=48;
    numBarJump=4;
    numStates=numMetricalPos*numBarJump;

    trMetProb.resize(numMetricalPos);
    for(int i=0;i<numMetricalPos;i+=1){
      trMetProb[i].P.assign(numMetricalPos,1E-10);
    }//endfor i
    barJumpProb.P.assign(numBarJump,1E-10);

    trProb.resize(numStates);
    for(int i=0;i<numStates;i+=1){
      trProb[i].P.assign(numStates,1E-10);
    }//endfor i
    trIniProb.P.assign(numStates,1E-10);

		barJumpProb.P[0]=0.996509;
		barJumpProb.P[1]=0.00300687;
		barJumpProb.P[2]=0.000472024;
		barJumpProb.P[3]=1.16481e-05;
		trMetProb[0].P[0]=0.639698;	trMetProb[0].P[1]=2.63594e-05;	trMetProb[0].P[2]=2.39631e-06;	trMetProb[0].P[3]=0.0153867;	trMetProb[0].P[4]=0.0163692;	trMetProb[0].P[5]=2.39631e-06;	trMetProb[0].P[6]=0.154013;	trMetProb[0].P[7]=2.39631e-06;	trMetProb[0].P[8]=0.00371668;	trMetProb[0].P[9]=0.00177567;	trMetProb[0].P[10]=2.39631e-06;	trMetProb[0].P[11]=2.39631e-06;	trMetProb[0].P[12]=0.111215;	trMetProb[0].P[13]=2.39631e-06;	trMetProb[0].P[14]=2.39631e-06;	trMetProb[0].P[15]=0.000265991;	trMetProb[0].P[16]=2.63594e-05;	trMetProb[0].P[17]=2.39631e-06;	trMetProb[0].P[18]=0.0100429;	trMetProb[0].P[19]=2.39631e-06;	trMetProb[0].P[20]=2.39631e-06;	trMetProb[0].P[21]=0.000841105;	trMetProb[0].P[22]=2.39631e-06;	trMetProb[0].P[23]=2.39631e-06;	trMetProb[0].P[24]=0.0375766;	trMetProb[0].P[25]=2.39631e-06;	trMetProb[0].P[26]=2.39631e-06;	trMetProb[0].P[27]=2.63594e-05;	trMetProb[0].P[28]=2.39631e-06;	trMetProb[0].P[29]=2.39631e-06;	trMetProb[0].P[30]=0.000865068;	trMetProb[0].P[31]=2.39631e-06;	trMetProb[0].P[32]=2.39631e-06;	trMetProb[0].P[33]=0.000170138;	trMetProb[0].P[34]=2.39631e-06;	trMetProb[0].P[35]=2.39631e-06;	trMetProb[0].P[36]=0.00632866;	trMetProb[0].P[37]=2.39631e-06;	trMetProb[0].P[38]=2.39631e-06;	trMetProb[0].P[39]=2.39631e-06;	trMetProb[0].P[40]=2.39631e-06;	trMetProb[0].P[41]=2.39631e-06;	trMetProb[0].P[42]=0.00134433;	trMetProb[0].P[43]=2.39631e-06;	trMetProb[0].P[44]=2.39631e-06;	trMetProb[0].P[45]=0.000242027;	trMetProb[0].P[46]=2.39631e-06;	trMetProb[0].P[47]=2.39631e-06;	
		trMetProb[1].P[0]=0.0172414;	trMetProb[1].P[1]=0.0172414;	trMetProb[1].P[2]=0.189655;	trMetProb[1].P[3]=0.0172414;	trMetProb[1].P[4]=0.0172414;	trMetProb[1].P[5]=0.0172414;	trMetProb[1].P[6]=0.0172414;	trMetProb[1].P[7]=0.0172414;	trMetProb[1].P[8]=0.0172414;	trMetProb[1].P[9]=0.0172414;	trMetProb[1].P[10]=0.0172414;	trMetProb[1].P[11]=0.0172414;	trMetProb[1].P[12]=0.0172414;	trMetProb[1].P[13]=0.0172414;	trMetProb[1].P[14]=0.0172414;	trMetProb[1].P[15]=0.0172414;	trMetProb[1].P[16]=0.0172414;	trMetProb[1].P[17]=0.0172414;	trMetProb[1].P[18]=0.0172414;	trMetProb[1].P[19]=0.0172414;	trMetProb[1].P[20]=0.0172414;	trMetProb[1].P[21]=0.0172414;	trMetProb[1].P[22]=0.0172414;	trMetProb[1].P[23]=0.0172414;	trMetProb[1].P[24]=0.0172414;	trMetProb[1].P[25]=0.0172414;	trMetProb[1].P[26]=0.0172414;	trMetProb[1].P[27]=0.0172414;	trMetProb[1].P[28]=0.0172414;	trMetProb[1].P[29]=0.0172414;	trMetProb[1].P[30]=0.0172414;	trMetProb[1].P[31]=0.0172414;	trMetProb[1].P[32]=0.0172414;	trMetProb[1].P[33]=0.0172414;	trMetProb[1].P[34]=0.0172414;	trMetProb[1].P[35]=0.0172414;	trMetProb[1].P[36]=0.0172414;	trMetProb[1].P[37]=0.0172414;	trMetProb[1].P[38]=0.0172414;	trMetProb[1].P[39]=0.0172414;	trMetProb[1].P[40]=0.0172414;	trMetProb[1].P[41]=0.0172414;	trMetProb[1].P[42]=0.0172414;	trMetProb[1].P[43]=0.0172414;	trMetProb[1].P[44]=0.0172414;	trMetProb[1].P[45]=0.0172414;	trMetProb[1].P[46]=0.0172414;	trMetProb[1].P[47]=0.0172414;	
		trMetProb[2].P[0]=0.0172414;	trMetProb[2].P[1]=0.0172414;	trMetProb[2].P[2]=0.0172414;	trMetProb[2].P[3]=0.189655;	trMetProb[2].P[4]=0.0172414;	trMetProb[2].P[5]=0.0172414;	trMetProb[2].P[6]=0.0172414;	trMetProb[2].P[7]=0.0172414;	trMetProb[2].P[8]=0.0172414;	trMetProb[2].P[9]=0.0172414;	trMetProb[2].P[10]=0.0172414;	trMetProb[2].P[11]=0.0172414;	trMetProb[2].P[12]=0.0172414;	trMetProb[2].P[13]=0.0172414;	trMetProb[2].P[14]=0.0172414;	trMetProb[2].P[15]=0.0172414;	trMetProb[2].P[16]=0.0172414;	trMetProb[2].P[17]=0.0172414;	trMetProb[2].P[18]=0.0172414;	trMetProb[2].P[19]=0.0172414;	trMetProb[2].P[20]=0.0172414;	trMetProb[2].P[21]=0.0172414;	trMetProb[2].P[22]=0.0172414;	trMetProb[2].P[23]=0.0172414;	trMetProb[2].P[24]=0.0172414;	trMetProb[2].P[25]=0.0172414;	trMetProb[2].P[26]=0.0172414;	trMetProb[2].P[27]=0.0172414;	trMetProb[2].P[28]=0.0172414;	trMetProb[2].P[29]=0.0172414;	trMetProb[2].P[30]=0.0172414;	trMetProb[2].P[31]=0.0172414;	trMetProb[2].P[32]=0.0172414;	trMetProb[2].P[33]=0.0172414;	trMetProb[2].P[34]=0.0172414;	trMetProb[2].P[35]=0.0172414;	trMetProb[2].P[36]=0.0172414;	trMetProb[2].P[37]=0.0172414;	trMetProb[2].P[38]=0.0172414;	trMetProb[2].P[39]=0.0172414;	trMetProb[2].P[40]=0.0172414;	trMetProb[2].P[41]=0.0172414;	trMetProb[2].P[42]=0.0172414;	trMetProb[2].P[43]=0.0172414;	trMetProb[2].P[44]=0.0172414;	trMetProb[2].P[45]=0.0172414;	trMetProb[2].P[46]=0.0172414;	trMetProb[2].P[47]=0.0172414;	
		trMetProb[3].P[0]=0.000143308;	trMetProb[3].P[1]=0.000143308;	trMetProb[3].P[2]=0.000143308;	trMetProb[3].P[3]=0.0760963;	trMetProb[3].P[4]=0.00730868;	trMetProb[3].P[5]=0.000143308;	trMetProb[3].P[6]=0.90728;	trMetProb[3].P[7]=0.000143308;	trMetProb[3].P[8]=0.000143308;	trMetProb[3].P[9]=0.000143308;	trMetProb[3].P[10]=0.000143308;	trMetProb[3].P[11]=0.000143308;	trMetProb[3].P[12]=0.00300946;	trMetProb[3].P[13]=0.000143308;	trMetProb[3].P[14]=0.000143308;	trMetProb[3].P[15]=0.000143308;	trMetProb[3].P[16]=0.000143308;	trMetProb[3].P[17]=0.000143308;	trMetProb[3].P[18]=0.000143308;	trMetProb[3].P[19]=0.000143308;	trMetProb[3].P[20]=0.000143308;	trMetProb[3].P[21]=0.000143308;	trMetProb[3].P[22]=0.000143308;	trMetProb[3].P[23]=0.000143308;	trMetProb[3].P[24]=0.000143308;	trMetProb[3].P[25]=0.000143308;	trMetProb[3].P[26]=0.000143308;	trMetProb[3].P[27]=0.000143308;	trMetProb[3].P[28]=0.000143308;	trMetProb[3].P[29]=0.000143308;	trMetProb[3].P[30]=0.000143308;	trMetProb[3].P[31]=0.000143308;	trMetProb[3].P[32]=0.000143308;	trMetProb[3].P[33]=0.000143308;	trMetProb[3].P[34]=0.000143308;	trMetProb[3].P[35]=0.000143308;	trMetProb[3].P[36]=0.000143308;	trMetProb[3].P[37]=0.000143308;	trMetProb[3].P[38]=0.000143308;	trMetProb[3].P[39]=0.000143308;	trMetProb[3].P[40]=0.000143308;	trMetProb[3].P[41]=0.000143308;	trMetProb[3].P[42]=0.000143308;	trMetProb[3].P[43]=0.000143308;	trMetProb[3].P[44]=0.000143308;	trMetProb[3].P[45]=0.000143308;	trMetProb[3].P[46]=0.000143308;	trMetProb[3].P[47]=0.000143308;	
		trMetProb[4].P[0]=0.000128238;	trMetProb[4].P[1]=0.000128238;	trMetProb[4].P[2]=0.000128238;	trMetProb[4].P[3]=0.000128238;	trMetProb[4].P[4]=0.110413;	trMetProb[4].P[5]=0.00141062;	trMetProb[4].P[6]=0.0873301;	trMetProb[4].P[7]=0.000128238;	trMetProb[4].P[8]=0.795204;	trMetProb[4].P[9]=0.000128238;	trMetProb[4].P[10]=0.000128238;	trMetProb[4].P[11]=0.000128238;	trMetProb[4].P[12]=0.000128238;	trMetProb[4].P[13]=0.000128238;	trMetProb[4].P[14]=0.000128238;	trMetProb[4].P[15]=0.000128238;	trMetProb[4].P[16]=0.000128238;	trMetProb[4].P[17]=0.000128238;	trMetProb[4].P[18]=0.000128238;	trMetProb[4].P[19]=0.000128238;	trMetProb[4].P[20]=0.000128238;	trMetProb[4].P[21]=0.000128238;	trMetProb[4].P[22]=0.000128238;	trMetProb[4].P[23]=0.000128238;	trMetProb[4].P[24]=0.000128238;	trMetProb[4].P[25]=0.000128238;	trMetProb[4].P[26]=0.000128238;	trMetProb[4].P[27]=0.000128238;	trMetProb[4].P[28]=0.000128238;	trMetProb[4].P[29]=0.000128238;	trMetProb[4].P[30]=0.000128238;	trMetProb[4].P[31]=0.000128238;	trMetProb[4].P[32]=0.000128238;	trMetProb[4].P[33]=0.000128238;	trMetProb[4].P[34]=0.000128238;	trMetProb[4].P[35]=0.000128238;	trMetProb[4].P[36]=0.000128238;	trMetProb[4].P[37]=0.000128238;	trMetProb[4].P[38]=0.000128238;	trMetProb[4].P[39]=0.000128238;	trMetProb[4].P[40]=0.000128238;	trMetProb[4].P[41]=0.000128238;	trMetProb[4].P[42]=0.000128238;	trMetProb[4].P[43]=0.000128238;	trMetProb[4].P[44]=0.000128238;	trMetProb[4].P[45]=0.000128238;	trMetProb[4].P[46]=0.000128238;	trMetProb[4].P[47]=0.000128238;	
		trMetProb[5].P[0]=0.0172414;	trMetProb[5].P[1]=0.0172414;	trMetProb[5].P[2]=0.0172414;	trMetProb[5].P[3]=0.0172414;	trMetProb[5].P[4]=0.0172414;	trMetProb[5].P[5]=0.0172414;	trMetProb[5].P[6]=0.189655;	trMetProb[5].P[7]=0.0172414;	trMetProb[5].P[8]=0.0172414;	trMetProb[5].P[9]=0.0172414;	trMetProb[5].P[10]=0.0172414;	trMetProb[5].P[11]=0.0172414;	trMetProb[5].P[12]=0.0172414;	trMetProb[5].P[13]=0.0172414;	trMetProb[5].P[14]=0.0172414;	trMetProb[5].P[15]=0.0172414;	trMetProb[5].P[16]=0.0172414;	trMetProb[5].P[17]=0.0172414;	trMetProb[5].P[18]=0.0172414;	trMetProb[5].P[19]=0.0172414;	trMetProb[5].P[20]=0.0172414;	trMetProb[5].P[21]=0.0172414;	trMetProb[5].P[22]=0.0172414;	trMetProb[5].P[23]=0.0172414;	trMetProb[5].P[24]=0.0172414;	trMetProb[5].P[25]=0.0172414;	trMetProb[5].P[26]=0.0172414;	trMetProb[5].P[27]=0.0172414;	trMetProb[5].P[28]=0.0172414;	trMetProb[5].P[29]=0.0172414;	trMetProb[5].P[30]=0.0172414;	trMetProb[5].P[31]=0.0172414;	trMetProb[5].P[32]=0.0172414;	trMetProb[5].P[33]=0.0172414;	trMetProb[5].P[34]=0.0172414;	trMetProb[5].P[35]=0.0172414;	trMetProb[5].P[36]=0.0172414;	trMetProb[5].P[37]=0.0172414;	trMetProb[5].P[38]=0.0172414;	trMetProb[5].P[39]=0.0172414;	trMetProb[5].P[40]=0.0172414;	trMetProb[5].P[41]=0.0172414;	trMetProb[5].P[42]=0.0172414;	trMetProb[5].P[43]=0.0172414;	trMetProb[5].P[44]=0.0172414;	trMetProb[5].P[45]=0.0172414;	trMetProb[5].P[46]=0.0172414;	trMetProb[5].P[47]=0.0172414;	
		trMetProb[6].P[0]=0.000125074;	trMetProb[6].P[1]=1.13704e-05;	trMetProb[6].P[2]=1.13704e-05;	trMetProb[6].P[3]=1.13704e-05;	trMetProb[6].P[4]=1.13704e-05;	trMetProb[6].P[5]=1.13704e-05;	trMetProb[6].P[6]=0.189441;	trMetProb[6].P[7]=1.13704e-05;	trMetProb[6].P[8]=0.0103584;	trMetProb[6].P[9]=0.0793764;	trMetProb[6].P[10]=1.13704e-05;	trMetProb[6].P[11]=1.13704e-05;	trMetProb[6].P[12]=0.719414;	trMetProb[6].P[13]=1.13704e-05;	trMetProb[6].P[14]=1.13704e-05;	trMetProb[6].P[15]=1.13704e-05;	trMetProb[6].P[16]=1.13704e-05;	trMetProb[6].P[17]=1.13704e-05;	trMetProb[6].P[18]=0.000466185;	trMetProb[6].P[19]=1.13704e-05;	trMetProb[6].P[20]=1.13704e-05;	trMetProb[6].P[21]=1.13704e-05;	trMetProb[6].P[22]=1.13704e-05;	trMetProb[6].P[23]=1.13704e-05;	trMetProb[6].P[24]=1.13704e-05;	trMetProb[6].P[25]=1.13704e-05;	trMetProb[6].P[26]=1.13704e-05;	trMetProb[6].P[27]=1.13704e-05;	trMetProb[6].P[28]=1.13704e-05;	trMetProb[6].P[29]=1.13704e-05;	trMetProb[6].P[30]=0.000125074;	trMetProb[6].P[31]=1.13704e-05;	trMetProb[6].P[32]=1.13704e-05;	trMetProb[6].P[33]=1.13704e-05;	trMetProb[6].P[34]=1.13704e-05;	trMetProb[6].P[35]=1.13704e-05;	trMetProb[6].P[36]=1.13704e-05;	trMetProb[6].P[37]=1.13704e-05;	trMetProb[6].P[38]=1.13704e-05;	trMetProb[6].P[39]=1.13704e-05;	trMetProb[6].P[40]=1.13704e-05;	trMetProb[6].P[41]=1.13704e-05;	trMetProb[6].P[42]=0.000238777;	trMetProb[6].P[43]=1.13704e-05;	trMetProb[6].P[44]=1.13704e-05;	trMetProb[6].P[45]=1.13704e-05;	trMetProb[6].P[46]=1.13704e-05;	trMetProb[6].P[47]=1.13704e-05;	
		trMetProb[7].P[0]=0.0208333;	trMetProb[7].P[1]=0.0208333;	trMetProb[7].P[2]=0.0208333;	trMetProb[7].P[3]=0.0208333;	trMetProb[7].P[4]=0.0208333;	trMetProb[7].P[5]=0.0208333;	trMetProb[7].P[6]=0.0208333;	trMetProb[7].P[7]=0.0208333;	trMetProb[7].P[8]=0.0208333;	trMetProb[7].P[9]=0.0208333;	trMetProb[7].P[10]=0.0208333;	trMetProb[7].P[11]=0.0208333;	trMetProb[7].P[12]=0.0208333;	trMetProb[7].P[13]=0.0208333;	trMetProb[7].P[14]=0.0208333;	trMetProb[7].P[15]=0.0208333;	trMetProb[7].P[16]=0.0208333;	trMetProb[7].P[17]=0.0208333;	trMetProb[7].P[18]=0.0208333;	trMetProb[7].P[19]=0.0208333;	trMetProb[7].P[20]=0.0208333;	trMetProb[7].P[21]=0.0208333;	trMetProb[7].P[22]=0.0208333;	trMetProb[7].P[23]=0.0208333;	trMetProb[7].P[24]=0.0208333;	trMetProb[7].P[25]=0.0208333;	trMetProb[7].P[26]=0.0208333;	trMetProb[7].P[27]=0.0208333;	trMetProb[7].P[28]=0.0208333;	trMetProb[7].P[29]=0.0208333;	trMetProb[7].P[30]=0.0208333;	trMetProb[7].P[31]=0.0208333;	trMetProb[7].P[32]=0.0208333;	trMetProb[7].P[33]=0.0208333;	trMetProb[7].P[34]=0.0208333;	trMetProb[7].P[35]=0.0208333;	trMetProb[7].P[36]=0.0208333;	trMetProb[7].P[37]=0.0208333;	trMetProb[7].P[38]=0.0208333;	trMetProb[7].P[39]=0.0208333;	trMetProb[7].P[40]=0.0208333;	trMetProb[7].P[41]=0.0208333;	trMetProb[7].P[42]=0.0208333;	trMetProb[7].P[43]=0.0208333;	trMetProb[7].P[44]=0.0208333;	trMetProb[7].P[45]=0.0208333;	trMetProb[7].P[46]=0.0208333;	trMetProb[7].P[47]=0.0208333;	
		trMetProb[8].P[0]=0.000104406;	trMetProb[8].P[1]=0.000104406;	trMetProb[8].P[2]=0.000104406;	trMetProb[8].P[3]=0.000104406;	trMetProb[8].P[4]=0.000104406;	trMetProb[8].P[5]=0.000104406;	trMetProb[8].P[6]=0.000104406;	trMetProb[8].P[7]=0.000104406;	trMetProb[8].P[8]=0.0898935;	trMetProb[8].P[9]=0.0053247;	trMetProb[8].P[10]=0.0053247;	trMetProb[8].P[11]=0.000104406;	trMetProb[8].P[12]=0.749739;	trMetProb[8].P[13]=0.000104406;	trMetProb[8].P[14]=0.000104406;	trMetProb[8].P[15]=0.000104406;	trMetProb[8].P[16]=0.145229;	trMetProb[8].P[17]=0.000104406;	trMetProb[8].P[18]=0.000104406;	trMetProb[8].P[19]=0.000104406;	trMetProb[8].P[20]=0.000104406;	trMetProb[8].P[21]=0.000104406;	trMetProb[8].P[22]=0.000104406;	trMetProb[8].P[23]=0.000104406;	trMetProb[8].P[24]=0.000104406;	trMetProb[8].P[25]=0.000104406;	trMetProb[8].P[26]=0.000104406;	trMetProb[8].P[27]=0.000104406;	trMetProb[8].P[28]=0.000104406;	trMetProb[8].P[29]=0.000104406;	trMetProb[8].P[30]=0.000104406;	trMetProb[8].P[31]=0.000104406;	trMetProb[8].P[32]=0.000104406;	trMetProb[8].P[33]=0.000104406;	trMetProb[8].P[34]=0.000104406;	trMetProb[8].P[35]=0.000104406;	trMetProb[8].P[36]=0.000104406;	trMetProb[8].P[37]=0.000104406;	trMetProb[8].P[38]=0.000104406;	trMetProb[8].P[39]=0.000104406;	trMetProb[8].P[40]=0.000104406;	trMetProb[8].P[41]=0.000104406;	trMetProb[8].P[42]=0.000104406;	trMetProb[8].P[43]=0.000104406;	trMetProb[8].P[44]=0.000104406;	trMetProb[8].P[45]=0.000104406;	trMetProb[8].P[46]=0.000104406;	trMetProb[8].P[47]=0.000104406;	
		trMetProb[9].P[0]=0.000108483;	trMetProb[9].P[1]=0.000108483;	trMetProb[9].P[2]=0.000108483;	trMetProb[9].P[3]=0.000108483;	trMetProb[9].P[4]=0.000108483;	trMetProb[9].P[5]=0.000108483;	trMetProb[9].P[6]=0.000108483;	trMetProb[9].P[7]=0.000108483;	trMetProb[9].P[8]=0.000108483;	trMetProb[9].P[9]=0.156325;	trMetProb[9].P[10]=0.0120417;	trMetProb[9].P[11]=0.000108483;	trMetProb[9].P[12]=0.826752;	trMetProb[9].P[13]=0.000108483;	trMetProb[9].P[14]=0.000108483;	trMetProb[9].P[15]=0.000108483;	trMetProb[9].P[16]=0.000108483;	trMetProb[9].P[17]=0.000108483;	trMetProb[9].P[18]=0.000108483;	trMetProb[9].P[19]=0.000108483;	trMetProb[9].P[20]=0.000108483;	trMetProb[9].P[21]=0.000108483;	trMetProb[9].P[22]=0.000108483;	trMetProb[9].P[23]=0.000108483;	trMetProb[9].P[24]=0.000108483;	trMetProb[9].P[25]=0.000108483;	trMetProb[9].P[26]=0.000108483;	trMetProb[9].P[27]=0.000108483;	trMetProb[9].P[28]=0.000108483;	trMetProb[9].P[29]=0.000108483;	trMetProb[9].P[30]=0.000108483;	trMetProb[9].P[31]=0.000108483;	trMetProb[9].P[32]=0.000108483;	trMetProb[9].P[33]=0.000108483;	trMetProb[9].P[34]=0.000108483;	trMetProb[9].P[35]=0.000108483;	trMetProb[9].P[36]=0.000108483;	trMetProb[9].P[37]=0.000108483;	trMetProb[9].P[38]=0.000108483;	trMetProb[9].P[39]=0.000108483;	trMetProb[9].P[40]=0.000108483;	trMetProb[9].P[41]=0.000108483;	trMetProb[9].P[42]=0.000108483;	trMetProb[9].P[43]=0.000108483;	trMetProb[9].P[44]=0.000108483;	trMetProb[9].P[45]=0.000108483;	trMetProb[9].P[46]=0.000108483;	trMetProb[9].P[47]=0.000108483;	
		trMetProb[10].P[0]=0.00480769;	trMetProb[10].P[1]=0.00480769;	trMetProb[10].P[2]=0.00480769;	trMetProb[10].P[3]=0.00480769;	trMetProb[10].P[4]=0.00480769;	trMetProb[10].P[5]=0.00480769;	trMetProb[10].P[6]=0.00480769;	trMetProb[10].P[7]=0.00480769;	trMetProb[10].P[8]=0.00480769;	trMetProb[10].P[9]=0.00480769;	trMetProb[10].P[10]=0.00480769;	trMetProb[10].P[11]=0.533654;	trMetProb[10].P[12]=0.245192;	trMetProb[10].P[13]=0.00480769;	trMetProb[10].P[14]=0.00480769;	trMetProb[10].P[15]=0.00480769;	trMetProb[10].P[16]=0.00480769;	trMetProb[10].P[17]=0.00480769;	trMetProb[10].P[18]=0.00480769;	trMetProb[10].P[19]=0.00480769;	trMetProb[10].P[20]=0.00480769;	trMetProb[10].P[21]=0.00480769;	trMetProb[10].P[22]=0.00480769;	trMetProb[10].P[23]=0.00480769;	trMetProb[10].P[24]=0.00480769;	trMetProb[10].P[25]=0.00480769;	trMetProb[10].P[26]=0.00480769;	trMetProb[10].P[27]=0.00480769;	trMetProb[10].P[28]=0.00480769;	trMetProb[10].P[29]=0.00480769;	trMetProb[10].P[30]=0.00480769;	trMetProb[10].P[31]=0.00480769;	trMetProb[10].P[32]=0.00480769;	trMetProb[10].P[33]=0.00480769;	trMetProb[10].P[34]=0.00480769;	trMetProb[10].P[35]=0.00480769;	trMetProb[10].P[36]=0.00480769;	trMetProb[10].P[37]=0.00480769;	trMetProb[10].P[38]=0.00480769;	trMetProb[10].P[39]=0.00480769;	trMetProb[10].P[40]=0.00480769;	trMetProb[10].P[41]=0.00480769;	trMetProb[10].P[42]=0.00480769;	trMetProb[10].P[43]=0.00480769;	trMetProb[10].P[44]=0.00480769;	trMetProb[10].P[45]=0.00480769;	trMetProb[10].P[46]=0.00480769;	trMetProb[10].P[47]=0.00480769;	
		trMetProb[11].P[0]=0.00632911;	trMetProb[11].P[1]=0.00632911;	trMetProb[11].P[2]=0.00632911;	trMetProb[11].P[3]=0.00632911;	trMetProb[11].P[4]=0.00632911;	trMetProb[11].P[5]=0.00632911;	trMetProb[11].P[6]=0.00632911;	trMetProb[11].P[7]=0.00632911;	trMetProb[11].P[8]=0.00632911;	trMetProb[11].P[9]=0.00632911;	trMetProb[11].P[10]=0.00632911;	trMetProb[11].P[11]=0.00632911;	trMetProb[11].P[12]=0.702532;	trMetProb[11].P[13]=0.00632911;	trMetProb[11].P[14]=0.00632911;	trMetProb[11].P[15]=0.00632911;	trMetProb[11].P[16]=0.00632911;	trMetProb[11].P[17]=0.00632911;	trMetProb[11].P[18]=0.00632911;	trMetProb[11].P[19]=0.00632911;	trMetProb[11].P[20]=0.00632911;	trMetProb[11].P[21]=0.00632911;	trMetProb[11].P[22]=0.00632911;	trMetProb[11].P[23]=0.00632911;	trMetProb[11].P[24]=0.00632911;	trMetProb[11].P[25]=0.00632911;	trMetProb[11].P[26]=0.00632911;	trMetProb[11].P[27]=0.00632911;	trMetProb[11].P[28]=0.00632911;	trMetProb[11].P[29]=0.00632911;	trMetProb[11].P[30]=0.00632911;	trMetProb[11].P[31]=0.00632911;	trMetProb[11].P[32]=0.00632911;	trMetProb[11].P[33]=0.00632911;	trMetProb[11].P[34]=0.00632911;	trMetProb[11].P[35]=0.00632911;	trMetProb[11].P[36]=0.00632911;	trMetProb[11].P[37]=0.00632911;	trMetProb[11].P[38]=0.00632911;	trMetProb[11].P[39]=0.00632911;	trMetProb[11].P[40]=0.00632911;	trMetProb[11].P[41]=0.00632911;	trMetProb[11].P[42]=0.00632911;	trMetProb[11].P[43]=0.00632911;	trMetProb[11].P[44]=0.00632911;	trMetProb[11].P[45]=0.00632911;	trMetProb[11].P[46]=0.00632911;	trMetProb[11].P[47]=0.00632911;	
		trMetProb[12].P[0]=0.0018891;	trMetProb[12].P[1]=4.48716e-06;	trMetProb[12].P[2]=4.48716e-06;	trMetProb[12].P[3]=4.48716e-06;	trMetProb[12].P[4]=4.48716e-06;	trMetProb[12].P[5]=4.48716e-06;	trMetProb[12].P[6]=4.93588e-05;	trMetProb[12].P[7]=4.48716e-06;	trMetProb[12].P[8]=4.48716e-06;	trMetProb[12].P[9]=4.48716e-06;	trMetProb[12].P[10]=4.48716e-06;	trMetProb[12].P[11]=4.48716e-06;	trMetProb[12].P[12]=0.438894;	trMetProb[12].P[13]=4.93588e-05;	trMetProb[12].P[14]=0.000183974;	trMetProb[12].P[15]=0.03303;	trMetProb[12].P[16]=0.0355428;	trMetProb[12].P[17]=4.48716e-06;	trMetProb[12].P[18]=0.306208;	trMetProb[12].P[19]=4.48716e-06;	trMetProb[12].P[20]=4.48716e-06;	trMetProb[12].P[21]=0.00247243;	trMetProb[12].P[22]=4.48716e-06;	trMetProb[12].P[23]=4.48716e-06;	trMetProb[12].P[24]=0.177876;	trMetProb[12].P[25]=4.48716e-06;	trMetProb[12].P[26]=4.48716e-06;	trMetProb[12].P[27]=4.93588e-05;	trMetProb[12].P[28]=4.48716e-06;	trMetProb[12].P[29]=4.48716e-06;	trMetProb[12].P[30]=0.000318589;	trMetProb[12].P[31]=4.48716e-06;	trMetProb[12].P[32]=4.48716e-06;	trMetProb[12].P[33]=4.48716e-06;	trMetProb[12].P[34]=4.48716e-06;	trMetProb[12].P[35]=4.48716e-06;	trMetProb[12].P[36]=0.00296601;	trMetProb[12].P[37]=4.48716e-06;	trMetProb[12].P[38]=4.48716e-06;	trMetProb[12].P[39]=4.93588e-05;	trMetProb[12].P[40]=4.48716e-06;	trMetProb[12].P[41]=4.48716e-06;	trMetProb[12].P[42]=0.000273717;	trMetProb[12].P[43]=4.48716e-06;	trMetProb[12].P[44]=4.48716e-06;	trMetProb[12].P[45]=4.48716e-06;	trMetProb[12].P[46]=4.48716e-06;	trMetProb[12].P[47]=4.48716e-06;	
		trMetProb[13].P[0]=0.0172414;	trMetProb[13].P[1]=0.0172414;	trMetProb[13].P[2]=0.0172414;	trMetProb[13].P[3]=0.0172414;	trMetProb[13].P[4]=0.0172414;	trMetProb[13].P[5]=0.0172414;	trMetProb[13].P[6]=0.0172414;	trMetProb[13].P[7]=0.0172414;	trMetProb[13].P[8]=0.0172414;	trMetProb[13].P[9]=0.0172414;	trMetProb[13].P[10]=0.0172414;	trMetProb[13].P[11]=0.0172414;	trMetProb[13].P[12]=0.0172414;	trMetProb[13].P[13]=0.0172414;	trMetProb[13].P[14]=0.189655;	trMetProb[13].P[15]=0.0172414;	trMetProb[13].P[16]=0.0172414;	trMetProb[13].P[17]=0.0172414;	trMetProb[13].P[18]=0.0172414;	trMetProb[13].P[19]=0.0172414;	trMetProb[13].P[20]=0.0172414;	trMetProb[13].P[21]=0.0172414;	trMetProb[13].P[22]=0.0172414;	trMetProb[13].P[23]=0.0172414;	trMetProb[13].P[24]=0.0172414;	trMetProb[13].P[25]=0.0172414;	trMetProb[13].P[26]=0.0172414;	trMetProb[13].P[27]=0.0172414;	trMetProb[13].P[28]=0.0172414;	trMetProb[13].P[29]=0.0172414;	trMetProb[13].P[30]=0.0172414;	trMetProb[13].P[31]=0.0172414;	trMetProb[13].P[32]=0.0172414;	trMetProb[13].P[33]=0.0172414;	trMetProb[13].P[34]=0.0172414;	trMetProb[13].P[35]=0.0172414;	trMetProb[13].P[36]=0.0172414;	trMetProb[13].P[37]=0.0172414;	trMetProb[13].P[38]=0.0172414;	trMetProb[13].P[39]=0.0172414;	trMetProb[13].P[40]=0.0172414;	trMetProb[13].P[41]=0.0172414;	trMetProb[13].P[42]=0.0172414;	trMetProb[13].P[43]=0.0172414;	trMetProb[13].P[44]=0.0172414;	trMetProb[13].P[45]=0.0172414;	trMetProb[13].P[46]=0.0172414;	trMetProb[13].P[47]=0.0172414;	
		trMetProb[14].P[0]=0.0102041;	trMetProb[14].P[1]=0.0102041;	trMetProb[14].P[2]=0.0102041;	trMetProb[14].P[3]=0.0102041;	trMetProb[14].P[4]=0.0102041;	trMetProb[14].P[5]=0.0102041;	trMetProb[14].P[6]=0.0102041;	trMetProb[14].P[7]=0.0102041;	trMetProb[14].P[8]=0.0102041;	trMetProb[14].P[9]=0.0102041;	trMetProb[14].P[10]=0.0102041;	trMetProb[14].P[11]=0.0102041;	trMetProb[14].P[12]=0.0102041;	trMetProb[14].P[13]=0.0102041;	trMetProb[14].P[14]=0.0102041;	trMetProb[14].P[15]=0.112245;	trMetProb[14].P[16]=0.418367;	trMetProb[14].P[17]=0.0102041;	trMetProb[14].P[18]=0.0102041;	trMetProb[14].P[19]=0.0102041;	trMetProb[14].P[20]=0.0102041;	trMetProb[14].P[21]=0.0102041;	trMetProb[14].P[22]=0.0102041;	trMetProb[14].P[23]=0.0102041;	trMetProb[14].P[24]=0.0102041;	trMetProb[14].P[25]=0.0102041;	trMetProb[14].P[26]=0.0102041;	trMetProb[14].P[27]=0.0102041;	trMetProb[14].P[28]=0.0102041;	trMetProb[14].P[29]=0.0102041;	trMetProb[14].P[30]=0.0102041;	trMetProb[14].P[31]=0.0102041;	trMetProb[14].P[32]=0.0102041;	trMetProb[14].P[33]=0.0102041;	trMetProb[14].P[34]=0.0102041;	trMetProb[14].P[35]=0.0102041;	trMetProb[14].P[36]=0.0102041;	trMetProb[14].P[37]=0.0102041;	trMetProb[14].P[38]=0.0102041;	trMetProb[14].P[39]=0.0102041;	trMetProb[14].P[40]=0.0102041;	trMetProb[14].P[41]=0.0102041;	trMetProb[14].P[42]=0.0102041;	trMetProb[14].P[43]=0.0102041;	trMetProb[14].P[44]=0.0102041;	trMetProb[14].P[45]=0.0102041;	trMetProb[14].P[46]=0.0102041;	trMetProb[14].P[47]=0.0102041;	
		trMetProb[15].P[0]=0.000123335;	trMetProb[15].P[1]=0.000123335;	trMetProb[15].P[2]=0.000123335;	trMetProb[15].P[3]=0.000123335;	trMetProb[15].P[4]=0.000123335;	trMetProb[15].P[5]=0.000123335;	trMetProb[15].P[6]=0.000123335;	trMetProb[15].P[7]=0.000123335;	trMetProb[15].P[8]=0.000123335;	trMetProb[15].P[9]=0.000123335;	trMetProb[15].P[10]=0.000123335;	trMetProb[15].P[11]=0.000123335;	trMetProb[15].P[12]=0.000123335;	trMetProb[15].P[13]=0.000123335;	trMetProb[15].P[14]=0.000123335;	trMetProb[15].P[15]=0.0839911;	trMetProb[15].P[16]=0.0136902;	trMetProb[15].P[17]=0.000123335;	trMetProb[15].P[18]=0.896769;	trMetProb[15].P[19]=0.000123335;	trMetProb[15].P[20]=0.000123335;	trMetProb[15].P[21]=0.000123335;	trMetProb[15].P[22]=0.000123335;	trMetProb[15].P[23]=0.000123335;	trMetProb[15].P[24]=0.000123335;	trMetProb[15].P[25]=0.000123335;	trMetProb[15].P[26]=0.000123335;	trMetProb[15].P[27]=0.000123335;	trMetProb[15].P[28]=0.000123335;	trMetProb[15].P[29]=0.000123335;	trMetProb[15].P[30]=0.000123335;	trMetProb[15].P[31]=0.000123335;	trMetProb[15].P[32]=0.000123335;	trMetProb[15].P[33]=0.000123335;	trMetProb[15].P[34]=0.000123335;	trMetProb[15].P[35]=0.000123335;	trMetProb[15].P[36]=0.000123335;	trMetProb[15].P[37]=0.000123335;	trMetProb[15].P[38]=0.000123335;	trMetProb[15].P[39]=0.000123335;	trMetProb[15].P[40]=0.000123335;	trMetProb[15].P[41]=0.000123335;	trMetProb[15].P[42]=0.000123335;	trMetProb[15].P[43]=0.000123335;	trMetProb[15].P[44]=0.000123335;	trMetProb[15].P[45]=0.000123335;	trMetProb[15].P[46]=0.000123335;	trMetProb[15].P[47]=0.000123335;	
		trMetProb[16].P[0]=9.56206e-05;	trMetProb[16].P[1]=9.56206e-05;	trMetProb[16].P[2]=9.56206e-05;	trMetProb[16].P[3]=9.56206e-05;	trMetProb[16].P[4]=9.56206e-05;	trMetProb[16].P[5]=9.56206e-05;	trMetProb[16].P[6]=9.56206e-05;	trMetProb[16].P[7]=9.56206e-05;	trMetProb[16].P[8]=9.56206e-05;	trMetProb[16].P[9]=9.56206e-05;	trMetProb[16].P[10]=9.56206e-05;	trMetProb[16].P[11]=9.56206e-05;	trMetProb[16].P[12]=9.56206e-05;	trMetProb[16].P[13]=9.56206e-05;	trMetProb[16].P[14]=9.56206e-05;	trMetProb[16].P[15]=9.56206e-05;	trMetProb[16].P[16]=0.089979;	trMetProb[16].P[17]=0.00296424;	trMetProb[16].P[18]=0.117709;	trMetProb[16].P[19]=9.56206e-05;	trMetProb[16].P[20]=0.648403;	trMetProb[16].P[21]=9.56206e-05;	trMetProb[16].P[22]=9.56206e-05;	trMetProb[16].P[23]=9.56206e-05;	trMetProb[16].P[24]=0.134921;	trMetProb[16].P[25]=9.56206e-05;	trMetProb[16].P[26]=9.56206e-05;	trMetProb[16].P[27]=9.56206e-05;	trMetProb[16].P[28]=9.56206e-05;	trMetProb[16].P[29]=9.56206e-05;	trMetProb[16].P[30]=0.00105183;	trMetProb[16].P[31]=9.56206e-05;	trMetProb[16].P[32]=0.00105183;	trMetProb[16].P[33]=9.56206e-05;	trMetProb[16].P[34]=9.56206e-05;	trMetProb[16].P[35]=9.56206e-05;	trMetProb[16].P[36]=9.56206e-05;	trMetProb[16].P[37]=9.56206e-05;	trMetProb[16].P[38]=9.56206e-05;	trMetProb[16].P[39]=9.56206e-05;	trMetProb[16].P[40]=9.56206e-05;	trMetProb[16].P[41]=9.56206e-05;	trMetProb[16].P[42]=9.56206e-05;	trMetProb[16].P[43]=9.56206e-05;	trMetProb[16].P[44]=9.56206e-05;	trMetProb[16].P[45]=9.56206e-05;	trMetProb[16].P[46]=9.56206e-05;	trMetProb[16].P[47]=9.56206e-05;	
		trMetProb[17].P[0]=0.0128205;	trMetProb[17].P[1]=0.0128205;	trMetProb[17].P[2]=0.0128205;	trMetProb[17].P[3]=0.0128205;	trMetProb[17].P[4]=0.0128205;	trMetProb[17].P[5]=0.0128205;	trMetProb[17].P[6]=0.0128205;	trMetProb[17].P[7]=0.0128205;	trMetProb[17].P[8]=0.0128205;	trMetProb[17].P[9]=0.0128205;	trMetProb[17].P[10]=0.0128205;	trMetProb[17].P[11]=0.0128205;	trMetProb[17].P[12]=0.0128205;	trMetProb[17].P[13]=0.0128205;	trMetProb[17].P[14]=0.0128205;	trMetProb[17].P[15]=0.0128205;	trMetProb[17].P[16]=0.0128205;	trMetProb[17].P[17]=0.0128205;	trMetProb[17].P[18]=0.397436;	trMetProb[17].P[19]=0.0128205;	trMetProb[17].P[20]=0.0128205;	trMetProb[17].P[21]=0.0128205;	trMetProb[17].P[22]=0.0128205;	trMetProb[17].P[23]=0.0128205;	trMetProb[17].P[24]=0.0128205;	trMetProb[17].P[25]=0.0128205;	trMetProb[17].P[26]=0.0128205;	trMetProb[17].P[27]=0.0128205;	trMetProb[17].P[28]=0.0128205;	trMetProb[17].P[29]=0.0128205;	trMetProb[17].P[30]=0.0128205;	trMetProb[17].P[31]=0.0128205;	trMetProb[17].P[32]=0.0128205;	trMetProb[17].P[33]=0.0128205;	trMetProb[17].P[34]=0.0128205;	trMetProb[17].P[35]=0.0128205;	trMetProb[17].P[36]=0.0128205;	trMetProb[17].P[37]=0.0128205;	trMetProb[17].P[38]=0.0128205;	trMetProb[17].P[39]=0.0128205;	trMetProb[17].P[40]=0.0128205;	trMetProb[17].P[41]=0.0128205;	trMetProb[17].P[42]=0.0128205;	trMetProb[17].P[43]=0.0128205;	trMetProb[17].P[44]=0.0128205;	trMetProb[17].P[45]=0.0128205;	trMetProb[17].P[46]=0.0128205;	trMetProb[17].P[47]=0.0128205;	
		trMetProb[18].P[0]=0.00199282;	trMetProb[18].P[1]=9.0173e-06;	trMetProb[18].P[2]=9.0173e-06;	trMetProb[18].P[3]=9.0173e-06;	trMetProb[18].P[4]=9.0173e-06;	trMetProb[18].P[5]=9.0173e-06;	trMetProb[18].P[6]=9.0173e-06;	trMetProb[18].P[7]=9.0173e-06;	trMetProb[18].P[8]=9.0173e-06;	trMetProb[18].P[9]=9.0173e-06;	trMetProb[18].P[10]=9.0173e-06;	trMetProb[18].P[11]=9.0173e-06;	trMetProb[18].P[12]=9.0173e-06;	trMetProb[18].P[13]=9.0173e-06;	trMetProb[18].P[14]=9.0173e-06;	trMetProb[18].P[15]=9.0173e-06;	trMetProb[18].P[16]=9.0173e-06;	trMetProb[18].P[17]=9.0173e-06;	trMetProb[18].P[18]=0.267462;	trMetProb[18].P[19]=9.0173e-06;	trMetProb[18].P[20]=0.0118217;	trMetProb[18].P[21]=0.0826976;	trMetProb[18].P[22]=9.0173e-06;	trMetProb[18].P[23]=9.0173e-06;	trMetProb[18].P[24]=0.635007;	trMetProb[18].P[25]=9.0173e-06;	trMetProb[18].P[26]=9.0173e-06;	trMetProb[18].P[27]=9.91902e-05;	trMetProb[18].P[28]=9.0173e-06;	trMetProb[18].P[29]=9.0173e-06;	trMetProb[18].P[30]=0.000550055;	trMetProb[18].P[31]=9.0173e-06;	trMetProb[18].P[32]=9.0173e-06;	trMetProb[18].P[33]=9.0173e-06;	trMetProb[18].P[34]=9.0173e-06;	trMetProb[18].P[35]=9.0173e-06;	trMetProb[18].P[36]=9.0173e-06;	trMetProb[18].P[37]=9.0173e-06;	trMetProb[18].P[38]=9.0173e-06;	trMetProb[18].P[39]=9.0173e-06;	trMetProb[18].P[40]=9.0173e-06;	trMetProb[18].P[41]=9.0173e-06;	trMetProb[18].P[42]=9.0173e-06;	trMetProb[18].P[43]=9.0173e-06;	trMetProb[18].P[44]=9.0173e-06;	trMetProb[18].P[45]=9.0173e-06;	trMetProb[18].P[46]=9.0173e-06;	trMetProb[18].P[47]=9.0173e-06;	
		trMetProb[19].P[0]=0.0208333;	trMetProb[19].P[1]=0.0208333;	trMetProb[19].P[2]=0.0208333;	trMetProb[19].P[3]=0.0208333;	trMetProb[19].P[4]=0.0208333;	trMetProb[19].P[5]=0.0208333;	trMetProb[19].P[6]=0.0208333;	trMetProb[19].P[7]=0.0208333;	trMetProb[19].P[8]=0.0208333;	trMetProb[19].P[9]=0.0208333;	trMetProb[19].P[10]=0.0208333;	trMetProb[19].P[11]=0.0208333;	trMetProb[19].P[12]=0.0208333;	trMetProb[19].P[13]=0.0208333;	trMetProb[19].P[14]=0.0208333;	trMetProb[19].P[15]=0.0208333;	trMetProb[19].P[16]=0.0208333;	trMetProb[19].P[17]=0.0208333;	trMetProb[19].P[18]=0.0208333;	trMetProb[19].P[19]=0.0208333;	trMetProb[19].P[20]=0.0208333;	trMetProb[19].P[21]=0.0208333;	trMetProb[19].P[22]=0.0208333;	trMetProb[19].P[23]=0.0208333;	trMetProb[19].P[24]=0.0208333;	trMetProb[19].P[25]=0.0208333;	trMetProb[19].P[26]=0.0208333;	trMetProb[19].P[27]=0.0208333;	trMetProb[19].P[28]=0.0208333;	trMetProb[19].P[29]=0.0208333;	trMetProb[19].P[30]=0.0208333;	trMetProb[19].P[31]=0.0208333;	trMetProb[19].P[32]=0.0208333;	trMetProb[19].P[33]=0.0208333;	trMetProb[19].P[34]=0.0208333;	trMetProb[19].P[35]=0.0208333;	trMetProb[19].P[36]=0.0208333;	trMetProb[19].P[37]=0.0208333;	trMetProb[19].P[38]=0.0208333;	trMetProb[19].P[39]=0.0208333;	trMetProb[19].P[40]=0.0208333;	trMetProb[19].P[41]=0.0208333;	trMetProb[19].P[42]=0.0208333;	trMetProb[19].P[43]=0.0208333;	trMetProb[19].P[44]=0.0208333;	trMetProb[19].P[45]=0.0208333;	trMetProb[19].P[46]=0.0208333;	trMetProb[19].P[47]=0.0208333;	
		trMetProb[20].P[0]=0.000110156;	trMetProb[20].P[1]=0.000110156;	trMetProb[20].P[2]=0.000110156;	trMetProb[20].P[3]=0.000110156;	trMetProb[20].P[4]=0.000110156;	trMetProb[20].P[5]=0.000110156;	trMetProb[20].P[6]=0.000110156;	trMetProb[20].P[7]=0.000110156;	trMetProb[20].P[8]=0.000110156;	trMetProb[20].P[9]=0.000110156;	trMetProb[20].P[10]=0.000110156;	trMetProb[20].P[11]=0.000110156;	trMetProb[20].P[12]=0.000110156;	trMetProb[20].P[13]=0.000110156;	trMetProb[20].P[14]=0.000110156;	trMetProb[20].P[15]=0.000110156;	trMetProb[20].P[16]=0.000110156;	trMetProb[20].P[17]=0.000110156;	trMetProb[20].P[18]=0.000110156;	trMetProb[20].P[19]=0.000110156;	trMetProb[20].P[20]=0.103657;	trMetProb[20].P[21]=0.0320555;	trMetProb[20].P[22]=0.0474774;	trMetProb[20].P[23]=0.000110156;	trMetProb[20].P[24]=0.811963;	trMetProb[20].P[25]=0.000110156;	trMetProb[20].P[26]=0.000110156;	trMetProb[20].P[27]=0.000110156;	trMetProb[20].P[28]=0.000110156;	trMetProb[20].P[29]=0.000110156;	trMetProb[20].P[30]=0.000110156;	trMetProb[20].P[31]=0.000110156;	trMetProb[20].P[32]=0.000110156;	trMetProb[20].P[33]=0.000110156;	trMetProb[20].P[34]=0.000110156;	trMetProb[20].P[35]=0.000110156;	trMetProb[20].P[36]=0.000110156;	trMetProb[20].P[37]=0.000110156;	trMetProb[20].P[38]=0.000110156;	trMetProb[20].P[39]=0.000110156;	trMetProb[20].P[40]=0.000110156;	trMetProb[20].P[41]=0.000110156;	trMetProb[20].P[42]=0.000110156;	trMetProb[20].P[43]=0.000110156;	trMetProb[20].P[44]=0.000110156;	trMetProb[20].P[45]=0.000110156;	trMetProb[20].P[46]=0.000110156;	trMetProb[20].P[47]=0.000110156;	
		trMetProb[21].P[0]=0.00474413;	trMetProb[21].P[1]=7.77726e-05;	trMetProb[21].P[2]=7.77726e-05;	trMetProb[21].P[3]=7.77726e-05;	trMetProb[21].P[4]=7.77726e-05;	trMetProb[21].P[5]=7.77726e-05;	trMetProb[21].P[6]=7.77726e-05;	trMetProb[21].P[7]=7.77726e-05;	trMetProb[21].P[8]=7.77726e-05;	trMetProb[21].P[9]=7.77726e-05;	trMetProb[21].P[10]=7.77726e-05;	trMetProb[21].P[11]=7.77726e-05;	trMetProb[21].P[12]=7.77726e-05;	trMetProb[21].P[13]=7.77726e-05;	trMetProb[21].P[14]=7.77726e-05;	trMetProb[21].P[15]=7.77726e-05;	trMetProb[21].P[16]=7.77726e-05;	trMetProb[21].P[17]=7.77726e-05;	trMetProb[21].P[18]=7.77726e-05;	trMetProb[21].P[19]=7.77726e-05;	trMetProb[21].P[20]=7.77726e-05;	trMetProb[21].P[21]=0.185177;	trMetProb[21].P[22]=7.77726e-05;	trMetProb[21].P[23]=7.77726e-05;	trMetProb[21].P[24]=0.804246;	trMetProb[21].P[25]=7.77726e-05;	trMetProb[21].P[26]=7.77726e-05;	trMetProb[21].P[27]=7.77726e-05;	trMetProb[21].P[28]=7.77726e-05;	trMetProb[21].P[29]=7.77726e-05;	trMetProb[21].P[30]=0.000855499;	trMetProb[21].P[31]=7.77726e-05;	trMetProb[21].P[32]=7.77726e-05;	trMetProb[21].P[33]=7.77726e-05;	trMetProb[21].P[34]=7.77726e-05;	trMetProb[21].P[35]=7.77726e-05;	trMetProb[21].P[36]=0.00163322;	trMetProb[21].P[37]=7.77726e-05;	trMetProb[21].P[38]=7.77726e-05;	trMetProb[21].P[39]=7.77726e-05;	trMetProb[21].P[40]=7.77726e-05;	trMetProb[21].P[41]=7.77726e-05;	trMetProb[21].P[42]=7.77726e-05;	trMetProb[21].P[43]=7.77726e-05;	trMetProb[21].P[44]=7.77726e-05;	trMetProb[21].P[45]=7.77726e-05;	trMetProb[21].P[46]=7.77726e-05;	trMetProb[21].P[47]=7.77726e-05;	
		trMetProb[22].P[0]=0.00209205;	trMetProb[22].P[1]=0.00209205;	trMetProb[22].P[2]=0.00209205;	trMetProb[22].P[3]=0.00209205;	trMetProb[22].P[4]=0.00209205;	trMetProb[22].P[5]=0.00209205;	trMetProb[22].P[6]=0.00209205;	trMetProb[22].P[7]=0.00209205;	trMetProb[22].P[8]=0.00209205;	trMetProb[22].P[9]=0.00209205;	trMetProb[22].P[10]=0.00209205;	trMetProb[22].P[11]=0.00209205;	trMetProb[22].P[12]=0.00209205;	trMetProb[22].P[13]=0.00209205;	trMetProb[22].P[14]=0.00209205;	trMetProb[22].P[15]=0.00209205;	trMetProb[22].P[16]=0.00209205;	trMetProb[22].P[17]=0.00209205;	trMetProb[22].P[18]=0.00209205;	trMetProb[22].P[19]=0.00209205;	trMetProb[22].P[20]=0.00209205;	trMetProb[22].P[21]=0.00209205;	trMetProb[22].P[22]=0.00209205;	trMetProb[22].P[23]=0.00209205;	trMetProb[22].P[24]=0.901674;	trMetProb[22].P[25]=0.00209205;	trMetProb[22].P[26]=0.00209205;	trMetProb[22].P[27]=0.00209205;	trMetProb[22].P[28]=0.00209205;	trMetProb[22].P[29]=0.00209205;	trMetProb[22].P[30]=0.00209205;	trMetProb[22].P[31]=0.00209205;	trMetProb[22].P[32]=0.00209205;	trMetProb[22].P[33]=0.00209205;	trMetProb[22].P[34]=0.00209205;	trMetProb[22].P[35]=0.00209205;	trMetProb[22].P[36]=0.00209205;	trMetProb[22].P[37]=0.00209205;	trMetProb[22].P[38]=0.00209205;	trMetProb[22].P[39]=0.00209205;	trMetProb[22].P[40]=0.00209205;	trMetProb[22].P[41]=0.00209205;	trMetProb[22].P[42]=0.00209205;	trMetProb[22].P[43]=0.00209205;	trMetProb[22].P[44]=0.00209205;	trMetProb[22].P[45]=0.00209205;	trMetProb[22].P[46]=0.00209205;	trMetProb[22].P[47]=0.00209205;	
		trMetProb[23].P[0]=0.0208333;	trMetProb[23].P[1]=0.0208333;	trMetProb[23].P[2]=0.0208333;	trMetProb[23].P[3]=0.0208333;	trMetProb[23].P[4]=0.0208333;	trMetProb[23].P[5]=0.0208333;	trMetProb[23].P[6]=0.0208333;	trMetProb[23].P[7]=0.0208333;	trMetProb[23].P[8]=0.0208333;	trMetProb[23].P[9]=0.0208333;	trMetProb[23].P[10]=0.0208333;	trMetProb[23].P[11]=0.0208333;	trMetProb[23].P[12]=0.0208333;	trMetProb[23].P[13]=0.0208333;	trMetProb[23].P[14]=0.0208333;	trMetProb[23].P[15]=0.0208333;	trMetProb[23].P[16]=0.0208333;	trMetProb[23].P[17]=0.0208333;	trMetProb[23].P[18]=0.0208333;	trMetProb[23].P[19]=0.0208333;	trMetProb[23].P[20]=0.0208333;	trMetProb[23].P[21]=0.0208333;	trMetProb[23].P[22]=0.0208333;	trMetProb[23].P[23]=0.0208333;	trMetProb[23].P[24]=0.0208333;	trMetProb[23].P[25]=0.0208333;	trMetProb[23].P[26]=0.0208333;	trMetProb[23].P[27]=0.0208333;	trMetProb[23].P[28]=0.0208333;	trMetProb[23].P[29]=0.0208333;	trMetProb[23].P[30]=0.0208333;	trMetProb[23].P[31]=0.0208333;	trMetProb[23].P[32]=0.0208333;	trMetProb[23].P[33]=0.0208333;	trMetProb[23].P[34]=0.0208333;	trMetProb[23].P[35]=0.0208333;	trMetProb[23].P[36]=0.0208333;	trMetProb[23].P[37]=0.0208333;	trMetProb[23].P[38]=0.0208333;	trMetProb[23].P[39]=0.0208333;	trMetProb[23].P[40]=0.0208333;	trMetProb[23].P[41]=0.0208333;	trMetProb[23].P[42]=0.0208333;	trMetProb[23].P[43]=0.0208333;	trMetProb[23].P[44]=0.0208333;	trMetProb[23].P[45]=0.0208333;	trMetProb[23].P[46]=0.0208333;	trMetProb[23].P[47]=0.0208333;	
		trMetProb[24].P[0]=0.0329732;	trMetProb[24].P[1]=3.01098e-06;	trMetProb[24].P[2]=3.01098e-06;	trMetProb[24].P[3]=3.01098e-06;	trMetProb[24].P[4]=6.32305e-05;	trMetProb[24].P[5]=3.01098e-06;	trMetProb[24].P[6]=0.00012345;	trMetProb[24].P[7]=3.01098e-06;	trMetProb[24].P[8]=3.01098e-06;	trMetProb[24].P[9]=3.01098e-06;	trMetProb[24].P[10]=3.01098e-06;	trMetProb[24].P[11]=3.01098e-06;	trMetProb[24].P[12]=0.000484767;	trMetProb[24].P[13]=3.01098e-06;	trMetProb[24].P[14]=3.01098e-06;	trMetProb[24].P[15]=3.01098e-06;	trMetProb[24].P[16]=3.01098e-06;	trMetProb[24].P[17]=3.01098e-06;	trMetProb[24].P[18]=0.000213779;	trMetProb[24].P[19]=3.01098e-06;	trMetProb[24].P[20]=3.01098e-06;	trMetProb[24].P[21]=0.000213779;	trMetProb[24].P[22]=3.01098e-06;	trMetProb[24].P[23]=3.01098e-06;	trMetProb[24].P[24]=0.562544;	trMetProb[24].P[25]=3.01098e-06;	trMetProb[24].P[26]=6.32305e-05;	trMetProb[24].P[27]=0.0207185;	trMetProb[24].P[28]=0.0225251;	trMetProb[24].P[29]=3.01098e-06;	trMetProb[24].P[30]=0.198878;	trMetProb[24].P[31]=3.01098e-06;	trMetProb[24].P[32]=0.00454959;	trMetProb[24].P[33]=0.00102674;	trMetProb[24].P[34]=3.01098e-06;	trMetProb[24].P[35]=3.01098e-06;	trMetProb[24].P[36]=0.140104;	trMetProb[24].P[37]=3.01098e-06;	trMetProb[24].P[38]=3.01098e-06;	trMetProb[24].P[39]=6.32305e-05;	trMetProb[24].P[40]=3.01098e-06;	trMetProb[24].P[41]=3.01098e-06;	trMetProb[24].P[42]=0.0144557;	trMetProb[24].P[43]=3.01098e-06;	trMetProb[24].P[44]=3.01098e-06;	trMetProb[24].P[45]=0.000906304;	trMetProb[24].P[46]=3.01098e-06;	trMetProb[24].P[47]=3.01098e-06;	
		trMetProb[25].P[0]=0.0208333;	trMetProb[25].P[1]=0.0208333;	trMetProb[25].P[2]=0.0208333;	trMetProb[25].P[3]=0.0208333;	trMetProb[25].P[4]=0.0208333;	trMetProb[25].P[5]=0.0208333;	trMetProb[25].P[6]=0.0208333;	trMetProb[25].P[7]=0.0208333;	trMetProb[25].P[8]=0.0208333;	trMetProb[25].P[9]=0.0208333;	trMetProb[25].P[10]=0.0208333;	trMetProb[25].P[11]=0.0208333;	trMetProb[25].P[12]=0.0208333;	trMetProb[25].P[13]=0.0208333;	trMetProb[25].P[14]=0.0208333;	trMetProb[25].P[15]=0.0208333;	trMetProb[25].P[16]=0.0208333;	trMetProb[25].P[17]=0.0208333;	trMetProb[25].P[18]=0.0208333;	trMetProb[25].P[19]=0.0208333;	trMetProb[25].P[20]=0.0208333;	trMetProb[25].P[21]=0.0208333;	trMetProb[25].P[22]=0.0208333;	trMetProb[25].P[23]=0.0208333;	trMetProb[25].P[24]=0.0208333;	trMetProb[25].P[25]=0.0208333;	trMetProb[25].P[26]=0.0208333;	trMetProb[25].P[27]=0.0208333;	trMetProb[25].P[28]=0.0208333;	trMetProb[25].P[29]=0.0208333;	trMetProb[25].P[30]=0.0208333;	trMetProb[25].P[31]=0.0208333;	trMetProb[25].P[32]=0.0208333;	trMetProb[25].P[33]=0.0208333;	trMetProb[25].P[34]=0.0208333;	trMetProb[25].P[35]=0.0208333;	trMetProb[25].P[36]=0.0208333;	trMetProb[25].P[37]=0.0208333;	trMetProb[25].P[38]=0.0208333;	trMetProb[25].P[39]=0.0208333;	trMetProb[25].P[40]=0.0208333;	trMetProb[25].P[41]=0.0208333;	trMetProb[25].P[42]=0.0208333;	trMetProb[25].P[43]=0.0208333;	trMetProb[25].P[44]=0.0208333;	trMetProb[25].P[45]=0.0208333;	trMetProb[25].P[46]=0.0208333;	trMetProb[25].P[47]=0.0208333;	
		trMetProb[26].P[0]=0.0147059;	trMetProb[26].P[1]=0.0147059;	trMetProb[26].P[2]=0.0147059;	trMetProb[26].P[3]=0.0147059;	trMetProb[26].P[4]=0.0147059;	trMetProb[26].P[5]=0.0147059;	trMetProb[26].P[6]=0.0147059;	trMetProb[26].P[7]=0.0147059;	trMetProb[26].P[8]=0.0147059;	trMetProb[26].P[9]=0.0147059;	trMetProb[26].P[10]=0.0147059;	trMetProb[26].P[11]=0.0147059;	trMetProb[26].P[12]=0.0147059;	trMetProb[26].P[13]=0.0147059;	trMetProb[26].P[14]=0.0147059;	trMetProb[26].P[15]=0.0147059;	trMetProb[26].P[16]=0.0147059;	trMetProb[26].P[17]=0.0147059;	trMetProb[26].P[18]=0.0147059;	trMetProb[26].P[19]=0.0147059;	trMetProb[26].P[20]=0.0147059;	trMetProb[26].P[21]=0.0147059;	trMetProb[26].P[22]=0.0147059;	trMetProb[26].P[23]=0.0147059;	trMetProb[26].P[24]=0.0147059;	trMetProb[26].P[25]=0.0147059;	trMetProb[26].P[26]=0.0147059;	trMetProb[26].P[27]=0.0147059;	trMetProb[26].P[28]=0.308824;	trMetProb[26].P[29]=0.0147059;	trMetProb[26].P[30]=0.0147059;	trMetProb[26].P[31]=0.0147059;	trMetProb[26].P[32]=0.0147059;	trMetProb[26].P[33]=0.0147059;	trMetProb[26].P[34]=0.0147059;	trMetProb[26].P[35]=0.0147059;	trMetProb[26].P[36]=0.0147059;	trMetProb[26].P[37]=0.0147059;	trMetProb[26].P[38]=0.0147059;	trMetProb[26].P[39]=0.0147059;	trMetProb[26].P[40]=0.0147059;	trMetProb[26].P[41]=0.0147059;	trMetProb[26].P[42]=0.0147059;	trMetProb[26].P[43]=0.0147059;	trMetProb[26].P[44]=0.0147059;	trMetProb[26].P[45]=0.0147059;	trMetProb[26].P[46]=0.0147059;	trMetProb[26].P[47]=0.0147059;	
		trMetProb[27].P[0]=0.00147889;	trMetProb[27].P[1]=0.000134445;	trMetProb[27].P[2]=0.000134445;	trMetProb[27].P[3]=0.000134445;	trMetProb[27].P[4]=0.000134445;	trMetProb[27].P[5]=0.000134445;	trMetProb[27].P[6]=0.000134445;	trMetProb[27].P[7]=0.000134445;	trMetProb[27].P[8]=0.000134445;	trMetProb[27].P[9]=0.000134445;	trMetProb[27].P[10]=0.000134445;	trMetProb[27].P[11]=0.000134445;	trMetProb[27].P[12]=0.000134445;	trMetProb[27].P[13]=0.000134445;	trMetProb[27].P[14]=0.000134445;	trMetProb[27].P[15]=0.000134445;	trMetProb[27].P[16]=0.000134445;	trMetProb[27].P[17]=0.000134445;	trMetProb[27].P[18]=0.000134445;	trMetProb[27].P[19]=0.000134445;	trMetProb[27].P[20]=0.000134445;	trMetProb[27].P[21]=0.000134445;	trMetProb[27].P[22]=0.000134445;	trMetProb[27].P[23]=0.000134445;	trMetProb[27].P[24]=0.000134445;	trMetProb[27].P[25]=0.000134445;	trMetProb[27].P[26]=0.000134445;	trMetProb[27].P[27]=0.0740791;	trMetProb[27].P[28]=0.00820113;	trMetProb[27].P[29]=0.000134445;	trMetProb[27].P[30]=0.910325;	trMetProb[27].P[31]=0.000134445;	trMetProb[27].P[32]=0.000134445;	trMetProb[27].P[33]=0.000134445;	trMetProb[27].P[34]=0.000134445;	trMetProb[27].P[35]=0.000134445;	trMetProb[27].P[36]=0.000134445;	trMetProb[27].P[37]=0.000134445;	trMetProb[27].P[38]=0.000134445;	trMetProb[27].P[39]=0.000134445;	trMetProb[27].P[40]=0.000134445;	trMetProb[27].P[41]=0.000134445;	trMetProb[27].P[42]=0.000134445;	trMetProb[27].P[43]=0.000134445;	trMetProb[27].P[44]=0.000134445;	trMetProb[27].P[45]=0.000134445;	trMetProb[27].P[46]=0.000134445;	trMetProb[27].P[47]=0.000134445;	
		trMetProb[28].P[0]=0.000116577;	trMetProb[28].P[1]=0.000116577;	trMetProb[28].P[2]=0.000116577;	trMetProb[28].P[3]=0.000116577;	trMetProb[28].P[4]=0.000116577;	trMetProb[28].P[5]=0.000116577;	trMetProb[28].P[6]=0.000116577;	trMetProb[28].P[7]=0.000116577;	trMetProb[28].P[8]=0.000116577;	trMetProb[28].P[9]=0.000116577;	trMetProb[28].P[10]=0.000116577;	trMetProb[28].P[11]=0.000116577;	trMetProb[28].P[12]=0.000116577;	trMetProb[28].P[13]=0.000116577;	trMetProb[28].P[14]=0.000116577;	trMetProb[28].P[15]=0.000116577;	trMetProb[28].P[16]=0.000116577;	trMetProb[28].P[17]=0.000116577;	trMetProb[28].P[18]=0.000116577;	trMetProb[28].P[19]=0.000116577;	trMetProb[28].P[20]=0.000116577;	trMetProb[28].P[21]=0.000116577;	trMetProb[28].P[22]=0.000116577;	trMetProb[28].P[23]=0.000116577;	trMetProb[28].P[24]=0.000116577;	trMetProb[28].P[25]=0.000116577;	trMetProb[28].P[26]=0.000116577;	trMetProb[28].P[27]=0.000116577;	trMetProb[28].P[28]=0.113197;	trMetProb[28].P[29]=0.000116577;	trMetProb[28].P[30]=0.120191;	trMetProb[28].P[31]=0.000116577;	trMetProb[28].P[32]=0.761366;	trMetProb[28].P[33]=0.000116577;	trMetProb[28].P[34]=0.000116577;	trMetProb[28].P[35]=0.000116577;	trMetProb[28].P[36]=0.000116577;	trMetProb[28].P[37]=0.000116577;	trMetProb[28].P[38]=0.000116577;	trMetProb[28].P[39]=0.000116577;	trMetProb[28].P[40]=0.000116577;	trMetProb[28].P[41]=0.000116577;	trMetProb[28].P[42]=0.000116577;	trMetProb[28].P[43]=0.000116577;	trMetProb[28].P[44]=0.000116577;	trMetProb[28].P[45]=0.000116577;	trMetProb[28].P[46]=0.000116577;	trMetProb[28].P[47]=0.000116577;	
		trMetProb[29].P[0]=0.0208333;	trMetProb[29].P[1]=0.0208333;	trMetProb[29].P[2]=0.0208333;	trMetProb[29].P[3]=0.0208333;	trMetProb[29].P[4]=0.0208333;	trMetProb[29].P[5]=0.0208333;	trMetProb[29].P[6]=0.0208333;	trMetProb[29].P[7]=0.0208333;	trMetProb[29].P[8]=0.0208333;	trMetProb[29].P[9]=0.0208333;	trMetProb[29].P[10]=0.0208333;	trMetProb[29].P[11]=0.0208333;	trMetProb[29].P[12]=0.0208333;	trMetProb[29].P[13]=0.0208333;	trMetProb[29].P[14]=0.0208333;	trMetProb[29].P[15]=0.0208333;	trMetProb[29].P[16]=0.0208333;	trMetProb[29].P[17]=0.0208333;	trMetProb[29].P[18]=0.0208333;	trMetProb[29].P[19]=0.0208333;	trMetProb[29].P[20]=0.0208333;	trMetProb[29].P[21]=0.0208333;	trMetProb[29].P[22]=0.0208333;	trMetProb[29].P[23]=0.0208333;	trMetProb[29].P[24]=0.0208333;	trMetProb[29].P[25]=0.0208333;	trMetProb[29].P[26]=0.0208333;	trMetProb[29].P[27]=0.0208333;	trMetProb[29].P[28]=0.0208333;	trMetProb[29].P[29]=0.0208333;	trMetProb[29].P[30]=0.0208333;	trMetProb[29].P[31]=0.0208333;	trMetProb[29].P[32]=0.0208333;	trMetProb[29].P[33]=0.0208333;	trMetProb[29].P[34]=0.0208333;	trMetProb[29].P[35]=0.0208333;	trMetProb[29].P[36]=0.0208333;	trMetProb[29].P[37]=0.0208333;	trMetProb[29].P[38]=0.0208333;	trMetProb[29].P[39]=0.0208333;	trMetProb[29].P[40]=0.0208333;	trMetProb[29].P[41]=0.0208333;	trMetProb[29].P[42]=0.0208333;	trMetProb[29].P[43]=0.0208333;	trMetProb[29].P[44]=0.0208333;	trMetProb[29].P[45]=0.0208333;	trMetProb[29].P[46]=0.0208333;	trMetProb[29].P[47]=0.0208333;	
		trMetProb[30].P[0]=1.05044e-05;	trMetProb[30].P[1]=1.05044e-05;	trMetProb[30].P[2]=1.05044e-05;	trMetProb[30].P[3]=1.05044e-05;	trMetProb[30].P[4]=1.05044e-05;	trMetProb[30].P[5]=1.05044e-05;	trMetProb[30].P[6]=1.05044e-05;	trMetProb[30].P[7]=1.05044e-05;	trMetProb[30].P[8]=1.05044e-05;	trMetProb[30].P[9]=1.05044e-05;	trMetProb[30].P[10]=1.05044e-05;	trMetProb[30].P[11]=1.05044e-05;	trMetProb[30].P[12]=1.05044e-05;	trMetProb[30].P[13]=1.05044e-05;	trMetProb[30].P[14]=1.05044e-05;	trMetProb[30].P[15]=1.05044e-05;	trMetProb[30].P[16]=1.05044e-05;	trMetProb[30].P[17]=1.05044e-05;	trMetProb[30].P[18]=1.05044e-05;	trMetProb[30].P[19]=1.05044e-05;	trMetProb[30].P[20]=1.05044e-05;	trMetProb[30].P[21]=1.05044e-05;	trMetProb[30].P[22]=1.05044e-05;	trMetProb[30].P[23]=1.05044e-05;	trMetProb[30].P[24]=1.05044e-05;	trMetProb[30].P[25]=1.05044e-05;	trMetProb[30].P[26]=1.05044e-05;	trMetProb[30].P[27]=1.05044e-05;	trMetProb[30].P[28]=1.05044e-05;	trMetProb[30].P[29]=1.05044e-05;	trMetProb[30].P[30]=0.218923;	trMetProb[30].P[31]=1.05044e-05;	trMetProb[30].P[32]=0.0136663;	trMetProb[30].P[33]=0.0785836;	trMetProb[30].P[34]=1.05044e-05;	trMetProb[30].P[35]=1.05044e-05;	trMetProb[30].P[36]=0.686895;	trMetProb[30].P[37]=1.05044e-05;	trMetProb[30].P[38]=1.05044e-05;	trMetProb[30].P[39]=0.000115549;	trMetProb[30].P[40]=1.05044e-05;	trMetProb[30].P[41]=1.05044e-05;	trMetProb[30].P[42]=0.00116599;	trMetProb[30].P[43]=1.05044e-05;	trMetProb[30].P[44]=1.05044e-05;	trMetProb[30].P[45]=0.000220593;	trMetProb[30].P[46]=1.05044e-05;	trMetProb[30].P[47]=1.05044e-05;	
		trMetProb[31].P[0]=0.0208333;	trMetProb[31].P[1]=0.0208333;	trMetProb[31].P[2]=0.0208333;	trMetProb[31].P[3]=0.0208333;	trMetProb[31].P[4]=0.0208333;	trMetProb[31].P[5]=0.0208333;	trMetProb[31].P[6]=0.0208333;	trMetProb[31].P[7]=0.0208333;	trMetProb[31].P[8]=0.0208333;	trMetProb[31].P[9]=0.0208333;	trMetProb[31].P[10]=0.0208333;	trMetProb[31].P[11]=0.0208333;	trMetProb[31].P[12]=0.0208333;	trMetProb[31].P[13]=0.0208333;	trMetProb[31].P[14]=0.0208333;	trMetProb[31].P[15]=0.0208333;	trMetProb[31].P[16]=0.0208333;	trMetProb[31].P[17]=0.0208333;	trMetProb[31].P[18]=0.0208333;	trMetProb[31].P[19]=0.0208333;	trMetProb[31].P[20]=0.0208333;	trMetProb[31].P[21]=0.0208333;	trMetProb[31].P[22]=0.0208333;	trMetProb[31].P[23]=0.0208333;	trMetProb[31].P[24]=0.0208333;	trMetProb[31].P[25]=0.0208333;	trMetProb[31].P[26]=0.0208333;	trMetProb[31].P[27]=0.0208333;	trMetProb[31].P[28]=0.0208333;	trMetProb[31].P[29]=0.0208333;	trMetProb[31].P[30]=0.0208333;	trMetProb[31].P[31]=0.0208333;	trMetProb[31].P[32]=0.0208333;	trMetProb[31].P[33]=0.0208333;	trMetProb[31].P[34]=0.0208333;	trMetProb[31].P[35]=0.0208333;	trMetProb[31].P[36]=0.0208333;	trMetProb[31].P[37]=0.0208333;	trMetProb[31].P[38]=0.0208333;	trMetProb[31].P[39]=0.0208333;	trMetProb[31].P[40]=0.0208333;	trMetProb[31].P[41]=0.0208333;	trMetProb[31].P[42]=0.0208333;	trMetProb[31].P[43]=0.0208333;	trMetProb[31].P[44]=0.0208333;	trMetProb[31].P[45]=0.0208333;	trMetProb[31].P[46]=0.0208333;	trMetProb[31].P[47]=0.0208333;	
		trMetProb[32].P[0]=0.00106096;	trMetProb[32].P[1]=9.64506e-05;	trMetProb[32].P[2]=9.64506e-05;	trMetProb[32].P[3]=9.64506e-05;	trMetProb[32].P[4]=9.64506e-05;	trMetProb[32].P[5]=9.64506e-05;	trMetProb[32].P[6]=9.64506e-05;	trMetProb[32].P[7]=9.64506e-05;	trMetProb[32].P[8]=9.64506e-05;	trMetProb[32].P[9]=9.64506e-05;	trMetProb[32].P[10]=9.64506e-05;	trMetProb[32].P[11]=9.64506e-05;	trMetProb[32].P[12]=9.64506e-05;	trMetProb[32].P[13]=9.64506e-05;	trMetProb[32].P[14]=9.64506e-05;	trMetProb[32].P[15]=9.64506e-05;	trMetProb[32].P[16]=9.64506e-05;	trMetProb[32].P[17]=9.64506e-05;	trMetProb[32].P[18]=9.64506e-05;	trMetProb[32].P[19]=9.64506e-05;	trMetProb[32].P[20]=9.64506e-05;	trMetProb[32].P[21]=9.64506e-05;	trMetProb[32].P[22]=9.64506e-05;	trMetProb[32].P[23]=9.64506e-05;	trMetProb[32].P[24]=9.64506e-05;	trMetProb[32].P[25]=9.64506e-05;	trMetProb[32].P[26]=9.64506e-05;	trMetProb[32].P[27]=9.64506e-05;	trMetProb[32].P[28]=9.64506e-05;	trMetProb[32].P[29]=9.64506e-05;	trMetProb[32].P[30]=9.64506e-05;	trMetProb[32].P[31]=9.64506e-05;	trMetProb[32].P[32]=0.0936535;	trMetProb[32].P[33]=0.00491898;	trMetProb[32].P[34]=0.00974151;	trMetProb[32].P[35]=9.64506e-05;	trMetProb[32].P[36]=0.756269;	trMetProb[32].P[37]=9.64506e-05;	trMetProb[32].P[38]=9.64506e-05;	trMetProb[32].P[39]=9.64506e-05;	trMetProb[32].P[40]=0.130305;	trMetProb[32].P[41]=9.64506e-05;	trMetProb[32].P[42]=9.64506e-05;	trMetProb[32].P[43]=9.64506e-05;	trMetProb[32].P[44]=9.64506e-05;	trMetProb[32].P[45]=9.64506e-05;	trMetProb[32].P[46]=9.64506e-05;	trMetProb[32].P[47]=9.64506e-05;	
		trMetProb[33].P[0]=0.000108483;	trMetProb[33].P[1]=0.000108483;	trMetProb[33].P[2]=0.000108483;	trMetProb[33].P[3]=0.000108483;	trMetProb[33].P[4]=0.000108483;	trMetProb[33].P[5]=0.000108483;	trMetProb[33].P[6]=0.000108483;	trMetProb[33].P[7]=0.000108483;	trMetProb[33].P[8]=0.000108483;	trMetProb[33].P[9]=0.000108483;	trMetProb[33].P[10]=0.000108483;	trMetProb[33].P[11]=0.000108483;	trMetProb[33].P[12]=0.000108483;	trMetProb[33].P[13]=0.000108483;	trMetProb[33].P[14]=0.000108483;	trMetProb[33].P[15]=0.000108483;	trMetProb[33].P[16]=0.000108483;	trMetProb[33].P[17]=0.000108483;	trMetProb[33].P[18]=0.000108483;	trMetProb[33].P[19]=0.000108483;	trMetProb[33].P[20]=0.000108483;	trMetProb[33].P[21]=0.000108483;	trMetProb[33].P[22]=0.000108483;	trMetProb[33].P[23]=0.000108483;	trMetProb[33].P[24]=0.000108483;	trMetProb[33].P[25]=0.000108483;	trMetProb[33].P[26]=0.000108483;	trMetProb[33].P[27]=0.000108483;	trMetProb[33].P[28]=0.000108483;	trMetProb[33].P[29]=0.000108483;	trMetProb[33].P[30]=0.000108483;	trMetProb[33].P[31]=0.000108483;	trMetProb[33].P[32]=0.000108483;	trMetProb[33].P[33]=0.134628;	trMetProb[33].P[34]=0.00119332;	trMetProb[33].P[35]=0.000108483;	trMetProb[33].P[36]=0.859297;	trMetProb[33].P[37]=0.000108483;	trMetProb[33].P[38]=0.000108483;	trMetProb[33].P[39]=0.000108483;	trMetProb[33].P[40]=0.000108483;	trMetProb[33].P[41]=0.000108483;	trMetProb[33].P[42]=0.000108483;	trMetProb[33].P[43]=0.000108483;	trMetProb[33].P[44]=0.000108483;	trMetProb[33].P[45]=0.000108483;	trMetProb[33].P[46]=0.000108483;	trMetProb[33].P[47]=0.000108483;	
		trMetProb[34].P[0]=0.00632911;	trMetProb[34].P[1]=0.00632911;	trMetProb[34].P[2]=0.00632911;	trMetProb[34].P[3]=0.00632911;	trMetProb[34].P[4]=0.00632911;	trMetProb[34].P[5]=0.00632911;	trMetProb[34].P[6]=0.00632911;	trMetProb[34].P[7]=0.00632911;	trMetProb[34].P[8]=0.00632911;	trMetProb[34].P[9]=0.00632911;	trMetProb[34].P[10]=0.00632911;	trMetProb[34].P[11]=0.00632911;	trMetProb[34].P[12]=0.00632911;	trMetProb[34].P[13]=0.00632911;	trMetProb[34].P[14]=0.00632911;	trMetProb[34].P[15]=0.00632911;	trMetProb[34].P[16]=0.00632911;	trMetProb[34].P[17]=0.00632911;	trMetProb[34].P[18]=0.00632911;	trMetProb[34].P[19]=0.00632911;	trMetProb[34].P[20]=0.00632911;	trMetProb[34].P[21]=0.00632911;	trMetProb[34].P[22]=0.00632911;	trMetProb[34].P[23]=0.00632911;	trMetProb[34].P[24]=0.00632911;	trMetProb[34].P[25]=0.00632911;	trMetProb[34].P[26]=0.00632911;	trMetProb[34].P[27]=0.00632911;	trMetProb[34].P[28]=0.00632911;	trMetProb[34].P[29]=0.00632911;	trMetProb[34].P[30]=0.00632911;	trMetProb[34].P[31]=0.00632911;	trMetProb[34].P[32]=0.00632911;	trMetProb[34].P[33]=0.00632911;	trMetProb[34].P[34]=0.00632911;	trMetProb[34].P[35]=0.0696203;	trMetProb[34].P[36]=0.639241;	trMetProb[34].P[37]=0.00632911;	trMetProb[34].P[38]=0.00632911;	trMetProb[34].P[39]=0.00632911;	trMetProb[34].P[40]=0.00632911;	trMetProb[34].P[41]=0.00632911;	trMetProb[34].P[42]=0.00632911;	trMetProb[34].P[43]=0.00632911;	trMetProb[34].P[44]=0.00632911;	trMetProb[34].P[45]=0.00632911;	trMetProb[34].P[46]=0.00632911;	trMetProb[34].P[47]=0.00632911;	
		trMetProb[35].P[0]=0.0172414;	trMetProb[35].P[1]=0.0172414;	trMetProb[35].P[2]=0.0172414;	trMetProb[35].P[3]=0.0172414;	trMetProb[35].P[4]=0.0172414;	trMetProb[35].P[5]=0.0172414;	trMetProb[35].P[6]=0.0172414;	trMetProb[35].P[7]=0.0172414;	trMetProb[35].P[8]=0.0172414;	trMetProb[35].P[9]=0.0172414;	trMetProb[35].P[10]=0.0172414;	trMetProb[35].P[11]=0.0172414;	trMetProb[35].P[12]=0.0172414;	trMetProb[35].P[13]=0.0172414;	trMetProb[35].P[14]=0.0172414;	trMetProb[35].P[15]=0.0172414;	trMetProb[35].P[16]=0.0172414;	trMetProb[35].P[17]=0.0172414;	trMetProb[35].P[18]=0.0172414;	trMetProb[35].P[19]=0.0172414;	trMetProb[35].P[20]=0.0172414;	trMetProb[35].P[21]=0.0172414;	trMetProb[35].P[22]=0.0172414;	trMetProb[35].P[23]=0.0172414;	trMetProb[35].P[24]=0.0172414;	trMetProb[35].P[25]=0.0172414;	trMetProb[35].P[26]=0.0172414;	trMetProb[35].P[27]=0.0172414;	trMetProb[35].P[28]=0.0172414;	trMetProb[35].P[29]=0.0172414;	trMetProb[35].P[30]=0.0172414;	trMetProb[35].P[31]=0.0172414;	trMetProb[35].P[32]=0.0172414;	trMetProb[35].P[33]=0.0172414;	trMetProb[35].P[34]=0.0172414;	trMetProb[35].P[35]=0.0172414;	trMetProb[35].P[36]=0.189655;	trMetProb[35].P[37]=0.0172414;	trMetProb[35].P[38]=0.0172414;	trMetProb[35].P[39]=0.0172414;	trMetProb[35].P[40]=0.0172414;	trMetProb[35].P[41]=0.0172414;	trMetProb[35].P[42]=0.0172414;	trMetProb[35].P[43]=0.0172414;	trMetProb[35].P[44]=0.0172414;	trMetProb[35].P[45]=0.0172414;	trMetProb[35].P[46]=0.0172414;	trMetProb[35].P[47]=0.0172414;	
		trMetProb[36].P[0]=0.164251;	trMetProb[36].P[1]=3.84293e-06;	trMetProb[36].P[2]=3.84293e-06;	trMetProb[36].P[3]=3.84293e-06;	trMetProb[36].P[4]=3.84293e-06;	trMetProb[36].P[5]=3.84293e-06;	trMetProb[36].P[6]=4.22722e-05;	trMetProb[36].P[7]=3.84293e-06;	trMetProb[36].P[8]=3.84293e-06;	trMetProb[36].P[9]=8.07016e-05;	trMetProb[36].P[10]=3.84293e-06;	trMetProb[36].P[11]=3.84293e-06;	trMetProb[36].P[12]=0.000618712;	trMetProb[36].P[13]=3.84293e-06;	trMetProb[36].P[14]=3.84293e-06;	trMetProb[36].P[15]=3.84293e-06;	trMetProb[36].P[16]=3.84293e-06;	trMetProb[36].P[17]=3.84293e-06;	trMetProb[36].P[18]=4.22722e-05;	trMetProb[36].P[19]=3.84293e-06;	trMetProb[36].P[20]=3.84293e-06;	trMetProb[36].P[21]=3.84293e-06;	trMetProb[36].P[22]=3.84293e-06;	trMetProb[36].P[23]=3.84293e-06;	trMetProb[36].P[24]=3.84293e-06;	trMetProb[36].P[25]=3.84293e-06;	trMetProb[36].P[26]=3.84293e-06;	trMetProb[36].P[27]=3.84293e-06;	trMetProb[36].P[28]=3.84293e-06;	trMetProb[36].P[29]=3.84293e-06;	trMetProb[36].P[30]=3.84293e-06;	trMetProb[36].P[31]=3.84293e-06;	trMetProb[36].P[32]=3.84293e-06;	trMetProb[36].P[33]=3.84293e-06;	trMetProb[36].P[34]=3.84293e-06;	trMetProb[36].P[35]=3.84293e-06;	trMetProb[36].P[36]=0.496511;	trMetProb[36].P[37]=8.07016e-05;	trMetProb[36].P[38]=0.000388136;	trMetProb[36].P[39]=0.0299787;	trMetProb[36].P[40]=0.0314006;	trMetProb[36].P[41]=3.84293e-06;	trMetProb[36].P[42]=0.274082;	trMetProb[36].P[43]=3.84293e-06;	trMetProb[36].P[44]=3.84293e-06;	trMetProb[36].P[45]=0.00238646;	trMetProb[36].P[46]=3.84293e-06;	trMetProb[36].P[47]=3.84293e-06;	
		trMetProb[37].P[0]=0.0147059;	trMetProb[37].P[1]=0.0147059;	trMetProb[37].P[2]=0.0147059;	trMetProb[37].P[3]=0.0147059;	trMetProb[37].P[4]=0.0147059;	trMetProb[37].P[5]=0.0147059;	trMetProb[37].P[6]=0.0147059;	trMetProb[37].P[7]=0.0147059;	trMetProb[37].P[8]=0.0147059;	trMetProb[37].P[9]=0.0147059;	trMetProb[37].P[10]=0.0147059;	trMetProb[37].P[11]=0.0147059;	trMetProb[37].P[12]=0.0147059;	trMetProb[37].P[13]=0.0147059;	trMetProb[37].P[14]=0.0147059;	trMetProb[37].P[15]=0.0147059;	trMetProb[37].P[16]=0.0147059;	trMetProb[37].P[17]=0.0147059;	trMetProb[37].P[18]=0.0147059;	trMetProb[37].P[19]=0.0147059;	trMetProb[37].P[20]=0.0147059;	trMetProb[37].P[21]=0.0147059;	trMetProb[37].P[22]=0.0147059;	trMetProb[37].P[23]=0.0147059;	trMetProb[37].P[24]=0.0147059;	trMetProb[37].P[25]=0.0147059;	trMetProb[37].P[26]=0.0147059;	trMetProb[37].P[27]=0.0147059;	trMetProb[37].P[28]=0.0147059;	trMetProb[37].P[29]=0.0147059;	trMetProb[37].P[30]=0.0147059;	trMetProb[37].P[31]=0.0147059;	trMetProb[37].P[32]=0.0147059;	trMetProb[37].P[33]=0.0147059;	trMetProb[37].P[34]=0.0147059;	trMetProb[37].P[35]=0.0147059;	trMetProb[37].P[36]=0.0147059;	trMetProb[37].P[37]=0.0147059;	trMetProb[37].P[38]=0.308824;	trMetProb[37].P[39]=0.0147059;	trMetProb[37].P[40]=0.0147059;	trMetProb[37].P[41]=0.0147059;	trMetProb[37].P[42]=0.0147059;	trMetProb[37].P[43]=0.0147059;	trMetProb[37].P[44]=0.0147059;	trMetProb[37].P[45]=0.0147059;	trMetProb[37].P[46]=0.0147059;	trMetProb[37].P[47]=0.0147059;	
		trMetProb[38].P[0]=0.00595238;	trMetProb[38].P[1]=0.00595238;	trMetProb[38].P[2]=0.00595238;	trMetProb[38].P[3]=0.00595238;	trMetProb[38].P[4]=0.00595238;	trMetProb[38].P[5]=0.00595238;	trMetProb[38].P[6]=0.00595238;	trMetProb[38].P[7]=0.00595238;	trMetProb[38].P[8]=0.00595238;	trMetProb[38].P[9]=0.00595238;	trMetProb[38].P[10]=0.00595238;	trMetProb[38].P[11]=0.00595238;	trMetProb[38].P[12]=0.00595238;	trMetProb[38].P[13]=0.00595238;	trMetProb[38].P[14]=0.00595238;	trMetProb[38].P[15]=0.00595238;	trMetProb[38].P[16]=0.00595238;	trMetProb[38].P[17]=0.00595238;	trMetProb[38].P[18]=0.00595238;	trMetProb[38].P[19]=0.00595238;	trMetProb[38].P[20]=0.00595238;	trMetProb[38].P[21]=0.00595238;	trMetProb[38].P[22]=0.00595238;	trMetProb[38].P[23]=0.00595238;	trMetProb[38].P[24]=0.00595238;	trMetProb[38].P[25]=0.00595238;	trMetProb[38].P[26]=0.00595238;	trMetProb[38].P[27]=0.00595238;	trMetProb[38].P[28]=0.00595238;	trMetProb[38].P[29]=0.00595238;	trMetProb[38].P[30]=0.00595238;	trMetProb[38].P[31]=0.00595238;	trMetProb[38].P[32]=0.00595238;	trMetProb[38].P[33]=0.00595238;	trMetProb[38].P[34]=0.00595238;	trMetProb[38].P[35]=0.00595238;	trMetProb[38].P[36]=0.00595238;	trMetProb[38].P[37]=0.00595238;	trMetProb[38].P[38]=0.00595238;	trMetProb[38].P[39]=0.125;	trMetProb[38].P[40]=0.60119;	trMetProb[38].P[41]=0.00595238;	trMetProb[38].P[42]=0.00595238;	trMetProb[38].P[43]=0.00595238;	trMetProb[38].P[44]=0.00595238;	trMetProb[38].P[45]=0.00595238;	trMetProb[38].P[46]=0.00595238;	trMetProb[38].P[47]=0.00595238;	
		trMetProb[39].P[0]=0.000114051;	trMetProb[39].P[1]=0.000114051;	trMetProb[39].P[2]=0.000114051;	trMetProb[39].P[3]=0.000114051;	trMetProb[39].P[4]=0.000114051;	trMetProb[39].P[5]=0.000114051;	trMetProb[39].P[6]=0.000114051;	trMetProb[39].P[7]=0.000114051;	trMetProb[39].P[8]=0.000114051;	trMetProb[39].P[9]=0.000114051;	trMetProb[39].P[10]=0.000114051;	trMetProb[39].P[11]=0.000114051;	trMetProb[39].P[12]=0.000114051;	trMetProb[39].P[13]=0.000114051;	trMetProb[39].P[14]=0.000114051;	trMetProb[39].P[15]=0.000114051;	trMetProb[39].P[16]=0.000114051;	trMetProb[39].P[17]=0.000114051;	trMetProb[39].P[18]=0.000114051;	trMetProb[39].P[19]=0.000114051;	trMetProb[39].P[20]=0.000114051;	trMetProb[39].P[21]=0.000114051;	trMetProb[39].P[22]=0.000114051;	trMetProb[39].P[23]=0.000114051;	trMetProb[39].P[24]=0.000114051;	trMetProb[39].P[25]=0.000114051;	trMetProb[39].P[26]=0.000114051;	trMetProb[39].P[27]=0.000114051;	trMetProb[39].P[28]=0.000114051;	trMetProb[39].P[29]=0.000114051;	trMetProb[39].P[30]=0.000114051;	trMetProb[39].P[31]=0.000114051;	trMetProb[39].P[32]=0.000114051;	trMetProb[39].P[33]=0.000114051;	trMetProb[39].P[34]=0.000114051;	trMetProb[39].P[35]=0.000114051;	trMetProb[39].P[36]=0.000114051;	trMetProb[39].P[37]=0.000114051;	trMetProb[39].P[38]=0.000114051;	trMetProb[39].P[39]=0.10162;	trMetProb[39].P[40]=0.0172217;	trMetProb[39].P[41]=0.000114051;	trMetProb[39].P[42]=0.876026;	trMetProb[39].P[43]=0.000114051;	trMetProb[39].P[44]=0.000114051;	trMetProb[39].P[45]=0.000114051;	trMetProb[39].P[46]=0.000114051;	trMetProb[39].P[47]=0.000114051;	
		trMetProb[40].P[0]=0.131158;	trMetProb[40].P[1]=9.29541e-05;	trMetProb[40].P[2]=9.29541e-05;	trMetProb[40].P[3]=9.29541e-05;	trMetProb[40].P[4]=9.29541e-05;	trMetProb[40].P[5]=9.29541e-05;	trMetProb[40].P[6]=9.29541e-05;	trMetProb[40].P[7]=9.29541e-05;	trMetProb[40].P[8]=9.29541e-05;	trMetProb[40].P[9]=9.29541e-05;	trMetProb[40].P[10]=9.29541e-05;	trMetProb[40].P[11]=9.29541e-05;	trMetProb[40].P[12]=9.29541e-05;	trMetProb[40].P[13]=9.29541e-05;	trMetProb[40].P[14]=9.29541e-05;	trMetProb[40].P[15]=9.29541e-05;	trMetProb[40].P[16]=9.29541e-05;	trMetProb[40].P[17]=9.29541e-05;	trMetProb[40].P[18]=9.29541e-05;	trMetProb[40].P[19]=9.29541e-05;	trMetProb[40].P[20]=9.29541e-05;	trMetProb[40].P[21]=9.29541e-05;	trMetProb[40].P[22]=9.29541e-05;	trMetProb[40].P[23]=9.29541e-05;	trMetProb[40].P[24]=9.29541e-05;	trMetProb[40].P[25]=9.29541e-05;	trMetProb[40].P[26]=9.29541e-05;	trMetProb[40].P[27]=9.29541e-05;	trMetProb[40].P[28]=9.29541e-05;	trMetProb[40].P[29]=9.29541e-05;	trMetProb[40].P[30]=9.29541e-05;	trMetProb[40].P[31]=9.29541e-05;	trMetProb[40].P[32]=9.29541e-05;	trMetProb[40].P[33]=9.29541e-05;	trMetProb[40].P[34]=9.29541e-05;	trMetProb[40].P[35]=9.29541e-05;	trMetProb[40].P[36]=9.29541e-05;	trMetProb[40].P[37]=9.29541e-05;	trMetProb[40].P[38]=9.29541e-05;	trMetProb[40].P[39]=9.29541e-05;	trMetProb[40].P[40]=0.0874698;	trMetProb[40].P[41]=0.00381112;	trMetProb[40].P[42]=0.139524;	trMetProb[40].P[43]=9.29541e-05;	trMetProb[40].P[44]=0.63404;	trMetProb[40].P[45]=9.29541e-05;	trMetProb[40].P[46]=9.29541e-05;	trMetProb[40].P[47]=9.29541e-05;	
		trMetProb[41].P[0]=0.0113636;	trMetProb[41].P[1]=0.0113636;	trMetProb[41].P[2]=0.0113636;	trMetProb[41].P[3]=0.0113636;	trMetProb[41].P[4]=0.0113636;	trMetProb[41].P[5]=0.0113636;	trMetProb[41].P[6]=0.0113636;	trMetProb[41].P[7]=0.0113636;	trMetProb[41].P[8]=0.0113636;	trMetProb[41].P[9]=0.0113636;	trMetProb[41].P[10]=0.0113636;	trMetProb[41].P[11]=0.0113636;	trMetProb[41].P[12]=0.0113636;	trMetProb[41].P[13]=0.0113636;	trMetProb[41].P[14]=0.0113636;	trMetProb[41].P[15]=0.0113636;	trMetProb[41].P[16]=0.0113636;	trMetProb[41].P[17]=0.0113636;	trMetProb[41].P[18]=0.0113636;	trMetProb[41].P[19]=0.0113636;	trMetProb[41].P[20]=0.0113636;	trMetProb[41].P[21]=0.0113636;	trMetProb[41].P[22]=0.0113636;	trMetProb[41].P[23]=0.0113636;	trMetProb[41].P[24]=0.0113636;	trMetProb[41].P[25]=0.0113636;	trMetProb[41].P[26]=0.0113636;	trMetProb[41].P[27]=0.0113636;	trMetProb[41].P[28]=0.0113636;	trMetProb[41].P[29]=0.0113636;	trMetProb[41].P[30]=0.0113636;	trMetProb[41].P[31]=0.0113636;	trMetProb[41].P[32]=0.0113636;	trMetProb[41].P[33]=0.0113636;	trMetProb[41].P[34]=0.0113636;	trMetProb[41].P[35]=0.0113636;	trMetProb[41].P[36]=0.0113636;	trMetProb[41].P[37]=0.0113636;	trMetProb[41].P[38]=0.0113636;	trMetProb[41].P[39]=0.0113636;	trMetProb[41].P[40]=0.0113636;	trMetProb[41].P[41]=0.0113636;	trMetProb[41].P[42]=0.465909;	trMetProb[41].P[43]=0.0113636;	trMetProb[41].P[44]=0.0113636;	trMetProb[41].P[45]=0.0113636;	trMetProb[41].P[46]=0.0113636;	trMetProb[41].P[47]=0.0113636;	
		trMetProb[42].P[0]=0.607918;	trMetProb[42].P[1]=8.0614e-06;	trMetProb[42].P[2]=8.0614e-06;	trMetProb[42].P[3]=8.0614e-06;	trMetProb[42].P[4]=8.0614e-06;	trMetProb[42].P[5]=8.0614e-06;	trMetProb[42].P[6]=8.86754e-05;	trMetProb[42].P[7]=8.0614e-06;	trMetProb[42].P[8]=8.0614e-06;	trMetProb[42].P[9]=8.86754e-05;	trMetProb[42].P[10]=8.0614e-06;	trMetProb[42].P[11]=8.0614e-06;	trMetProb[42].P[12]=8.86754e-05;	trMetProb[42].P[13]=8.0614e-06;	trMetProb[42].P[14]=8.0614e-06;	trMetProb[42].P[15]=8.0614e-06;	trMetProb[42].P[16]=8.0614e-06;	trMetProb[42].P[17]=8.0614e-06;	trMetProb[42].P[18]=8.0614e-06;	trMetProb[42].P[19]=8.0614e-06;	trMetProb[42].P[20]=8.0614e-06;	trMetProb[42].P[21]=8.0614e-06;	trMetProb[42].P[22]=8.0614e-06;	trMetProb[42].P[23]=8.0614e-06;	trMetProb[42].P[24]=0.000249903;	trMetProb[42].P[25]=8.0614e-06;	trMetProb[42].P[26]=8.0614e-06;	trMetProb[42].P[27]=8.0614e-06;	trMetProb[42].P[28]=8.0614e-06;	trMetProb[42].P[29]=8.0614e-06;	trMetProb[42].P[30]=8.0614e-06;	trMetProb[42].P[31]=8.0614e-06;	trMetProb[42].P[32]=8.0614e-06;	trMetProb[42].P[33]=8.0614e-06;	trMetProb[42].P[34]=8.0614e-06;	trMetProb[42].P[35]=8.0614e-06;	trMetProb[42].P[36]=8.86754e-05;	trMetProb[42].P[37]=8.0614e-06;	trMetProb[42].P[38]=8.0614e-06;	trMetProb[42].P[39]=8.0614e-06;	trMetProb[42].P[40]=8.0614e-06;	trMetProb[42].P[41]=8.0614e-06;	trMetProb[42].P[42]=0.302875;	trMetProb[42].P[43]=8.86754e-05;	trMetProb[42].P[44]=0.0100042;	trMetProb[42].P[45]=0.0782036;	trMetProb[42].P[46]=8.0614e-06;	trMetProb[42].P[47]=8.0614e-06;	
		trMetProb[43].P[0]=0.0172414;	trMetProb[43].P[1]=0.0172414;	trMetProb[43].P[2]=0.0172414;	trMetProb[43].P[3]=0.0172414;	trMetProb[43].P[4]=0.0172414;	trMetProb[43].P[5]=0.0172414;	trMetProb[43].P[6]=0.0172414;	trMetProb[43].P[7]=0.0172414;	trMetProb[43].P[8]=0.0172414;	trMetProb[43].P[9]=0.0172414;	trMetProb[43].P[10]=0.0172414;	trMetProb[43].P[11]=0.0172414;	trMetProb[43].P[12]=0.0172414;	trMetProb[43].P[13]=0.0172414;	trMetProb[43].P[14]=0.0172414;	trMetProb[43].P[15]=0.0172414;	trMetProb[43].P[16]=0.0172414;	trMetProb[43].P[17]=0.0172414;	trMetProb[43].P[18]=0.0172414;	trMetProb[43].P[19]=0.0172414;	trMetProb[43].P[20]=0.0172414;	trMetProb[43].P[21]=0.0172414;	trMetProb[43].P[22]=0.0172414;	trMetProb[43].P[23]=0.0172414;	trMetProb[43].P[24]=0.0172414;	trMetProb[43].P[25]=0.0172414;	trMetProb[43].P[26]=0.0172414;	trMetProb[43].P[27]=0.0172414;	trMetProb[43].P[28]=0.0172414;	trMetProb[43].P[29]=0.0172414;	trMetProb[43].P[30]=0.0172414;	trMetProb[43].P[31]=0.0172414;	trMetProb[43].P[32]=0.0172414;	trMetProb[43].P[33]=0.0172414;	trMetProb[43].P[34]=0.0172414;	trMetProb[43].P[35]=0.0172414;	trMetProb[43].P[36]=0.0172414;	trMetProb[43].P[37]=0.0172414;	trMetProb[43].P[38]=0.0172414;	trMetProb[43].P[39]=0.0172414;	trMetProb[43].P[40]=0.0172414;	trMetProb[43].P[41]=0.0172414;	trMetProb[43].P[42]=0.0172414;	trMetProb[43].P[43]=0.0172414;	trMetProb[43].P[44]=0.189655;	trMetProb[43].P[45]=0.0172414;	trMetProb[43].P[46]=0.0172414;	trMetProb[43].P[47]=0.0172414;	
		trMetProb[44].P[0]=0.859969;	trMetProb[44].P[1]=0.000110522;	trMetProb[44].P[2]=0.000110522;	trMetProb[44].P[3]=0.000110522;	trMetProb[44].P[4]=0.000110522;	trMetProb[44].P[5]=0.000110522;	trMetProb[44].P[6]=0.000110522;	trMetProb[44].P[7]=0.000110522;	trMetProb[44].P[8]=0.000110522;	trMetProb[44].P[9]=0.000110522;	trMetProb[44].P[10]=0.000110522;	trMetProb[44].P[11]=0.000110522;	trMetProb[44].P[12]=0.000110522;	trMetProb[44].P[13]=0.000110522;	trMetProb[44].P[14]=0.000110522;	trMetProb[44].P[15]=0.000110522;	trMetProb[44].P[16]=0.000110522;	trMetProb[44].P[17]=0.000110522;	trMetProb[44].P[18]=0.000110522;	trMetProb[44].P[19]=0.000110522;	trMetProb[44].P[20]=0.000110522;	trMetProb[44].P[21]=0.000110522;	trMetProb[44].P[22]=0.000110522;	trMetProb[44].P[23]=0.000110522;	trMetProb[44].P[24]=0.000110522;	trMetProb[44].P[25]=0.000110522;	trMetProb[44].P[26]=0.000110522;	trMetProb[44].P[27]=0.000110522;	trMetProb[44].P[28]=0.000110522;	trMetProb[44].P[29]=0.000110522;	trMetProb[44].P[30]=0.000110522;	trMetProb[44].P[31]=0.000110522;	trMetProb[44].P[32]=0.000110522;	trMetProb[44].P[33]=0.000110522;	trMetProb[44].P[34]=0.000110522;	trMetProb[44].P[35]=0.000110522;	trMetProb[44].P[36]=0.000110522;	trMetProb[44].P[37]=0.000110522;	trMetProb[44].P[38]=0.000110522;	trMetProb[44].P[39]=0.000110522;	trMetProb[44].P[40]=0.000110522;	trMetProb[44].P[41]=0.000110522;	trMetProb[44].P[42]=0.000110522;	trMetProb[44].P[43]=0.000110522;	trMetProb[44].P[44]=0.102896;	trMetProb[44].P[45]=0.017794;	trMetProb[44].P[46]=0.0144783;	trMetProb[44].P[47]=0.000110522;	
		trMetProb[45].P[0]=0.784767;	trMetProb[45].P[1]=7.20565e-05;	trMetProb[45].P[2]=7.20565e-05;	trMetProb[45].P[3]=7.20565e-05;	trMetProb[45].P[4]=7.20565e-05;	trMetProb[45].P[5]=7.20565e-05;	trMetProb[45].P[6]=7.20565e-05;	trMetProb[45].P[7]=7.20565e-05;	trMetProb[45].P[8]=7.20565e-05;	trMetProb[45].P[9]=7.20565e-05;	trMetProb[45].P[10]=7.20565e-05;	trMetProb[45].P[11]=7.20565e-05;	trMetProb[45].P[12]=7.20565e-05;	trMetProb[45].P[13]=7.20565e-05;	trMetProb[45].P[14]=7.20565e-05;	trMetProb[45].P[15]=7.20565e-05;	trMetProb[45].P[16]=7.20565e-05;	trMetProb[45].P[17]=7.20565e-05;	trMetProb[45].P[18]=7.20565e-05;	trMetProb[45].P[19]=7.20565e-05;	trMetProb[45].P[20]=7.20565e-05;	trMetProb[45].P[21]=7.20565e-05;	trMetProb[45].P[22]=7.20565e-05;	trMetProb[45].P[23]=7.20565e-05;	trMetProb[45].P[24]=7.20565e-05;	trMetProb[45].P[25]=7.20565e-05;	trMetProb[45].P[26]=7.20565e-05;	trMetProb[45].P[27]=7.20565e-05;	trMetProb[45].P[28]=7.20565e-05;	trMetProb[45].P[29]=7.20565e-05;	trMetProb[45].P[30]=7.20565e-05;	trMetProb[45].P[31]=7.20565e-05;	trMetProb[45].P[32]=7.20565e-05;	trMetProb[45].P[33]=7.20565e-05;	trMetProb[45].P[34]=7.20565e-05;	trMetProb[45].P[35]=7.20565e-05;	trMetProb[45].P[36]=7.20565e-05;	trMetProb[45].P[37]=7.20565e-05;	trMetProb[45].P[38]=7.20565e-05;	trMetProb[45].P[39]=7.20565e-05;	trMetProb[45].P[40]=7.20565e-05;	trMetProb[45].P[41]=7.20565e-05;	trMetProb[45].P[42]=7.20565e-05;	trMetProb[45].P[43]=7.20565e-05;	trMetProb[45].P[44]=7.20565e-05;	trMetProb[45].P[45]=0.211198;	trMetProb[45].P[46]=0.000792621;	trMetProb[45].P[47]=7.20565e-05;	
		trMetProb[46].P[0]=0.696809;	trMetProb[46].P[1]=0.00531915;	trMetProb[46].P[2]=0.00531915;	trMetProb[46].P[3]=0.00531915;	trMetProb[46].P[4]=0.00531915;	trMetProb[46].P[5]=0.00531915;	trMetProb[46].P[6]=0.00531915;	trMetProb[46].P[7]=0.00531915;	trMetProb[46].P[8]=0.00531915;	trMetProb[46].P[9]=0.00531915;	trMetProb[46].P[10]=0.00531915;	trMetProb[46].P[11]=0.00531915;	trMetProb[46].P[12]=0.00531915;	trMetProb[46].P[13]=0.00531915;	trMetProb[46].P[14]=0.00531915;	trMetProb[46].P[15]=0.00531915;	trMetProb[46].P[16]=0.00531915;	trMetProb[46].P[17]=0.00531915;	trMetProb[46].P[18]=0.00531915;	trMetProb[46].P[19]=0.00531915;	trMetProb[46].P[20]=0.00531915;	trMetProb[46].P[21]=0.00531915;	trMetProb[46].P[22]=0.00531915;	trMetProb[46].P[23]=0.00531915;	trMetProb[46].P[24]=0.00531915;	trMetProb[46].P[25]=0.00531915;	trMetProb[46].P[26]=0.00531915;	trMetProb[46].P[27]=0.00531915;	trMetProb[46].P[28]=0.00531915;	trMetProb[46].P[29]=0.00531915;	trMetProb[46].P[30]=0.00531915;	trMetProb[46].P[31]=0.00531915;	trMetProb[46].P[32]=0.00531915;	trMetProb[46].P[33]=0.00531915;	trMetProb[46].P[34]=0.00531915;	trMetProb[46].P[35]=0.00531915;	trMetProb[46].P[36]=0.00531915;	trMetProb[46].P[37]=0.00531915;	trMetProb[46].P[38]=0.00531915;	trMetProb[46].P[39]=0.00531915;	trMetProb[46].P[40]=0.00531915;	trMetProb[46].P[41]=0.00531915;	trMetProb[46].P[42]=0.00531915;	trMetProb[46].P[43]=0.00531915;	trMetProb[46].P[44]=0.00531915;	trMetProb[46].P[45]=0.00531915;	trMetProb[46].P[46]=0.00531915;	trMetProb[46].P[47]=0.0585106;	


    for(int i=0;i<numMetricalPos;i+=1){
      trMetProb[i].Normalize();
    }//endfor i
    barJumpProb.Normalize();

    for(int i=0;i<numStates;i+=1){
      for(int j=0;j<numStates;j+=1){
        trProb[i].P[j]=trMetProb[i%numMetricalPos].P[j%numMetricalPos]*barJumpProb.P[j/numMetricalPos];
      }//endfor j
      trProb[i].Normalize();
    }//endfor i

  effGrids.clear();
  for(int i=0;i<numStates;i+=1){
    if(i%2!=0 && i%3!=0){continue;}
    effGrids.push_back(i);
  }//endfor i
  effGridIntervals.clear();
  effGridIntervals.resize(effGrids.size());
  for(int i=0;i<effGrids.size();i+=1){
    for(int j=0;j<effGrids.size();j+=1){//j->i
      effGridIntervals[i].push_back(effGrids[j]);
    }//endfor j
  }//endfor i
//cout<<effGrids.size()<<"\t"<<effGridIntervals[0].size()<<endl;

//////Calculate and set initial probabilites
    vector<double> stationaryProb;
    for(int i=0;i<numStates;i+=1){
      stationaryProb.push_back((1.*rand())/(1.*RAND_MAX));
    }//endfor i
    Norm(stationaryProb);
    for(int iter=0;iter<100;iter+=1){
      vector<double> prevVec(stationaryProb);
      for(int i=0;i<numStates;i+=1){
        stationaryProb[i]=0;
        for(int j=0;j<numStates;j+=1){
          stationaryProb[i]+=prevVec[j]*trProb[j].P[i];
        }//endfor j
      }//endfor i
    }//endfor iter
    Norm(stationaryProb);
    trIniProb.P=stationaryProb;
    trIniProb.Normalize();

//////Init tempo model
    Sigma_t=0.02;
    lambda=0.0101;
    minSecPerQN=0.3;//BPM=200
    maxSeqPerQN=1.5;//BPM=40
    numTempoState=50;
    truncatedWidth=6;
    double SigmaV=1.;
    fac_t=-0.5*log(2*M_PI*Sigma_t*Sigma_t);

    double eps=log(maxSeqPerQN/minSecPerQN)/numTempoState;
    for(int i=0;i<numTempoState;i+=1){
      secPerQN.push_back(minSecPerQN*exp(i*eps));
    }//endfor i

    tempoTrProb.resize(numTempoState);
    for(int i=0;i<numTempoState;i+=1){
      tempoTrProb[i].P.resize(numTempoState);
      for(int j=0;j<numTempoState;j+=1){
        tempoTrProb[i].P[j]=exp(-0.5*pow((i-j)/SigmaV,2.));
      }//endfor j
      tempoTrProb[i].Normalize();
    }//endfor i

    tempoTrIniProb.P.resize(numTempoState);
    for(int i=0;i<numTempoState;i+=1){
      tempoTrIniProb.P[i]=exp(-0.5*pow((i-numTempoState/2)/(3*SigmaV),2.));
    }//endfor i
    tempoTrIniProb.Normalize();


if(printOn){cout<<"###Init END###"<<endl;}
  }//end Init

  void ReadData_Transcr(string filename){
    data.ReadFile(filename);
    data.TPQN=24;
    for(int n=0;n<data.evts.size();n+=1){data.evts[n].chan=0;}
  }//end ReadData_Transcr

  double OutputLP(int pos_pre,int pos,int tempoID,double ioi_){
    int nv=pos%numMetricalPos-pos_pre%numMetricalPos+(pos/numMetricalPos)*numMetricalPos;
    if(nv<0){
      return fac_t-0.5*pow((ioi_-1*secPerQN[tempoID]/double(TPQN))/Sigma_t,2.)-1E10;
    }else if(nv==0){
      return -log(lambda)-ioi_/lambda;
    }else{
      return fac_t-0.5*pow((ioi_-nv*secPerQN[tempoID]/double(TPQN))/Sigma_t,2.);
    }//endif
  }//end OutputLP

  void Viterbi(){
if(printOn){cout<<"###Viterbi###"<<endl;}

    vector<double> iois;
    for(int n=1;n<data.evts.size();n+=1){
      iois.push_back(data.evts[n].ontime-data.evts[n-1].ontime);
    }//endfor n

    vector<vector<double> > LP;//pos X tempoID
    vector<vector<vector<vector<int> > > > amax;//amax[n][pos][tempoID][0]と...[1]は(pos,tempoID)に対応。
    double logP;

////初期確率
    LP.resize(numStates);
    for(int iN=0;iN<numStates;iN+=1){
      LP[iN].resize(numTempoState);
      for(int iT=0;iT<numTempoState;iT+=1){
        LP[iN][iT]=trIniProb.LP[iN]+tempoTrIniProb.LP[iT];
      }//endfor iT
    }//endfor iN
    amax.resize(iois.size());
    for(int n=0;n<iois.size();n+=1){
      amax[n].resize(numStates);
      for(int iN=0;iN<numStates;iN+=1){
        amax[n][iN].resize(numTempoState);
        for(int iT=0;iT<numTempoState;iT+=1){
          amax[n][iN][iT].resize(2);
        }//endfor iT
      }//endfor iN
    }//endfor n

    for(int n=0;n<iois.size();n+=1){
cout<<"###### data sample "<<(n+1)<<"/"<<iois.size()<<endl;
      vector<vector<double> > preLP=LP;

      int jN,iN;
      for(int i=0;i<effGrids.size();i+=1){//jN,jT -> iN,iT
      for(int iT=0;iT<numTempoState;iT+=1){

        iN=effGrids[i];
        LP[iN][iT]=preLP[0][0]+trProb[0].LP[iN]+tempoTrProb[0].LP[iT]+OutputLP(0,iN,iT,iois[n]);
        amax[n][iN][iT][0]=0;
        amax[n][iN][iT][1]=0;

        for(int j=0;j<effGridIntervals[i].size();j+=1){
        for(int jT=0;jT<numTempoState;jT+=1){
            jN=effGrids[j];
            logP=preLP[jN][jT]+trProb[jN].LP[iN]+tempoTrProb[jT].LP[iT]+OutputLP(jN,iN,iT,iois[n]);
            if(logP>LP[iN][iT]){
              LP[iN][iT]=logP;
              amax[n][iN][iT][0]=jN;
              amax[n][iN][iT][1]=jT;
            }//endif

        }//endfor jT
        }//endfor jN

      }//endfor iT
      }//endfor iN
    }//endfor n

    vector<vector<int> > maxPath;//(maxPath[n][0],maxPath[n][1])は(pos,tempoID)を表す

    maxPath.resize(iois.size()+1);
    for(int n=0;n<iois.size()+1;n+=1){
      maxPath[n].resize(2);
    }//endfor n
    double max=LP[0][0];
    maxPath[iois.size()][0]=0;
    maxPath[iois.size()][1]=0;
    for(int i=0;i<effGrids.size();i+=1){
    for(int iT=0;iT<numTempoState;iT+=1){
      int iN=effGrids[i];
      if(LP[iN][iT]>max){
        max=LP[iN][iT];
        maxPath[iois.size()][0]=iN;
        maxPath[iois.size()][1]=iT;
      }//endif
    }//endfor iT
    }//endfor iN
    for(int n=iois.size()-1;n>=0;n-=1){
      maxPath[n][0]=amax[n][maxPath[n+1][0]][maxPath[n+1][1]][0];
      maxPath[n][1]=amax[n][maxPath[n+1][0]][maxPath[n+1][1]][1];
    }//endfor n
  data.logP=max;
  data.evts[0].stime=0;
  data.evts[0].dur=-1;
  for(int n=1;n<iois.size()+1;n+=1){
    int nv=maxPath[n][0]%numMetricalPos-maxPath[n-1][0]%numMetricalPos+(maxPath[n][0]/numMetricalPos)*numMetricalPos;
    data.evts[n].stime=data.evts[n-1].stime+nv;
    data.evts[n].dur=-1;
  }//endfor n

if(printOn){cout<<"###Viterbi END###"<<endl;}
  }//end Viterbi

  void WriteFile(string filename){
    data.WriteFile(filename);
  }//end WriteFile

};//end class MetricalHMM_duple


class MetricalHMM_triple{
public:
  int TPQN;
  Transcr data;

  int numMetricalPos;
  int numBarJump;
  int numStates;//=numMetricalPos*numBarJump, metPos=state%numMetricalPos, barJump=state/numMetricalPos

  vector<Prob> trProb;//s_n -> s_n+1
  Prob trIniProb;
  vector<Prob> trMetProb;//s_n -> s_n+1
  Prob barJumpProb;

  vector<int> effGrids;//effGrids[i] is an allowed position on the grid
  vector<vector<int> > effGridIntervals;//effGridIntervals[i][j] is the position effGrids[j] of an allowed interval effGrids[j]->effGrids[i]

  double Sigma_t;//オンセット時刻のノイズの分散
  double lambda;//chordalIOIのscale parameter
  vector<double> secPerQN;
  vector<Prob> tempoTrProb;
  Prob tempoTrIniProb;
  int numTempoState;
  double minSecPerQN,maxSeqPerQN;
  int truncatedWidth;
  double outerLP;
  double fac_t;

  MetricalHMM_triple(){
    Init();
  }//end MetricalHMM_triple
  ~MetricalHMM_triple(){
  }//end ~MetricalHMM_triple

  void Init(){
if(printOn){cout<<"###Init###"<<endl;}

    TPQN=24;
    numMetricalPos=72;
    numBarJump=4;
    numStates=numMetricalPos*numBarJump;

    trMetProb.resize(numMetricalPos);
    for(int i=0;i<numMetricalPos;i+=1){
      trMetProb[i].P.assign(numMetricalPos,1E-10);
    }//endfor i
    barJumpProb.P.assign(numBarJump,1E-10);

    trProb.resize(numStates);
    for(int i=0;i<numStates;i+=1){
      trProb[i].P.assign(numStates,1E-10);
    }//endfor i
    trIniProb.P.assign(numStates,1E-10);

		barJumpProb.P[0]=0.992632;
		barJumpProb.P[1]=0.00673178;
		barJumpProb.P[2]=0.000585041;
		barJumpProb.P[3]=5.16462e-05;
		trMetProb[0].P[0]=0.667592;			trMetProb[0].P[1]=2.86605e-06;			trMetProb[0].P[2]=3.15266e-05;			trMetProb[0].P[3]=0.00370007;			trMetProb[0].P[4]=0.00152187;			trMetProb[0].P[5]=2.86605e-06;			trMetProb[0].P[6]=0.0233039;			trMetProb[0].P[7]=2.86605e-06;			trMetProb[0].P[8]=0.011983;			trMetProb[0].P[9]=0.000633398;			trMetProb[0].P[10]=2.86605e-06;			trMetProb[0].P[11]=2.86605e-06;			trMetProb[0].P[12]=0.0997988;			trMetProb[0].P[13]=2.86605e-06;			trMetProb[0].P[14]=2.86605e-06;			trMetProb[0].P[15]=8.88476e-05;			trMetProb[0].P[16]=2.86605e-06;			trMetProb[0].P[17]=2.86605e-06;			trMetProb[0].P[18]=0.00536238;			trMetProb[0].P[19]=2.86605e-06;			trMetProb[0].P[20]=2.86605e-06;			trMetProb[0].P[21]=0.000117508;			trMetProb[0].P[22]=2.86605e-06;			trMetProb[0].P[23]=2.86605e-06;			trMetProb[0].P[24]=0.142274;			trMetProb[0].P[25]=2.86605e-06;			trMetProb[0].P[26]=2.86605e-06;			trMetProb[0].P[27]=2.86605e-06;			trMetProb[0].P[28]=3.15266e-05;			trMetProb[0].P[29]=2.86605e-06;			trMetProb[0].P[30]=8.88476e-05;			trMetProb[0].P[31]=2.86605e-06;			trMetProb[0].P[32]=2.86605e-06;			trMetProb[0].P[33]=2.86605e-06;			trMetProb[0].P[34]=2.86605e-06;			trMetProb[0].P[35]=2.86605e-06;			trMetProb[0].P[36]=0.00530506;			trMetProb[0].P[37]=2.86605e-06;			trMetProb[0].P[38]=2.86605e-06;			trMetProb[0].P[39]=2.86605e-06;			trMetProb[0].P[40]=2.86605e-06;			trMetProb[0].P[41]=2.86605e-06;			trMetProb[0].P[42]=0.000346792;			trMetProb[0].P[43]=2.86605e-06;			trMetProb[0].P[44]=2.86605e-06;			trMetProb[0].P[45]=2.86605e-06;			trMetProb[0].P[46]=2.86605e-06;			trMetProb[0].P[47]=2.86605e-06;			trMetProb[0].P[48]=0.0373762;			trMetProb[0].P[49]=2.86605e-06;			trMetProb[0].P[50]=2.86605e-06;			trMetProb[0].P[51]=2.86605e-06;			trMetProb[0].P[52]=2.86605e-06;			trMetProb[0].P[53]=2.86605e-06;			trMetProb[0].P[54]=2.86605e-06;			trMetProb[0].P[55]=2.86605e-06;			trMetProb[0].P[56]=2.86605e-06;			trMetProb[0].P[57]=2.86605e-06;			trMetProb[0].P[58]=2.86605e-06;			trMetProb[0].P[59]=2.86605e-06;			trMetProb[0].P[60]=0.000289471;			trMetProb[0].P[61]=2.86605e-06;			trMetProb[0].P[62]=2.86605e-06;			trMetProb[0].P[63]=2.86605e-06;			trMetProb[0].P[64]=2.86605e-06;			trMetProb[0].P[65]=2.86605e-06;			trMetProb[0].P[66]=2.86605e-06;			trMetProb[0].P[67]=2.86605e-06;			trMetProb[0].P[68]=2.86605e-06;			trMetProb[0].P[69]=2.86605e-06;			trMetProb[0].P[70]=2.86605e-06;			trMetProb[0].P[71]=2.86605e-06;	
		trMetProb[1].P[0]=0.0138889;			trMetProb[1].P[1]=0.0138889;			trMetProb[1].P[2]=0.0138889;			trMetProb[1].P[3]=0.0138889;			trMetProb[1].P[4]=0.0138889;			trMetProb[1].P[5]=0.0138889;			trMetProb[1].P[6]=0.0138889;			trMetProb[1].P[7]=0.0138889;			trMetProb[1].P[8]=0.0138889;			trMetProb[1].P[9]=0.0138889;			trMetProb[1].P[10]=0.0138889;			trMetProb[1].P[11]=0.0138889;			trMetProb[1].P[12]=0.0138889;			trMetProb[1].P[13]=0.0138889;			trMetProb[1].P[14]=0.0138889;			trMetProb[1].P[15]=0.0138889;			trMetProb[1].P[16]=0.0138889;			trMetProb[1].P[17]=0.0138889;			trMetProb[1].P[18]=0.0138889;			trMetProb[1].P[19]=0.0138889;			trMetProb[1].P[20]=0.0138889;			trMetProb[1].P[21]=0.0138889;			trMetProb[1].P[22]=0.0138889;			trMetProb[1].P[23]=0.0138889;			trMetProb[1].P[24]=0.0138889;			trMetProb[1].P[25]=0.0138889;			trMetProb[1].P[26]=0.0138889;			trMetProb[1].P[27]=0.0138889;			trMetProb[1].P[28]=0.0138889;			trMetProb[1].P[29]=0.0138889;			trMetProb[1].P[30]=0.0138889;			trMetProb[1].P[31]=0.0138889;			trMetProb[1].P[32]=0.0138889;			trMetProb[1].P[33]=0.0138889;			trMetProb[1].P[34]=0.0138889;			trMetProb[1].P[35]=0.0138889;			trMetProb[1].P[36]=0.0138889;			trMetProb[1].P[37]=0.0138889;			trMetProb[1].P[38]=0.0138889;			trMetProb[1].P[39]=0.0138889;			trMetProb[1].P[40]=0.0138889;			trMetProb[1].P[41]=0.0138889;			trMetProb[1].P[42]=0.0138889;			trMetProb[1].P[43]=0.0138889;			trMetProb[1].P[44]=0.0138889;			trMetProb[1].P[45]=0.0138889;			trMetProb[1].P[46]=0.0138889;			trMetProb[1].P[47]=0.0138889;			trMetProb[1].P[48]=0.0138889;			trMetProb[1].P[49]=0.0138889;			trMetProb[1].P[50]=0.0138889;			trMetProb[1].P[51]=0.0138889;			trMetProb[1].P[52]=0.0138889;			trMetProb[1].P[53]=0.0138889;			trMetProb[1].P[54]=0.0138889;			trMetProb[1].P[55]=0.0138889;			trMetProb[1].P[56]=0.0138889;			trMetProb[1].P[57]=0.0138889;			trMetProb[1].P[58]=0.0138889;			trMetProb[1].P[59]=0.0138889;			trMetProb[1].P[60]=0.0138889;			trMetProb[1].P[61]=0.0138889;			trMetProb[1].P[62]=0.0138889;			trMetProb[1].P[63]=0.0138889;			trMetProb[1].P[64]=0.0138889;			trMetProb[1].P[65]=0.0138889;			trMetProb[1].P[66]=0.0138889;			trMetProb[1].P[67]=0.0138889;			trMetProb[1].P[68]=0.0138889;			trMetProb[1].P[69]=0.0138889;			trMetProb[1].P[70]=0.0138889;			trMetProb[1].P[71]=0.0138889;	
		trMetProb[2].P[0]=0.0121951;			trMetProb[2].P[1]=0.0121951;			trMetProb[2].P[2]=0.0121951;			trMetProb[2].P[3]=0.0121951;			trMetProb[2].P[4]=0.134146;			trMetProb[2].P[5]=0.0121951;			trMetProb[2].P[6]=0.0121951;			trMetProb[2].P[7]=0.0121951;			trMetProb[2].P[8]=0.0121951;			trMetProb[2].P[9]=0.0121951;			trMetProb[2].P[10]=0.0121951;			trMetProb[2].P[11]=0.0121951;			trMetProb[2].P[12]=0.0121951;			trMetProb[2].P[13]=0.0121951;			trMetProb[2].P[14]=0.0121951;			trMetProb[2].P[15]=0.0121951;			trMetProb[2].P[16]=0.0121951;			trMetProb[2].P[17]=0.0121951;			trMetProb[2].P[18]=0.0121951;			trMetProb[2].P[19]=0.0121951;			trMetProb[2].P[20]=0.0121951;			trMetProb[2].P[21]=0.0121951;			trMetProb[2].P[22]=0.0121951;			trMetProb[2].P[23]=0.0121951;			trMetProb[2].P[24]=0.0121951;			trMetProb[2].P[25]=0.0121951;			trMetProb[2].P[26]=0.0121951;			trMetProb[2].P[27]=0.0121951;			trMetProb[2].P[28]=0.0121951;			trMetProb[2].P[29]=0.0121951;			trMetProb[2].P[30]=0.0121951;			trMetProb[2].P[31]=0.0121951;			trMetProb[2].P[32]=0.0121951;			trMetProb[2].P[33]=0.0121951;			trMetProb[2].P[34]=0.0121951;			trMetProb[2].P[35]=0.0121951;			trMetProb[2].P[36]=0.0121951;			trMetProb[2].P[37]=0.0121951;			trMetProb[2].P[38]=0.0121951;			trMetProb[2].P[39]=0.0121951;			trMetProb[2].P[40]=0.0121951;			trMetProb[2].P[41]=0.0121951;			trMetProb[2].P[42]=0.0121951;			trMetProb[2].P[43]=0.0121951;			trMetProb[2].P[44]=0.0121951;			trMetProb[2].P[45]=0.0121951;			trMetProb[2].P[46]=0.0121951;			trMetProb[2].P[47]=0.0121951;			trMetProb[2].P[48]=0.0121951;			trMetProb[2].P[49]=0.0121951;			trMetProb[2].P[50]=0.0121951;			trMetProb[2].P[51]=0.0121951;			trMetProb[2].P[52]=0.0121951;			trMetProb[2].P[53]=0.0121951;			trMetProb[2].P[54]=0.0121951;			trMetProb[2].P[55]=0.0121951;			trMetProb[2].P[56]=0.0121951;			trMetProb[2].P[57]=0.0121951;			trMetProb[2].P[58]=0.0121951;			trMetProb[2].P[59]=0.0121951;			trMetProb[2].P[60]=0.0121951;			trMetProb[2].P[61]=0.0121951;			trMetProb[2].P[62]=0.0121951;			trMetProb[2].P[63]=0.0121951;			trMetProb[2].P[64]=0.0121951;			trMetProb[2].P[65]=0.0121951;			trMetProb[2].P[66]=0.0121951;			trMetProb[2].P[67]=0.0121951;			trMetProb[2].P[68]=0.0121951;			trMetProb[2].P[69]=0.0121951;			trMetProb[2].P[70]=0.0121951;			trMetProb[2].P[71]=0.0121951;	
		trMetProb[3].P[0]=0.000620347;			trMetProb[3].P[1]=0.000620347;			trMetProb[3].P[2]=0.000620347;			trMetProb[3].P[3]=0.161911;			trMetProb[3].P[4]=0.000620347;			trMetProb[3].P[5]=0.000620347;			trMetProb[3].P[6]=0.745037;			trMetProb[3].P[7]=0.000620347;			trMetProb[3].P[8]=0.000620347;			trMetProb[3].P[9]=0.000620347;			trMetProb[3].P[10]=0.000620347;			trMetProb[3].P[11]=0.000620347;			trMetProb[3].P[12]=0.0502481;			trMetProb[3].P[13]=0.000620347;			trMetProb[3].P[14]=0.000620347;			trMetProb[3].P[15]=0.000620347;			trMetProb[3].P[16]=0.000620347;			trMetProb[3].P[17]=0.000620347;			trMetProb[3].P[18]=0.000620347;			trMetProb[3].P[19]=0.000620347;			trMetProb[3].P[20]=0.000620347;			trMetProb[3].P[21]=0.000620347;			trMetProb[3].P[22]=0.000620347;			trMetProb[3].P[23]=0.000620347;			trMetProb[3].P[24]=0.000620347;			trMetProb[3].P[25]=0.000620347;			trMetProb[3].P[26]=0.000620347;			trMetProb[3].P[27]=0.000620347;			trMetProb[3].P[28]=0.000620347;			trMetProb[3].P[29]=0.000620347;			trMetProb[3].P[30]=0.000620347;			trMetProb[3].P[31]=0.000620347;			trMetProb[3].P[32]=0.000620347;			trMetProb[3].P[33]=0.000620347;			trMetProb[3].P[34]=0.000620347;			trMetProb[3].P[35]=0.000620347;			trMetProb[3].P[36]=0.000620347;			trMetProb[3].P[37]=0.000620347;			trMetProb[3].P[38]=0.000620347;			trMetProb[3].P[39]=0.000620347;			trMetProb[3].P[40]=0.000620347;			trMetProb[3].P[41]=0.000620347;			trMetProb[3].P[42]=0.000620347;			trMetProb[3].P[43]=0.000620347;			trMetProb[3].P[44]=0.000620347;			trMetProb[3].P[45]=0.000620347;			trMetProb[3].P[46]=0.000620347;			trMetProb[3].P[47]=0.000620347;			trMetProb[3].P[48]=0.000620347;			trMetProb[3].P[49]=0.000620347;			trMetProb[3].P[50]=0.000620347;			trMetProb[3].P[51]=0.000620347;			trMetProb[3].P[52]=0.000620347;			trMetProb[3].P[53]=0.000620347;			trMetProb[3].P[54]=0.000620347;			trMetProb[3].P[55]=0.000620347;			trMetProb[3].P[56]=0.000620347;			trMetProb[3].P[57]=0.000620347;			trMetProb[3].P[58]=0.000620347;			trMetProb[3].P[59]=0.000620347;			trMetProb[3].P[60]=0.000620347;			trMetProb[3].P[61]=0.000620347;			trMetProb[3].P[62]=0.000620347;			trMetProb[3].P[63]=0.000620347;			trMetProb[3].P[64]=0.000620347;			trMetProb[3].P[65]=0.000620347;			trMetProb[3].P[66]=0.000620347;			trMetProb[3].P[67]=0.000620347;			trMetProb[3].P[68]=0.000620347;			trMetProb[3].P[69]=0.000620347;			trMetProb[3].P[70]=0.000620347;			trMetProb[3].P[71]=0.000620347;	
		trMetProb[4].P[0]=0.00160772;			trMetProb[4].P[1]=0.00160772;			trMetProb[4].P[2]=0.00160772;			trMetProb[4].P[3]=0.00160772;			trMetProb[4].P[4]=0.0176849;			trMetProb[4].P[5]=0.00160772;			trMetProb[4].P[6]=0.0337621;			trMetProb[4].P[7]=0.00160772;			trMetProb[4].P[8]=0.837621;			trMetProb[4].P[9]=0.00160772;			trMetProb[4].P[10]=0.00160772;			trMetProb[4].P[11]=0.00160772;			trMetProb[4].P[12]=0.00160772;			trMetProb[4].P[13]=0.00160772;			trMetProb[4].P[14]=0.00160772;			trMetProb[4].P[15]=0.00160772;			trMetProb[4].P[16]=0.00160772;			trMetProb[4].P[17]=0.00160772;			trMetProb[4].P[18]=0.00160772;			trMetProb[4].P[19]=0.00160772;			trMetProb[4].P[20]=0.00160772;			trMetProb[4].P[21]=0.00160772;			trMetProb[4].P[22]=0.00160772;			trMetProb[4].P[23]=0.00160772;			trMetProb[4].P[24]=0.00160772;			trMetProb[4].P[25]=0.00160772;			trMetProb[4].P[26]=0.00160772;			trMetProb[4].P[27]=0.00160772;			trMetProb[4].P[28]=0.00160772;			trMetProb[4].P[29]=0.00160772;			trMetProb[4].P[30]=0.00160772;			trMetProb[4].P[31]=0.00160772;			trMetProb[4].P[32]=0.00160772;			trMetProb[4].P[33]=0.00160772;			trMetProb[4].P[34]=0.00160772;			trMetProb[4].P[35]=0.00160772;			trMetProb[4].P[36]=0.00160772;			trMetProb[4].P[37]=0.00160772;			trMetProb[4].P[38]=0.00160772;			trMetProb[4].P[39]=0.00160772;			trMetProb[4].P[40]=0.00160772;			trMetProb[4].P[41]=0.00160772;			trMetProb[4].P[42]=0.00160772;			trMetProb[4].P[43]=0.00160772;			trMetProb[4].P[44]=0.00160772;			trMetProb[4].P[45]=0.00160772;			trMetProb[4].P[46]=0.00160772;			trMetProb[4].P[47]=0.00160772;			trMetProb[4].P[48]=0.00160772;			trMetProb[4].P[49]=0.00160772;			trMetProb[4].P[50]=0.00160772;			trMetProb[4].P[51]=0.00160772;			trMetProb[4].P[52]=0.00160772;			trMetProb[4].P[53]=0.00160772;			trMetProb[4].P[54]=0.00160772;			trMetProb[4].P[55]=0.00160772;			trMetProb[4].P[56]=0.00160772;			trMetProb[4].P[57]=0.00160772;			trMetProb[4].P[58]=0.00160772;			trMetProb[4].P[59]=0.00160772;			trMetProb[4].P[60]=0.00160772;			trMetProb[4].P[61]=0.00160772;			trMetProb[4].P[62]=0.00160772;			trMetProb[4].P[63]=0.00160772;			trMetProb[4].P[64]=0.00160772;			trMetProb[4].P[65]=0.00160772;			trMetProb[4].P[66]=0.00160772;			trMetProb[4].P[67]=0.00160772;			trMetProb[4].P[68]=0.00160772;			trMetProb[4].P[69]=0.00160772;			trMetProb[4].P[70]=0.00160772;			trMetProb[4].P[71]=0.00160772;	
		trMetProb[5].P[0]=0.0138889;			trMetProb[5].P[1]=0.0138889;			trMetProb[5].P[2]=0.0138889;			trMetProb[5].P[3]=0.0138889;			trMetProb[5].P[4]=0.0138889;			trMetProb[5].P[5]=0.0138889;			trMetProb[5].P[6]=0.0138889;			trMetProb[5].P[7]=0.0138889;			trMetProb[5].P[8]=0.0138889;			trMetProb[5].P[9]=0.0138889;			trMetProb[5].P[10]=0.0138889;			trMetProb[5].P[11]=0.0138889;			trMetProb[5].P[12]=0.0138889;			trMetProb[5].P[13]=0.0138889;			trMetProb[5].P[14]=0.0138889;			trMetProb[5].P[15]=0.0138889;			trMetProb[5].P[16]=0.0138889;			trMetProb[5].P[17]=0.0138889;			trMetProb[5].P[18]=0.0138889;			trMetProb[5].P[19]=0.0138889;			trMetProb[5].P[20]=0.0138889;			trMetProb[5].P[21]=0.0138889;			trMetProb[5].P[22]=0.0138889;			trMetProb[5].P[23]=0.0138889;			trMetProb[5].P[24]=0.0138889;			trMetProb[5].P[25]=0.0138889;			trMetProb[5].P[26]=0.0138889;			trMetProb[5].P[27]=0.0138889;			trMetProb[5].P[28]=0.0138889;			trMetProb[5].P[29]=0.0138889;			trMetProb[5].P[30]=0.0138889;			trMetProb[5].P[31]=0.0138889;			trMetProb[5].P[32]=0.0138889;			trMetProb[5].P[33]=0.0138889;			trMetProb[5].P[34]=0.0138889;			trMetProb[5].P[35]=0.0138889;			trMetProb[5].P[36]=0.0138889;			trMetProb[5].P[37]=0.0138889;			trMetProb[5].P[38]=0.0138889;			trMetProb[5].P[39]=0.0138889;			trMetProb[5].P[40]=0.0138889;			trMetProb[5].P[41]=0.0138889;			trMetProb[5].P[42]=0.0138889;			trMetProb[5].P[43]=0.0138889;			trMetProb[5].P[44]=0.0138889;			trMetProb[5].P[45]=0.0138889;			trMetProb[5].P[46]=0.0138889;			trMetProb[5].P[47]=0.0138889;			trMetProb[5].P[48]=0.0138889;			trMetProb[5].P[49]=0.0138889;			trMetProb[5].P[50]=0.0138889;			trMetProb[5].P[51]=0.0138889;			trMetProb[5].P[52]=0.0138889;			trMetProb[5].P[53]=0.0138889;			trMetProb[5].P[54]=0.0138889;			trMetProb[5].P[55]=0.0138889;			trMetProb[5].P[56]=0.0138889;			trMetProb[5].P[57]=0.0138889;			trMetProb[5].P[58]=0.0138889;			trMetProb[5].P[59]=0.0138889;			trMetProb[5].P[60]=0.0138889;			trMetProb[5].P[61]=0.0138889;			trMetProb[5].P[62]=0.0138889;			trMetProb[5].P[63]=0.0138889;			trMetProb[5].P[64]=0.0138889;			trMetProb[5].P[65]=0.0138889;			trMetProb[5].P[66]=0.0138889;			trMetProb[5].P[67]=0.0138889;			trMetProb[5].P[68]=0.0138889;			trMetProb[5].P[69]=0.0138889;			trMetProb[5].P[70]=0.0138889;			trMetProb[5].P[71]=0.0138889;	
		trMetProb[6].P[0]=8.45166e-05;			trMetProb[6].P[1]=8.45166e-05;			trMetProb[6].P[2]=8.45166e-05;			trMetProb[6].P[3]=8.45166e-05;			trMetProb[6].P[4]=8.45166e-05;			trMetProb[6].P[5]=8.45166e-05;			trMetProb[6].P[6]=0.204615;			trMetProb[6].P[7]=8.45166e-05;			trMetProb[6].P[8]=0.00262001;			trMetProb[6].P[9]=0.104885;			trMetProb[6].P[10]=8.45166e-05;			trMetProb[6].P[11]=8.45166e-05;			trMetProb[6].P[12]=0.676217;			trMetProb[6].P[13]=8.45166e-05;			trMetProb[6].P[14]=8.45166e-05;			trMetProb[6].P[15]=8.45166e-05;			trMetProb[6].P[16]=8.45166e-05;			trMetProb[6].P[17]=8.45166e-05;			trMetProb[6].P[18]=0.000929682;			trMetProb[6].P[19]=8.45166e-05;			trMetProb[6].P[20]=8.45166e-05;			trMetProb[6].P[21]=8.45166e-05;			trMetProb[6].P[22]=8.45166e-05;			trMetProb[6].P[23]=8.45166e-05;			trMetProb[6].P[24]=0.00346518;			trMetProb[6].P[25]=8.45166e-05;			trMetProb[6].P[26]=8.45166e-05;			trMetProb[6].P[27]=8.45166e-05;			trMetProb[6].P[28]=8.45166e-05;			trMetProb[6].P[29]=8.45166e-05;			trMetProb[6].P[30]=8.45166e-05;			trMetProb[6].P[31]=8.45166e-05;			trMetProb[6].P[32]=8.45166e-05;			trMetProb[6].P[33]=8.45166e-05;			trMetProb[6].P[34]=8.45166e-05;			trMetProb[6].P[35]=8.45166e-05;			trMetProb[6].P[36]=8.45166e-05;			trMetProb[6].P[37]=8.45166e-05;			trMetProb[6].P[38]=8.45166e-05;			trMetProb[6].P[39]=8.45166e-05;			trMetProb[6].P[40]=8.45166e-05;			trMetProb[6].P[41]=8.45166e-05;			trMetProb[6].P[42]=8.45166e-05;			trMetProb[6].P[43]=8.45166e-05;			trMetProb[6].P[44]=8.45166e-05;			trMetProb[6].P[45]=8.45166e-05;			trMetProb[6].P[46]=8.45166e-05;			trMetProb[6].P[47]=8.45166e-05;			trMetProb[6].P[48]=0.00177485;			trMetProb[6].P[49]=8.45166e-05;			trMetProb[6].P[50]=8.45166e-05;			trMetProb[6].P[51]=8.45166e-05;			trMetProb[6].P[52]=8.45166e-05;			trMetProb[6].P[53]=8.45166e-05;			trMetProb[6].P[54]=8.45166e-05;			trMetProb[6].P[55]=8.45166e-05;			trMetProb[6].P[56]=8.45166e-05;			trMetProb[6].P[57]=8.45166e-05;			trMetProb[6].P[58]=8.45166e-05;			trMetProb[6].P[59]=8.45166e-05;			trMetProb[6].P[60]=8.45166e-05;			trMetProb[6].P[61]=8.45166e-05;			trMetProb[6].P[62]=8.45166e-05;			trMetProb[6].P[63]=8.45166e-05;			trMetProb[6].P[64]=8.45166e-05;			trMetProb[6].P[65]=8.45166e-05;			trMetProb[6].P[66]=8.45166e-05;			trMetProb[6].P[67]=8.45166e-05;			trMetProb[6].P[68]=8.45166e-05;			trMetProb[6].P[69]=8.45166e-05;			trMetProb[6].P[70]=8.45166e-05;			trMetProb[6].P[71]=8.45166e-05;	
		trMetProb[7].P[0]=0.0138889;			trMetProb[7].P[1]=0.0138889;			trMetProb[7].P[2]=0.0138889;			trMetProb[7].P[3]=0.0138889;			trMetProb[7].P[4]=0.0138889;			trMetProb[7].P[5]=0.0138889;			trMetProb[7].P[6]=0.0138889;			trMetProb[7].P[7]=0.0138889;			trMetProb[7].P[8]=0.0138889;			trMetProb[7].P[9]=0.0138889;			trMetProb[7].P[10]=0.0138889;			trMetProb[7].P[11]=0.0138889;			trMetProb[7].P[12]=0.0138889;			trMetProb[7].P[13]=0.0138889;			trMetProb[7].P[14]=0.0138889;			trMetProb[7].P[15]=0.0138889;			trMetProb[7].P[16]=0.0138889;			trMetProb[7].P[17]=0.0138889;			trMetProb[7].P[18]=0.0138889;			trMetProb[7].P[19]=0.0138889;			trMetProb[7].P[20]=0.0138889;			trMetProb[7].P[21]=0.0138889;			trMetProb[7].P[22]=0.0138889;			trMetProb[7].P[23]=0.0138889;			trMetProb[7].P[24]=0.0138889;			trMetProb[7].P[25]=0.0138889;			trMetProb[7].P[26]=0.0138889;			trMetProb[7].P[27]=0.0138889;			trMetProb[7].P[28]=0.0138889;			trMetProb[7].P[29]=0.0138889;			trMetProb[7].P[30]=0.0138889;			trMetProb[7].P[31]=0.0138889;			trMetProb[7].P[32]=0.0138889;			trMetProb[7].P[33]=0.0138889;			trMetProb[7].P[34]=0.0138889;			trMetProb[7].P[35]=0.0138889;			trMetProb[7].P[36]=0.0138889;			trMetProb[7].P[37]=0.0138889;			trMetProb[7].P[38]=0.0138889;			trMetProb[7].P[39]=0.0138889;			trMetProb[7].P[40]=0.0138889;			trMetProb[7].P[41]=0.0138889;			trMetProb[7].P[42]=0.0138889;			trMetProb[7].P[43]=0.0138889;			trMetProb[7].P[44]=0.0138889;			trMetProb[7].P[45]=0.0138889;			trMetProb[7].P[46]=0.0138889;			trMetProb[7].P[47]=0.0138889;			trMetProb[7].P[48]=0.0138889;			trMetProb[7].P[49]=0.0138889;			trMetProb[7].P[50]=0.0138889;			trMetProb[7].P[51]=0.0138889;			trMetProb[7].P[52]=0.0138889;			trMetProb[7].P[53]=0.0138889;			trMetProb[7].P[54]=0.0138889;			trMetProb[7].P[55]=0.0138889;			trMetProb[7].P[56]=0.0138889;			trMetProb[7].P[57]=0.0138889;			trMetProb[7].P[58]=0.0138889;			trMetProb[7].P[59]=0.0138889;			trMetProb[7].P[60]=0.0138889;			trMetProb[7].P[61]=0.0138889;			trMetProb[7].P[62]=0.0138889;			trMetProb[7].P[63]=0.0138889;			trMetProb[7].P[64]=0.0138889;			trMetProb[7].P[65]=0.0138889;			trMetProb[7].P[66]=0.0138889;			trMetProb[7].P[67]=0.0138889;			trMetProb[7].P[68]=0.0138889;			trMetProb[7].P[69]=0.0138889;			trMetProb[7].P[70]=0.0138889;			trMetProb[7].P[71]=0.0138889;	
		trMetProb[8].P[0]=0.00017001;			trMetProb[8].P[1]=0.00017001;			trMetProb[8].P[2]=0.00017001;			trMetProb[8].P[3]=0.00017001;			trMetProb[8].P[4]=0.00017001;			trMetProb[8].P[5]=0.00017001;			trMetProb[8].P[6]=0.00017001;			trMetProb[8].P[7]=0.00017001;			trMetProb[8].P[8]=0.178681;			trMetProb[8].P[9]=0.00527032;			trMetProb[8].P[10]=0.00357021;			trMetProb[8].P[11]=0.00017001;			trMetProb[8].P[12]=0.0987759;			trMetProb[8].P[13]=0.00017001;			trMetProb[8].P[14]=0.00017001;			trMetProb[8].P[15]=0.00017001;			trMetProb[8].P[16]=0.702312;			trMetProb[8].P[17]=0.00017001;			trMetProb[8].P[18]=0.00017001;			trMetProb[8].P[19]=0.00017001;			trMetProb[8].P[20]=0.00017001;			trMetProb[8].P[21]=0.00017001;			trMetProb[8].P[22]=0.00017001;			trMetProb[8].P[23]=0.00017001;			trMetProb[8].P[24]=0.00017001;			trMetProb[8].P[25]=0.00017001;			trMetProb[8].P[26]=0.00017001;			trMetProb[8].P[27]=0.00017001;			trMetProb[8].P[28]=0.00017001;			trMetProb[8].P[29]=0.00017001;			trMetProb[8].P[30]=0.00017001;			trMetProb[8].P[31]=0.00017001;			trMetProb[8].P[32]=0.00017001;			trMetProb[8].P[33]=0.00017001;			trMetProb[8].P[34]=0.00017001;			trMetProb[8].P[35]=0.00017001;			trMetProb[8].P[36]=0.00017001;			trMetProb[8].P[37]=0.00017001;			trMetProb[8].P[38]=0.00017001;			trMetProb[8].P[39]=0.00017001;			trMetProb[8].P[40]=0.00017001;			trMetProb[8].P[41]=0.00017001;			trMetProb[8].P[42]=0.00017001;			trMetProb[8].P[43]=0.00017001;			trMetProb[8].P[44]=0.00017001;			trMetProb[8].P[45]=0.00017001;			trMetProb[8].P[46]=0.00017001;			trMetProb[8].P[47]=0.00017001;			trMetProb[8].P[48]=0.00017001;			trMetProb[8].P[49]=0.00017001;			trMetProb[8].P[50]=0.00017001;			trMetProb[8].P[51]=0.00017001;			trMetProb[8].P[52]=0.00017001;			trMetProb[8].P[53]=0.00017001;			trMetProb[8].P[54]=0.00017001;			trMetProb[8].P[55]=0.00017001;			trMetProb[8].P[56]=0.00017001;			trMetProb[8].P[57]=0.00017001;			trMetProb[8].P[58]=0.00017001;			trMetProb[8].P[59]=0.00017001;			trMetProb[8].P[60]=0.00017001;			trMetProb[8].P[61]=0.00017001;			trMetProb[8].P[62]=0.00017001;			trMetProb[8].P[63]=0.00017001;			trMetProb[8].P[64]=0.00017001;			trMetProb[8].P[65]=0.00017001;			trMetProb[8].P[66]=0.00017001;			trMetProb[8].P[67]=0.00017001;			trMetProb[8].P[68]=0.00017001;			trMetProb[8].P[69]=0.00017001;			trMetProb[8].P[70]=0.00017001;			trMetProb[8].P[71]=0.00017001;	
		trMetProb[9].P[0]=0.000539957;			trMetProb[9].P[1]=0.000539957;			trMetProb[9].P[2]=0.000539957;			trMetProb[9].P[3]=0.000539957;			trMetProb[9].P[4]=0.000539957;			trMetProb[9].P[5]=0.000539957;			trMetProb[9].P[6]=0.000539957;			trMetProb[9].P[7]=0.000539957;			trMetProb[9].P[8]=0.000539957;			trMetProb[9].P[9]=0.173326;			trMetProb[9].P[10]=0.000539957;			trMetProb[9].P[11]=0.000539957;			trMetProb[9].P[12]=0.778078;			trMetProb[9].P[13]=0.000539957;			trMetProb[9].P[14]=0.000539957;			trMetProb[9].P[15]=0.000539957;			trMetProb[9].P[16]=0.000539957;			trMetProb[9].P[17]=0.000539957;			trMetProb[9].P[18]=0.0113391;			trMetProb[9].P[19]=0.000539957;			trMetProb[9].P[20]=0.000539957;			trMetProb[9].P[21]=0.000539957;			trMetProb[9].P[22]=0.000539957;			trMetProb[9].P[23]=0.000539957;			trMetProb[9].P[24]=0.000539957;			trMetProb[9].P[25]=0.000539957;			trMetProb[9].P[26]=0.000539957;			trMetProb[9].P[27]=0.000539957;			trMetProb[9].P[28]=0.000539957;			trMetProb[9].P[29]=0.000539957;			trMetProb[9].P[30]=0.000539957;			trMetProb[9].P[31]=0.000539957;			trMetProb[9].P[32]=0.000539957;			trMetProb[9].P[33]=0.000539957;			trMetProb[9].P[34]=0.000539957;			trMetProb[9].P[35]=0.000539957;			trMetProb[9].P[36]=0.000539957;			trMetProb[9].P[37]=0.000539957;			trMetProb[9].P[38]=0.000539957;			trMetProb[9].P[39]=0.000539957;			trMetProb[9].P[40]=0.000539957;			trMetProb[9].P[41]=0.000539957;			trMetProb[9].P[42]=0.000539957;			trMetProb[9].P[43]=0.000539957;			trMetProb[9].P[44]=0.000539957;			trMetProb[9].P[45]=0.000539957;			trMetProb[9].P[46]=0.000539957;			trMetProb[9].P[47]=0.000539957;			trMetProb[9].P[48]=0.000539957;			trMetProb[9].P[49]=0.000539957;			trMetProb[9].P[50]=0.000539957;			trMetProb[9].P[51]=0.000539957;			trMetProb[9].P[52]=0.000539957;			trMetProb[9].P[53]=0.000539957;			trMetProb[9].P[54]=0.000539957;			trMetProb[9].P[55]=0.000539957;			trMetProb[9].P[56]=0.000539957;			trMetProb[9].P[57]=0.000539957;			trMetProb[9].P[58]=0.000539957;			trMetProb[9].P[59]=0.000539957;			trMetProb[9].P[60]=0.000539957;			trMetProb[9].P[61]=0.000539957;			trMetProb[9].P[62]=0.000539957;			trMetProb[9].P[63]=0.000539957;			trMetProb[9].P[64]=0.000539957;			trMetProb[9].P[65]=0.000539957;			trMetProb[9].P[66]=0.000539957;			trMetProb[9].P[67]=0.000539957;			trMetProb[9].P[68]=0.000539957;			trMetProb[9].P[69]=0.000539957;			trMetProb[9].P[70]=0.000539957;			trMetProb[9].P[71]=0.000539957;	
		trMetProb[10].P[0]=0.0108696;			trMetProb[10].P[1]=0.0108696;			trMetProb[10].P[2]=0.0108696;			trMetProb[10].P[3]=0.0108696;			trMetProb[10].P[4]=0.0108696;			trMetProb[10].P[5]=0.0108696;			trMetProb[10].P[6]=0.0108696;			trMetProb[10].P[7]=0.0108696;			trMetProb[10].P[8]=0.0108696;			trMetProb[10].P[9]=0.0108696;			trMetProb[10].P[10]=0.0108696;			trMetProb[10].P[11]=0.0108696;			trMetProb[10].P[12]=0.228261;			trMetProb[10].P[13]=0.0108696;			trMetProb[10].P[14]=0.0108696;			trMetProb[10].P[15]=0.0108696;			trMetProb[10].P[16]=0.0108696;			trMetProb[10].P[17]=0.0108696;			trMetProb[10].P[18]=0.0108696;			trMetProb[10].P[19]=0.0108696;			trMetProb[10].P[20]=0.0108696;			trMetProb[10].P[21]=0.0108696;			trMetProb[10].P[22]=0.0108696;			trMetProb[10].P[23]=0.0108696;			trMetProb[10].P[24]=0.0108696;			trMetProb[10].P[25]=0.0108696;			trMetProb[10].P[26]=0.0108696;			trMetProb[10].P[27]=0.0108696;			trMetProb[10].P[28]=0.0108696;			trMetProb[10].P[29]=0.0108696;			trMetProb[10].P[30]=0.0108696;			trMetProb[10].P[31]=0.0108696;			trMetProb[10].P[32]=0.0108696;			trMetProb[10].P[33]=0.0108696;			trMetProb[10].P[34]=0.0108696;			trMetProb[10].P[35]=0.0108696;			trMetProb[10].P[36]=0.0108696;			trMetProb[10].P[37]=0.0108696;			trMetProb[10].P[38]=0.0108696;			trMetProb[10].P[39]=0.0108696;			trMetProb[10].P[40]=0.0108696;			trMetProb[10].P[41]=0.0108696;			trMetProb[10].P[42]=0.0108696;			trMetProb[10].P[43]=0.0108696;			trMetProb[10].P[44]=0.0108696;			trMetProb[10].P[45]=0.0108696;			trMetProb[10].P[46]=0.0108696;			trMetProb[10].P[47]=0.0108696;			trMetProb[10].P[48]=0.0108696;			trMetProb[10].P[49]=0.0108696;			trMetProb[10].P[50]=0.0108696;			trMetProb[10].P[51]=0.0108696;			trMetProb[10].P[52]=0.0108696;			trMetProb[10].P[53]=0.0108696;			trMetProb[10].P[54]=0.0108696;			trMetProb[10].P[55]=0.0108696;			trMetProb[10].P[56]=0.0108696;			trMetProb[10].P[57]=0.0108696;			trMetProb[10].P[58]=0.0108696;			trMetProb[10].P[59]=0.0108696;			trMetProb[10].P[60]=0.0108696;			trMetProb[10].P[61]=0.0108696;			trMetProb[10].P[62]=0.0108696;			trMetProb[10].P[63]=0.0108696;			trMetProb[10].P[64]=0.0108696;			trMetProb[10].P[65]=0.0108696;			trMetProb[10].P[66]=0.0108696;			trMetProb[10].P[67]=0.0108696;			trMetProb[10].P[68]=0.0108696;			trMetProb[10].P[69]=0.0108696;			trMetProb[10].P[70]=0.0108696;			trMetProb[10].P[71]=0.0108696;	
		trMetProb[11].P[0]=0.0138889;			trMetProb[11].P[1]=0.0138889;			trMetProb[11].P[2]=0.0138889;			trMetProb[11].P[3]=0.0138889;			trMetProb[11].P[4]=0.0138889;			trMetProb[11].P[5]=0.0138889;			trMetProb[11].P[6]=0.0138889;			trMetProb[11].P[7]=0.0138889;			trMetProb[11].P[8]=0.0138889;			trMetProb[11].P[9]=0.0138889;			trMetProb[11].P[10]=0.0138889;			trMetProb[11].P[11]=0.0138889;			trMetProb[11].P[12]=0.0138889;			trMetProb[11].P[13]=0.0138889;			trMetProb[11].P[14]=0.0138889;			trMetProb[11].P[15]=0.0138889;			trMetProb[11].P[16]=0.0138889;			trMetProb[11].P[17]=0.0138889;			trMetProb[11].P[18]=0.0138889;			trMetProb[11].P[19]=0.0138889;			trMetProb[11].P[20]=0.0138889;			trMetProb[11].P[21]=0.0138889;			trMetProb[11].P[22]=0.0138889;			trMetProb[11].P[23]=0.0138889;			trMetProb[11].P[24]=0.0138889;			trMetProb[11].P[25]=0.0138889;			trMetProb[11].P[26]=0.0138889;			trMetProb[11].P[27]=0.0138889;			trMetProb[11].P[28]=0.0138889;			trMetProb[11].P[29]=0.0138889;			trMetProb[11].P[30]=0.0138889;			trMetProb[11].P[31]=0.0138889;			trMetProb[11].P[32]=0.0138889;			trMetProb[11].P[33]=0.0138889;			trMetProb[11].P[34]=0.0138889;			trMetProb[11].P[35]=0.0138889;			trMetProb[11].P[36]=0.0138889;			trMetProb[11].P[37]=0.0138889;			trMetProb[11].P[38]=0.0138889;			trMetProb[11].P[39]=0.0138889;			trMetProb[11].P[40]=0.0138889;			trMetProb[11].P[41]=0.0138889;			trMetProb[11].P[42]=0.0138889;			trMetProb[11].P[43]=0.0138889;			trMetProb[11].P[44]=0.0138889;			trMetProb[11].P[45]=0.0138889;			trMetProb[11].P[46]=0.0138889;			trMetProb[11].P[47]=0.0138889;			trMetProb[11].P[48]=0.0138889;			trMetProb[11].P[49]=0.0138889;			trMetProb[11].P[50]=0.0138889;			trMetProb[11].P[51]=0.0138889;			trMetProb[11].P[52]=0.0138889;			trMetProb[11].P[53]=0.0138889;			trMetProb[11].P[54]=0.0138889;			trMetProb[11].P[55]=0.0138889;			trMetProb[11].P[56]=0.0138889;			trMetProb[11].P[57]=0.0138889;			trMetProb[11].P[58]=0.0138889;			trMetProb[11].P[59]=0.0138889;			trMetProb[11].P[60]=0.0138889;			trMetProb[11].P[61]=0.0138889;			trMetProb[11].P[62]=0.0138889;			trMetProb[11].P[63]=0.0138889;			trMetProb[11].P[64]=0.0138889;			trMetProb[11].P[65]=0.0138889;			trMetProb[11].P[66]=0.0138889;			trMetProb[11].P[67]=0.0138889;			trMetProb[11].P[68]=0.0138889;			trMetProb[11].P[69]=0.0138889;			trMetProb[11].P[70]=0.0138889;			trMetProb[11].P[71]=0.0138889;	
		trMetProb[12].P[0]=1.61129e-05;			trMetProb[12].P[1]=1.61129e-05;			trMetProb[12].P[2]=1.61129e-05;			trMetProb[12].P[3]=1.61129e-05;			trMetProb[12].P[4]=1.61129e-05;			trMetProb[12].P[5]=1.61129e-05;			trMetProb[12].P[6]=1.61129e-05;			trMetProb[12].P[7]=1.61129e-05;			trMetProb[12].P[8]=1.61129e-05;			trMetProb[12].P[9]=1.61129e-05;			trMetProb[12].P[10]=1.61129e-05;			trMetProb[12].P[11]=1.61129e-05;			trMetProb[12].P[12]=0.272324;			trMetProb[12].P[13]=1.61129e-05;			trMetProb[12].P[14]=0.000177242;			trMetProb[12].P[15]=0.0222519;			trMetProb[12].P[16]=0.00952274;			trMetProb[12].P[17]=1.61129e-05;			trMetProb[12].P[18]=0.133431;			trMetProb[12].P[19]=1.61129e-05;			trMetProb[12].P[20]=1.61129e-05;			trMetProb[12].P[21]=0.00388321;			trMetProb[12].P[22]=1.61129e-05;			trMetProb[12].P[23]=1.61129e-05;			trMetProb[12].P[24]=0.555751;			trMetProb[12].P[25]=1.61129e-05;			trMetProb[12].P[26]=1.61129e-05;			trMetProb[12].P[27]=1.61129e-05;			trMetProb[12].P[28]=1.61129e-05;			trMetProb[12].P[29]=1.61129e-05;			trMetProb[12].P[30]=1.61129e-05;			trMetProb[12].P[31]=1.61129e-05;			trMetProb[12].P[32]=1.61129e-05;			trMetProb[12].P[33]=1.61129e-05;			trMetProb[12].P[34]=1.61129e-05;			trMetProb[12].P[35]=1.61129e-05;			trMetProb[12].P[36]=0.00114402;			trMetProb[12].P[37]=1.61129e-05;			trMetProb[12].P[38]=1.61129e-05;			trMetProb[12].P[39]=1.61129e-05;			trMetProb[12].P[40]=1.61129e-05;			trMetProb[12].P[41]=1.61129e-05;			trMetProb[12].P[42]=0.0004995;			trMetProb[12].P[43]=1.61129e-05;			trMetProb[12].P[44]=1.61129e-05;			trMetProb[12].P[45]=1.61129e-05;			trMetProb[12].P[46]=1.61129e-05;			trMetProb[12].P[47]=1.61129e-05;			trMetProb[12].P[48]=1.61129e-05;			trMetProb[12].P[49]=1.61129e-05;			trMetProb[12].P[50]=1.61129e-05;			trMetProb[12].P[51]=1.61129e-05;			trMetProb[12].P[52]=1.61129e-05;			trMetProb[12].P[53]=1.61129e-05;			trMetProb[12].P[54]=1.61129e-05;			trMetProb[12].P[55]=1.61129e-05;			trMetProb[12].P[56]=1.61129e-05;			trMetProb[12].P[57]=1.61129e-05;			trMetProb[12].P[58]=1.61129e-05;			trMetProb[12].P[59]=1.61129e-05;			trMetProb[12].P[60]=1.61129e-05;			trMetProb[12].P[61]=1.61129e-05;			trMetProb[12].P[62]=1.61129e-05;			trMetProb[12].P[63]=1.61129e-05;			trMetProb[12].P[64]=1.61129e-05;			trMetProb[12].P[65]=1.61129e-05;			trMetProb[12].P[66]=1.61129e-05;			trMetProb[12].P[67]=1.61129e-05;			trMetProb[12].P[68]=1.61129e-05;			trMetProb[12].P[69]=1.61129e-05;			trMetProb[12].P[70]=1.61129e-05;			trMetProb[12].P[71]=1.61129e-05;	
		trMetProb[13].P[0]=0.0138889;			trMetProb[13].P[1]=0.0138889;			trMetProb[13].P[2]=0.0138889;			trMetProb[13].P[3]=0.0138889;			trMetProb[13].P[4]=0.0138889;			trMetProb[13].P[5]=0.0138889;			trMetProb[13].P[6]=0.0138889;			trMetProb[13].P[7]=0.0138889;			trMetProb[13].P[8]=0.0138889;			trMetProb[13].P[9]=0.0138889;			trMetProb[13].P[10]=0.0138889;			trMetProb[13].P[11]=0.0138889;			trMetProb[13].P[12]=0.0138889;			trMetProb[13].P[13]=0.0138889;			trMetProb[13].P[14]=0.0138889;			trMetProb[13].P[15]=0.0138889;			trMetProb[13].P[16]=0.0138889;			trMetProb[13].P[17]=0.0138889;			trMetProb[13].P[18]=0.0138889;			trMetProb[13].P[19]=0.0138889;			trMetProb[13].P[20]=0.0138889;			trMetProb[13].P[21]=0.0138889;			trMetProb[13].P[22]=0.0138889;			trMetProb[13].P[23]=0.0138889;			trMetProb[13].P[24]=0.0138889;			trMetProb[13].P[25]=0.0138889;			trMetProb[13].P[26]=0.0138889;			trMetProb[13].P[27]=0.0138889;			trMetProb[13].P[28]=0.0138889;			trMetProb[13].P[29]=0.0138889;			trMetProb[13].P[30]=0.0138889;			trMetProb[13].P[31]=0.0138889;			trMetProb[13].P[32]=0.0138889;			trMetProb[13].P[33]=0.0138889;			trMetProb[13].P[34]=0.0138889;			trMetProb[13].P[35]=0.0138889;			trMetProb[13].P[36]=0.0138889;			trMetProb[13].P[37]=0.0138889;			trMetProb[13].P[38]=0.0138889;			trMetProb[13].P[39]=0.0138889;			trMetProb[13].P[40]=0.0138889;			trMetProb[13].P[41]=0.0138889;			trMetProb[13].P[42]=0.0138889;			trMetProb[13].P[43]=0.0138889;			trMetProb[13].P[44]=0.0138889;			trMetProb[13].P[45]=0.0138889;			trMetProb[13].P[46]=0.0138889;			trMetProb[13].P[47]=0.0138889;			trMetProb[13].P[48]=0.0138889;			trMetProb[13].P[49]=0.0138889;			trMetProb[13].P[50]=0.0138889;			trMetProb[13].P[51]=0.0138889;			trMetProb[13].P[52]=0.0138889;			trMetProb[13].P[53]=0.0138889;			trMetProb[13].P[54]=0.0138889;			trMetProb[13].P[55]=0.0138889;			trMetProb[13].P[56]=0.0138889;			trMetProb[13].P[57]=0.0138889;			trMetProb[13].P[58]=0.0138889;			trMetProb[13].P[59]=0.0138889;			trMetProb[13].P[60]=0.0138889;			trMetProb[13].P[61]=0.0138889;			trMetProb[13].P[62]=0.0138889;			trMetProb[13].P[63]=0.0138889;			trMetProb[13].P[64]=0.0138889;			trMetProb[13].P[65]=0.0138889;			trMetProb[13].P[66]=0.0138889;			trMetProb[13].P[67]=0.0138889;			trMetProb[13].P[68]=0.0138889;			trMetProb[13].P[69]=0.0138889;			trMetProb[13].P[70]=0.0138889;			trMetProb[13].P[71]=0.0138889;	
		trMetProb[14].P[0]=0.0121951;			trMetProb[14].P[1]=0.0121951;			trMetProb[14].P[2]=0.0121951;			trMetProb[14].P[3]=0.0121951;			trMetProb[14].P[4]=0.0121951;			trMetProb[14].P[5]=0.0121951;			trMetProb[14].P[6]=0.0121951;			trMetProb[14].P[7]=0.0121951;			trMetProb[14].P[8]=0.0121951;			trMetProb[14].P[9]=0.0121951;			trMetProb[14].P[10]=0.0121951;			trMetProb[14].P[11]=0.0121951;			trMetProb[14].P[12]=0.0121951;			trMetProb[14].P[13]=0.0121951;			trMetProb[14].P[14]=0.0121951;			trMetProb[14].P[15]=0.0121951;			trMetProb[14].P[16]=0.134146;			trMetProb[14].P[17]=0.0121951;			trMetProb[14].P[18]=0.0121951;			trMetProb[14].P[19]=0.0121951;			trMetProb[14].P[20]=0.0121951;			trMetProb[14].P[21]=0.0121951;			trMetProb[14].P[22]=0.0121951;			trMetProb[14].P[23]=0.0121951;			trMetProb[14].P[24]=0.0121951;			trMetProb[14].P[25]=0.0121951;			trMetProb[14].P[26]=0.0121951;			trMetProb[14].P[27]=0.0121951;			trMetProb[14].P[28]=0.0121951;			trMetProb[14].P[29]=0.0121951;			trMetProb[14].P[30]=0.0121951;			trMetProb[14].P[31]=0.0121951;			trMetProb[14].P[32]=0.0121951;			trMetProb[14].P[33]=0.0121951;			trMetProb[14].P[34]=0.0121951;			trMetProb[14].P[35]=0.0121951;			trMetProb[14].P[36]=0.0121951;			trMetProb[14].P[37]=0.0121951;			trMetProb[14].P[38]=0.0121951;			trMetProb[14].P[39]=0.0121951;			trMetProb[14].P[40]=0.0121951;			trMetProb[14].P[41]=0.0121951;			trMetProb[14].P[42]=0.0121951;			trMetProb[14].P[43]=0.0121951;			trMetProb[14].P[44]=0.0121951;			trMetProb[14].P[45]=0.0121951;			trMetProb[14].P[46]=0.0121951;			trMetProb[14].P[47]=0.0121951;			trMetProb[14].P[48]=0.0121951;			trMetProb[14].P[49]=0.0121951;			trMetProb[14].P[50]=0.0121951;			trMetProb[14].P[51]=0.0121951;			trMetProb[14].P[52]=0.0121951;			trMetProb[14].P[53]=0.0121951;			trMetProb[14].P[54]=0.0121951;			trMetProb[14].P[55]=0.0121951;			trMetProb[14].P[56]=0.0121951;			trMetProb[14].P[57]=0.0121951;			trMetProb[14].P[58]=0.0121951;			trMetProb[14].P[59]=0.0121951;			trMetProb[14].P[60]=0.0121951;			trMetProb[14].P[61]=0.0121951;			trMetProb[14].P[62]=0.0121951;			trMetProb[14].P[63]=0.0121951;			trMetProb[14].P[64]=0.0121951;			trMetProb[14].P[65]=0.0121951;			trMetProb[14].P[66]=0.0121951;			trMetProb[14].P[67]=0.0121951;			trMetProb[14].P[68]=0.0121951;			trMetProb[14].P[69]=0.0121951;			trMetProb[14].P[70]=0.0121951;			trMetProb[14].P[71]=0.0121951;	
		trMetProb[15].P[0]=0.000564334;			trMetProb[15].P[1]=0.000564334;			trMetProb[15].P[2]=0.000564334;			trMetProb[15].P[3]=0.000564334;			trMetProb[15].P[4]=0.000564334;			trMetProb[15].P[5]=0.000564334;			trMetProb[15].P[6]=0.000564334;			trMetProb[15].P[7]=0.000564334;			trMetProb[15].P[8]=0.000564334;			trMetProb[15].P[9]=0.000564334;			trMetProb[15].P[10]=0.000564334;			trMetProb[15].P[11]=0.000564334;			trMetProb[15].P[12]=0.000564334;			trMetProb[15].P[13]=0.000564334;			trMetProb[15].P[14]=0.000564334;			trMetProb[15].P[15]=0.152935;			trMetProb[15].P[16]=0.0174944;			trMetProb[15].P[17]=0.000564334;			trMetProb[15].P[18]=0.762415;			trMetProb[15].P[19]=0.000564334;			trMetProb[15].P[20]=0.000564334;			trMetProb[15].P[21]=0.000564334;			trMetProb[15].P[22]=0.000564334;			trMetProb[15].P[23]=0.000564334;			trMetProb[15].P[24]=0.0231377;			trMetProb[15].P[25]=0.000564334;			trMetProb[15].P[26]=0.000564334;			trMetProb[15].P[27]=0.000564334;			trMetProb[15].P[28]=0.000564334;			trMetProb[15].P[29]=0.000564334;			trMetProb[15].P[30]=0.000564334;			trMetProb[15].P[31]=0.000564334;			trMetProb[15].P[32]=0.000564334;			trMetProb[15].P[33]=0.000564334;			trMetProb[15].P[34]=0.000564334;			trMetProb[15].P[35]=0.000564334;			trMetProb[15].P[36]=0.000564334;			trMetProb[15].P[37]=0.000564334;			trMetProb[15].P[38]=0.000564334;			trMetProb[15].P[39]=0.000564334;			trMetProb[15].P[40]=0.000564334;			trMetProb[15].P[41]=0.000564334;			trMetProb[15].P[42]=0.00620767;			trMetProb[15].P[43]=0.000564334;			trMetProb[15].P[44]=0.000564334;			trMetProb[15].P[45]=0.000564334;			trMetProb[15].P[46]=0.000564334;			trMetProb[15].P[47]=0.000564334;			trMetProb[15].P[48]=0.000564334;			trMetProb[15].P[49]=0.000564334;			trMetProb[15].P[50]=0.000564334;			trMetProb[15].P[51]=0.000564334;			trMetProb[15].P[52]=0.000564334;			trMetProb[15].P[53]=0.000564334;			trMetProb[15].P[54]=0.000564334;			trMetProb[15].P[55]=0.000564334;			trMetProb[15].P[56]=0.000564334;			trMetProb[15].P[57]=0.000564334;			trMetProb[15].P[58]=0.000564334;			trMetProb[15].P[59]=0.000564334;			trMetProb[15].P[60]=0.000564334;			trMetProb[15].P[61]=0.000564334;			trMetProb[15].P[62]=0.000564334;			trMetProb[15].P[63]=0.000564334;			trMetProb[15].P[64]=0.000564334;			trMetProb[15].P[65]=0.000564334;			trMetProb[15].P[66]=0.000564334;			trMetProb[15].P[67]=0.000564334;			trMetProb[15].P[68]=0.000564334;			trMetProb[15].P[69]=0.000564334;			trMetProb[15].P[70]=0.000564334;			trMetProb[15].P[71]=0.000564334;	
		trMetProb[16].P[0]=0.00190575;			trMetProb[16].P[1]=0.00017325;			trMetProb[16].P[2]=0.00017325;			trMetProb[16].P[3]=0.00017325;			trMetProb[16].P[4]=0.00017325;			trMetProb[16].P[5]=0.00017325;			trMetProb[16].P[6]=0.00017325;			trMetProb[16].P[7]=0.00017325;			trMetProb[16].P[8]=0.00017325;			trMetProb[16].P[9]=0.00017325;			trMetProb[16].P[10]=0.00017325;			trMetProb[16].P[11]=0.00017325;			trMetProb[16].P[12]=0.00017325;			trMetProb[16].P[13]=0.00017325;			trMetProb[16].P[14]=0.00017325;			trMetProb[16].P[15]=0.00017325;			trMetProb[16].P[16]=0.168226;			trMetProb[16].P[17]=0.00017325;			trMetProb[16].P[18]=0.00363825;			trMetProb[16].P[19]=0.00017325;			trMetProb[16].P[20]=0.0937283;			trMetProb[16].P[21]=0.00017325;			trMetProb[16].P[22]=0.00017325;			trMetProb[16].P[23]=0.00017325;			trMetProb[16].P[24]=0.720894;			trMetProb[16].P[25]=0.00017325;			trMetProb[16].P[26]=0.00017325;			trMetProb[16].P[27]=0.00017325;			trMetProb[16].P[28]=0.00017325;			trMetProb[16].P[29]=0.00017325;			trMetProb[16].P[30]=0.00017325;			trMetProb[16].P[31]=0.00017325;			trMetProb[16].P[32]=0.00017325;			trMetProb[16].P[33]=0.00017325;			trMetProb[16].P[34]=0.00017325;			trMetProb[16].P[35]=0.00017325;			trMetProb[16].P[36]=0.00017325;			trMetProb[16].P[37]=0.00017325;			trMetProb[16].P[38]=0.00017325;			trMetProb[16].P[39]=0.00017325;			trMetProb[16].P[40]=0.00017325;			trMetProb[16].P[41]=0.00017325;			trMetProb[16].P[42]=0.00017325;			trMetProb[16].P[43]=0.00017325;			trMetProb[16].P[44]=0.00017325;			trMetProb[16].P[45]=0.00017325;			trMetProb[16].P[46]=0.00017325;			trMetProb[16].P[47]=0.00017325;			trMetProb[16].P[48]=0.00017325;			trMetProb[16].P[49]=0.00017325;			trMetProb[16].P[50]=0.00017325;			trMetProb[16].P[51]=0.00017325;			trMetProb[16].P[52]=0.00017325;			trMetProb[16].P[53]=0.00017325;			trMetProb[16].P[54]=0.00017325;			trMetProb[16].P[55]=0.00017325;			trMetProb[16].P[56]=0.00017325;			trMetProb[16].P[57]=0.00017325;			trMetProb[16].P[58]=0.00017325;			trMetProb[16].P[59]=0.00017325;			trMetProb[16].P[60]=0.00017325;			trMetProb[16].P[61]=0.00017325;			trMetProb[16].P[62]=0.00017325;			trMetProb[16].P[63]=0.00017325;			trMetProb[16].P[64]=0.00017325;			trMetProb[16].P[65]=0.00017325;			trMetProb[16].P[66]=0.00017325;			trMetProb[16].P[67]=0.00017325;			trMetProb[16].P[68]=0.00017325;			trMetProb[16].P[69]=0.00017325;			trMetProb[16].P[70]=0.00017325;			trMetProb[16].P[71]=0.00017325;	
		trMetProb[17].P[0]=0.0138889;			trMetProb[17].P[1]=0.0138889;			trMetProb[17].P[2]=0.0138889;			trMetProb[17].P[3]=0.0138889;			trMetProb[17].P[4]=0.0138889;			trMetProb[17].P[5]=0.0138889;			trMetProb[17].P[6]=0.0138889;			trMetProb[17].P[7]=0.0138889;			trMetProb[17].P[8]=0.0138889;			trMetProb[17].P[9]=0.0138889;			trMetProb[17].P[10]=0.0138889;			trMetProb[17].P[11]=0.0138889;			trMetProb[17].P[12]=0.0138889;			trMetProb[17].P[13]=0.0138889;			trMetProb[17].P[14]=0.0138889;			trMetProb[17].P[15]=0.0138889;			trMetProb[17].P[16]=0.0138889;			trMetProb[17].P[17]=0.0138889;			trMetProb[17].P[18]=0.0138889;			trMetProb[17].P[19]=0.0138889;			trMetProb[17].P[20]=0.0138889;			trMetProb[17].P[21]=0.0138889;			trMetProb[17].P[22]=0.0138889;			trMetProb[17].P[23]=0.0138889;			trMetProb[17].P[24]=0.0138889;			trMetProb[17].P[25]=0.0138889;			trMetProb[17].P[26]=0.0138889;			trMetProb[17].P[27]=0.0138889;			trMetProb[17].P[28]=0.0138889;			trMetProb[17].P[29]=0.0138889;			trMetProb[17].P[30]=0.0138889;			trMetProb[17].P[31]=0.0138889;			trMetProb[17].P[32]=0.0138889;			trMetProb[17].P[33]=0.0138889;			trMetProb[17].P[34]=0.0138889;			trMetProb[17].P[35]=0.0138889;			trMetProb[17].P[36]=0.0138889;			trMetProb[17].P[37]=0.0138889;			trMetProb[17].P[38]=0.0138889;			trMetProb[17].P[39]=0.0138889;			trMetProb[17].P[40]=0.0138889;			trMetProb[17].P[41]=0.0138889;			trMetProb[17].P[42]=0.0138889;			trMetProb[17].P[43]=0.0138889;			trMetProb[17].P[44]=0.0138889;			trMetProb[17].P[45]=0.0138889;			trMetProb[17].P[46]=0.0138889;			trMetProb[17].P[47]=0.0138889;			trMetProb[17].P[48]=0.0138889;			trMetProb[17].P[49]=0.0138889;			trMetProb[17].P[50]=0.0138889;			trMetProb[17].P[51]=0.0138889;			trMetProb[17].P[52]=0.0138889;			trMetProb[17].P[53]=0.0138889;			trMetProb[17].P[54]=0.0138889;			trMetProb[17].P[55]=0.0138889;			trMetProb[17].P[56]=0.0138889;			trMetProb[17].P[57]=0.0138889;			trMetProb[17].P[58]=0.0138889;			trMetProb[17].P[59]=0.0138889;			trMetProb[17].P[60]=0.0138889;			trMetProb[17].P[61]=0.0138889;			trMetProb[17].P[62]=0.0138889;			trMetProb[17].P[63]=0.0138889;			trMetProb[17].P[64]=0.0138889;			trMetProb[17].P[65]=0.0138889;			trMetProb[17].P[66]=0.0138889;			trMetProb[17].P[67]=0.0138889;			trMetProb[17].P[68]=0.0138889;			trMetProb[17].P[69]=0.0138889;			trMetProb[17].P[70]=0.0138889;			trMetProb[17].P[71]=0.0138889;	
		trMetProb[18].P[0]=0.000746167;			trMetProb[18].P[1]=6.78334e-05;			trMetProb[18].P[2]=6.78334e-05;			trMetProb[18].P[3]=6.78334e-05;			trMetProb[18].P[4]=6.78334e-05;			trMetProb[18].P[5]=6.78334e-05;			trMetProb[18].P[6]=0.00210284;			trMetProb[18].P[7]=6.78334e-05;			trMetProb[18].P[8]=6.78334e-05;			trMetProb[18].P[9]=6.78334e-05;			trMetProb[18].P[10]=6.78334e-05;			trMetProb[18].P[11]=6.78334e-05;			trMetProb[18].P[12]=6.78334e-05;			trMetProb[18].P[13]=6.78334e-05;			trMetProb[18].P[14]=6.78334e-05;			trMetProb[18].P[15]=6.78334e-05;			trMetProb[18].P[16]=6.78334e-05;			trMetProb[18].P[17]=6.78334e-05;			trMetProb[18].P[18]=0.212386;			trMetProb[18].P[19]=6.78334e-05;			trMetProb[18].P[20]=0.0014245;			trMetProb[18].P[21]=0.120133;			trMetProb[18].P[22]=6.78334e-05;			trMetProb[18].P[23]=6.78334e-05;			trMetProb[18].P[24]=0.652625;			trMetProb[18].P[25]=6.78334e-05;			trMetProb[18].P[26]=6.78334e-05;			trMetProb[18].P[27]=0.0014245;			trMetProb[18].P[28]=6.78334e-05;			trMetProb[18].P[29]=6.78334e-05;			trMetProb[18].P[30]=0.000746167;			trMetProb[18].P[31]=6.78334e-05;			trMetProb[18].P[32]=6.78334e-05;			trMetProb[18].P[33]=6.78334e-05;			trMetProb[18].P[34]=6.78334e-05;			trMetProb[18].P[35]=6.78334e-05;			trMetProb[18].P[36]=0.00413784;			trMetProb[18].P[37]=6.78334e-05;			trMetProb[18].P[38]=6.78334e-05;			trMetProb[18].P[39]=6.78334e-05;			trMetProb[18].P[40]=6.78334e-05;			trMetProb[18].P[41]=6.78334e-05;			trMetProb[18].P[42]=6.78334e-05;			trMetProb[18].P[43]=6.78334e-05;			trMetProb[18].P[44]=6.78334e-05;			trMetProb[18].P[45]=6.78334e-05;			trMetProb[18].P[46]=6.78334e-05;			trMetProb[18].P[47]=6.78334e-05;			trMetProb[18].P[48]=6.78334e-05;			trMetProb[18].P[49]=6.78334e-05;			trMetProb[18].P[50]=6.78334e-05;			trMetProb[18].P[51]=6.78334e-05;			trMetProb[18].P[52]=6.78334e-05;			trMetProb[18].P[53]=6.78334e-05;			trMetProb[18].P[54]=6.78334e-05;			trMetProb[18].P[55]=6.78334e-05;			trMetProb[18].P[56]=6.78334e-05;			trMetProb[18].P[57]=6.78334e-05;			trMetProb[18].P[58]=6.78334e-05;			trMetProb[18].P[59]=6.78334e-05;			trMetProb[18].P[60]=6.78334e-05;			trMetProb[18].P[61]=6.78334e-05;			trMetProb[18].P[62]=6.78334e-05;			trMetProb[18].P[63]=6.78334e-05;			trMetProb[18].P[64]=6.78334e-05;			trMetProb[18].P[65]=6.78334e-05;			trMetProb[18].P[66]=6.78334e-05;			trMetProb[18].P[67]=6.78334e-05;			trMetProb[18].P[68]=6.78334e-05;			trMetProb[18].P[69]=6.78334e-05;			trMetProb[18].P[70]=6.78334e-05;			trMetProb[18].P[71]=6.78334e-05;	
		trMetProb[19].P[0]=0.0138889;			trMetProb[19].P[1]=0.0138889;			trMetProb[19].P[2]=0.0138889;			trMetProb[19].P[3]=0.0138889;			trMetProb[19].P[4]=0.0138889;			trMetProb[19].P[5]=0.0138889;			trMetProb[19].P[6]=0.0138889;			trMetProb[19].P[7]=0.0138889;			trMetProb[19].P[8]=0.0138889;			trMetProb[19].P[9]=0.0138889;			trMetProb[19].P[10]=0.0138889;			trMetProb[19].P[11]=0.0138889;			trMetProb[19].P[12]=0.0138889;			trMetProb[19].P[13]=0.0138889;			trMetProb[19].P[14]=0.0138889;			trMetProb[19].P[15]=0.0138889;			trMetProb[19].P[16]=0.0138889;			trMetProb[19].P[17]=0.0138889;			trMetProb[19].P[18]=0.0138889;			trMetProb[19].P[19]=0.0138889;			trMetProb[19].P[20]=0.0138889;			trMetProb[19].P[21]=0.0138889;			trMetProb[19].P[22]=0.0138889;			trMetProb[19].P[23]=0.0138889;			trMetProb[19].P[24]=0.0138889;			trMetProb[19].P[25]=0.0138889;			trMetProb[19].P[26]=0.0138889;			trMetProb[19].P[27]=0.0138889;			trMetProb[19].P[28]=0.0138889;			trMetProb[19].P[29]=0.0138889;			trMetProb[19].P[30]=0.0138889;			trMetProb[19].P[31]=0.0138889;			trMetProb[19].P[32]=0.0138889;			trMetProb[19].P[33]=0.0138889;			trMetProb[19].P[34]=0.0138889;			trMetProb[19].P[35]=0.0138889;			trMetProb[19].P[36]=0.0138889;			trMetProb[19].P[37]=0.0138889;			trMetProb[19].P[38]=0.0138889;			trMetProb[19].P[39]=0.0138889;			trMetProb[19].P[40]=0.0138889;			trMetProb[19].P[41]=0.0138889;			trMetProb[19].P[42]=0.0138889;			trMetProb[19].P[43]=0.0138889;			trMetProb[19].P[44]=0.0138889;			trMetProb[19].P[45]=0.0138889;			trMetProb[19].P[46]=0.0138889;			trMetProb[19].P[47]=0.0138889;			trMetProb[19].P[48]=0.0138889;			trMetProb[19].P[49]=0.0138889;			trMetProb[19].P[50]=0.0138889;			trMetProb[19].P[51]=0.0138889;			trMetProb[19].P[52]=0.0138889;			trMetProb[19].P[53]=0.0138889;			trMetProb[19].P[54]=0.0138889;			trMetProb[19].P[55]=0.0138889;			trMetProb[19].P[56]=0.0138889;			trMetProb[19].P[57]=0.0138889;			trMetProb[19].P[58]=0.0138889;			trMetProb[19].P[59]=0.0138889;			trMetProb[19].P[60]=0.0138889;			trMetProb[19].P[61]=0.0138889;			trMetProb[19].P[62]=0.0138889;			trMetProb[19].P[63]=0.0138889;			trMetProb[19].P[64]=0.0138889;			trMetProb[19].P[65]=0.0138889;			trMetProb[19].P[66]=0.0138889;			trMetProb[19].P[67]=0.0138889;			trMetProb[19].P[68]=0.0138889;			trMetProb[19].P[69]=0.0138889;			trMetProb[19].P[70]=0.0138889;			trMetProb[19].P[71]=0.0138889;	
		trMetProb[20].P[0]=0.0014245;			trMetProb[20].P[1]=0.0014245;			trMetProb[20].P[2]=0.0014245;			trMetProb[20].P[3]=0.0014245;			trMetProb[20].P[4]=0.0014245;			trMetProb[20].P[5]=0.0014245;			trMetProb[20].P[6]=0.0014245;			trMetProb[20].P[7]=0.0014245;			trMetProb[20].P[8]=0.0014245;			trMetProb[20].P[9]=0.0014245;			trMetProb[20].P[10]=0.0014245;			trMetProb[20].P[11]=0.0014245;			trMetProb[20].P[12]=0.0014245;			trMetProb[20].P[13]=0.0014245;			trMetProb[20].P[14]=0.0014245;			trMetProb[20].P[15]=0.0014245;			trMetProb[20].P[16]=0.0014245;			trMetProb[20].P[17]=0.0014245;			trMetProb[20].P[18]=0.0014245;			trMetProb[20].P[19]=0.0014245;			trMetProb[20].P[20]=0.10114;			trMetProb[20].P[21]=0.0584046;			trMetProb[20].P[22]=0.0299145;			trMetProb[20].P[23]=0.0014245;			trMetProb[20].P[24]=0.713675;			trMetProb[20].P[25]=0.0014245;			trMetProb[20].P[26]=0.0014245;			trMetProb[20].P[27]=0.0014245;			trMetProb[20].P[28]=0.0014245;			trMetProb[20].P[29]=0.0014245;			trMetProb[20].P[30]=0.0014245;			trMetProb[20].P[31]=0.0014245;			trMetProb[20].P[32]=0.0014245;			trMetProb[20].P[33]=0.0014245;			trMetProb[20].P[34]=0.0014245;			trMetProb[20].P[35]=0.0014245;			trMetProb[20].P[36]=0.0014245;			trMetProb[20].P[37]=0.0014245;			trMetProb[20].P[38]=0.0014245;			trMetProb[20].P[39]=0.0014245;			trMetProb[20].P[40]=0.0014245;			trMetProb[20].P[41]=0.0014245;			trMetProb[20].P[42]=0.0014245;			trMetProb[20].P[43]=0.0014245;			trMetProb[20].P[44]=0.0014245;			trMetProb[20].P[45]=0.0014245;			trMetProb[20].P[46]=0.0014245;			trMetProb[20].P[47]=0.0014245;			trMetProb[20].P[48]=0.0014245;			trMetProb[20].P[49]=0.0014245;			trMetProb[20].P[50]=0.0014245;			trMetProb[20].P[51]=0.0014245;			trMetProb[20].P[52]=0.0014245;			trMetProb[20].P[53]=0.0014245;			trMetProb[20].P[54]=0.0014245;			trMetProb[20].P[55]=0.0014245;			trMetProb[20].P[56]=0.0014245;			trMetProb[20].P[57]=0.0014245;			trMetProb[20].P[58]=0.0014245;			trMetProb[20].P[59]=0.0014245;			trMetProb[20].P[60]=0.0014245;			trMetProb[20].P[61]=0.0014245;			trMetProb[20].P[62]=0.0014245;			trMetProb[20].P[63]=0.0014245;			trMetProb[20].P[64]=0.0014245;			trMetProb[20].P[65]=0.0014245;			trMetProb[20].P[66]=0.0014245;			trMetProb[20].P[67]=0.0014245;			trMetProb[20].P[68]=0.0014245;			trMetProb[20].P[69]=0.0014245;			trMetProb[20].P[70]=0.0014245;			trMetProb[20].P[71]=0.0014245;	
		trMetProb[21].P[0]=0.00039032;			trMetProb[21].P[1]=0.00039032;			trMetProb[21].P[2]=0.00039032;			trMetProb[21].P[3]=0.00039032;			trMetProb[21].P[4]=0.00039032;			trMetProb[21].P[5]=0.00039032;			trMetProb[21].P[6]=0.00039032;			trMetProb[21].P[7]=0.00039032;			trMetProb[21].P[8]=0.00039032;			trMetProb[21].P[9]=0.00039032;			trMetProb[21].P[10]=0.00039032;			trMetProb[21].P[11]=0.00039032;			trMetProb[21].P[12]=0.00039032;			trMetProb[21].P[13]=0.00039032;			trMetProb[21].P[14]=0.00039032;			trMetProb[21].P[15]=0.00039032;			trMetProb[21].P[16]=0.00039032;			trMetProb[21].P[17]=0.00039032;			trMetProb[21].P[18]=0.00039032;			trMetProb[21].P[19]=0.00039032;			trMetProb[21].P[20]=0.00039032;			trMetProb[21].P[21]=0.148712;			trMetProb[21].P[22]=0.00039032;			trMetProb[21].P[23]=0.00039032;			trMetProb[21].P[24]=0.823966;			trMetProb[21].P[25]=0.00039032;			trMetProb[21].P[26]=0.00039032;			trMetProb[21].P[27]=0.00039032;			trMetProb[21].P[28]=0.00039032;			trMetProb[21].P[29]=0.00039032;			trMetProb[21].P[30]=0.00039032;			trMetProb[21].P[31]=0.00039032;			trMetProb[21].P[32]=0.00039032;			trMetProb[21].P[33]=0.00039032;			trMetProb[21].P[34]=0.00039032;			trMetProb[21].P[35]=0.00039032;			trMetProb[21].P[36]=0.00039032;			trMetProb[21].P[37]=0.00039032;			trMetProb[21].P[38]=0.00039032;			trMetProb[21].P[39]=0.00039032;			trMetProb[21].P[40]=0.00039032;			trMetProb[21].P[41]=0.00039032;			trMetProb[21].P[42]=0.00039032;			trMetProb[21].P[43]=0.00039032;			trMetProb[21].P[44]=0.00039032;			trMetProb[21].P[45]=0.00039032;			trMetProb[21].P[46]=0.00039032;			trMetProb[21].P[47]=0.00039032;			trMetProb[21].P[48]=0.00039032;			trMetProb[21].P[49]=0.00039032;			trMetProb[21].P[50]=0.00039032;			trMetProb[21].P[51]=0.00039032;			trMetProb[21].P[52]=0.00039032;			trMetProb[21].P[53]=0.00039032;			trMetProb[21].P[54]=0.00039032;			trMetProb[21].P[55]=0.00039032;			trMetProb[21].P[56]=0.00039032;			trMetProb[21].P[57]=0.00039032;			trMetProb[21].P[58]=0.00039032;			trMetProb[21].P[59]=0.00039032;			trMetProb[21].P[60]=0.00039032;			trMetProb[21].P[61]=0.00039032;			trMetProb[21].P[62]=0.00039032;			trMetProb[21].P[63]=0.00039032;			trMetProb[21].P[64]=0.00039032;			trMetProb[21].P[65]=0.00039032;			trMetProb[21].P[66]=0.00039032;			trMetProb[21].P[67]=0.00039032;			trMetProb[21].P[68]=0.00039032;			trMetProb[21].P[69]=0.00039032;			trMetProb[21].P[70]=0.00039032;			trMetProb[21].P[71]=0.00039032;	
		trMetProb[22].P[0]=0.0108696;			trMetProb[22].P[1]=0.0108696;			trMetProb[22].P[2]=0.0108696;			trMetProb[22].P[3]=0.0108696;			trMetProb[22].P[4]=0.0108696;			trMetProb[22].P[5]=0.0108696;			trMetProb[22].P[6]=0.0108696;			trMetProb[22].P[7]=0.0108696;			trMetProb[22].P[8]=0.0108696;			trMetProb[22].P[9]=0.0108696;			trMetProb[22].P[10]=0.0108696;			trMetProb[22].P[11]=0.0108696;			trMetProb[22].P[12]=0.0108696;			trMetProb[22].P[13]=0.0108696;			trMetProb[22].P[14]=0.0108696;			trMetProb[22].P[15]=0.0108696;			trMetProb[22].P[16]=0.0108696;			trMetProb[22].P[17]=0.0108696;			trMetProb[22].P[18]=0.0108696;			trMetProb[22].P[19]=0.0108696;			trMetProb[22].P[20]=0.0108696;			trMetProb[22].P[21]=0.0108696;			trMetProb[22].P[22]=0.0108696;			trMetProb[22].P[23]=0.0108696;			trMetProb[22].P[24]=0.228261;			trMetProb[22].P[25]=0.0108696;			trMetProb[22].P[26]=0.0108696;			trMetProb[22].P[27]=0.0108696;			trMetProb[22].P[28]=0.0108696;			trMetProb[22].P[29]=0.0108696;			trMetProb[22].P[30]=0.0108696;			trMetProb[22].P[31]=0.0108696;			trMetProb[22].P[32]=0.0108696;			trMetProb[22].P[33]=0.0108696;			trMetProb[22].P[34]=0.0108696;			trMetProb[22].P[35]=0.0108696;			trMetProb[22].P[36]=0.0108696;			trMetProb[22].P[37]=0.0108696;			trMetProb[22].P[38]=0.0108696;			trMetProb[22].P[39]=0.0108696;			trMetProb[22].P[40]=0.0108696;			trMetProb[22].P[41]=0.0108696;			trMetProb[22].P[42]=0.0108696;			trMetProb[22].P[43]=0.0108696;			trMetProb[22].P[44]=0.0108696;			trMetProb[22].P[45]=0.0108696;			trMetProb[22].P[46]=0.0108696;			trMetProb[22].P[47]=0.0108696;			trMetProb[22].P[48]=0.0108696;			trMetProb[22].P[49]=0.0108696;			trMetProb[22].P[50]=0.0108696;			trMetProb[22].P[51]=0.0108696;			trMetProb[22].P[52]=0.0108696;			trMetProb[22].P[53]=0.0108696;			trMetProb[22].P[54]=0.0108696;			trMetProb[22].P[55]=0.0108696;			trMetProb[22].P[56]=0.0108696;			trMetProb[22].P[57]=0.0108696;			trMetProb[22].P[58]=0.0108696;			trMetProb[22].P[59]=0.0108696;			trMetProb[22].P[60]=0.0108696;			trMetProb[22].P[61]=0.0108696;			trMetProb[22].P[62]=0.0108696;			trMetProb[22].P[63]=0.0108696;			trMetProb[22].P[64]=0.0108696;			trMetProb[22].P[65]=0.0108696;			trMetProb[22].P[66]=0.0108696;			trMetProb[22].P[67]=0.0108696;			trMetProb[22].P[68]=0.0108696;			trMetProb[22].P[69]=0.0108696;			trMetProb[22].P[70]=0.0108696;			trMetProb[22].P[71]=0.0108696;	
		trMetProb[23].P[0]=0.0138889;			trMetProb[23].P[1]=0.0138889;			trMetProb[23].P[2]=0.0138889;			trMetProb[23].P[3]=0.0138889;			trMetProb[23].P[4]=0.0138889;			trMetProb[23].P[5]=0.0138889;			trMetProb[23].P[6]=0.0138889;			trMetProb[23].P[7]=0.0138889;			trMetProb[23].P[8]=0.0138889;			trMetProb[23].P[9]=0.0138889;			trMetProb[23].P[10]=0.0138889;			trMetProb[23].P[11]=0.0138889;			trMetProb[23].P[12]=0.0138889;			trMetProb[23].P[13]=0.0138889;			trMetProb[23].P[14]=0.0138889;			trMetProb[23].P[15]=0.0138889;			trMetProb[23].P[16]=0.0138889;			trMetProb[23].P[17]=0.0138889;			trMetProb[23].P[18]=0.0138889;			trMetProb[23].P[19]=0.0138889;			trMetProb[23].P[20]=0.0138889;			trMetProb[23].P[21]=0.0138889;			trMetProb[23].P[22]=0.0138889;			trMetProb[23].P[23]=0.0138889;			trMetProb[23].P[24]=0.0138889;			trMetProb[23].P[25]=0.0138889;			trMetProb[23].P[26]=0.0138889;			trMetProb[23].P[27]=0.0138889;			trMetProb[23].P[28]=0.0138889;			trMetProb[23].P[29]=0.0138889;			trMetProb[23].P[30]=0.0138889;			trMetProb[23].P[31]=0.0138889;			trMetProb[23].P[32]=0.0138889;			trMetProb[23].P[33]=0.0138889;			trMetProb[23].P[34]=0.0138889;			trMetProb[23].P[35]=0.0138889;			trMetProb[23].P[36]=0.0138889;			trMetProb[23].P[37]=0.0138889;			trMetProb[23].P[38]=0.0138889;			trMetProb[23].P[39]=0.0138889;			trMetProb[23].P[40]=0.0138889;			trMetProb[23].P[41]=0.0138889;			trMetProb[23].P[42]=0.0138889;			trMetProb[23].P[43]=0.0138889;			trMetProb[23].P[44]=0.0138889;			trMetProb[23].P[45]=0.0138889;			trMetProb[23].P[46]=0.0138889;			trMetProb[23].P[47]=0.0138889;			trMetProb[23].P[48]=0.0138889;			trMetProb[23].P[49]=0.0138889;			trMetProb[23].P[50]=0.0138889;			trMetProb[23].P[51]=0.0138889;			trMetProb[23].P[52]=0.0138889;			trMetProb[23].P[53]=0.0138889;			trMetProb[23].P[54]=0.0138889;			trMetProb[23].P[55]=0.0138889;			trMetProb[23].P[56]=0.0138889;			trMetProb[23].P[57]=0.0138889;			trMetProb[23].P[58]=0.0138889;			trMetProb[23].P[59]=0.0138889;			trMetProb[23].P[60]=0.0138889;			trMetProb[23].P[61]=0.0138889;			trMetProb[23].P[62]=0.0138889;			trMetProb[23].P[63]=0.0138889;			trMetProb[23].P[64]=0.0138889;			trMetProb[23].P[65]=0.0138889;			trMetProb[23].P[66]=0.0138889;			trMetProb[23].P[67]=0.0138889;			trMetProb[23].P[68]=0.0138889;			trMetProb[23].P[69]=0.0138889;			trMetProb[23].P[70]=0.0138889;			trMetProb[23].P[71]=0.0138889;	
		trMetProb[24].P[0]=0.00627376;			trMetProb[24].P[1]=5.01499e-06;			trMetProb[24].P[2]=5.01499e-06;			trMetProb[24].P[3]=5.01499e-06;			trMetProb[24].P[4]=5.01499e-06;			trMetProb[24].P[5]=5.01499e-06;			trMetProb[24].P[6]=5.01499e-06;			trMetProb[24].P[7]=5.01499e-06;			trMetProb[24].P[8]=5.01499e-06;			trMetProb[24].P[9]=5.01499e-06;			trMetProb[24].P[10]=5.01499e-06;			trMetProb[24].P[11]=5.01499e-06;			trMetProb[24].P[12]=0.000205615;			trMetProb[24].P[13]=5.01499e-06;			trMetProb[24].P[14]=5.01499e-06;			trMetProb[24].P[15]=5.01499e-06;			trMetProb[24].P[16]=5.01499e-06;			trMetProb[24].P[17]=5.01499e-06;			trMetProb[24].P[18]=5.01499e-06;			trMetProb[24].P[19]=5.01499e-06;			trMetProb[24].P[20]=5.01499e-06;			trMetProb[24].P[21]=5.01499e-06;			trMetProb[24].P[22]=5.01499e-06;			trMetProb[24].P[23]=5.01499e-06;			trMetProb[24].P[24]=0.494183;			trMetProb[24].P[25]=5.01499e-06;			trMetProb[24].P[26]=5.01499e-06;			trMetProb[24].P[27]=0.00597286;			trMetProb[24].P[28]=0.00311431;			trMetProb[24].P[29]=5.01499e-06;			trMetProb[24].P[30]=0.0392223;			trMetProb[24].P[31]=5.01499e-06;			trMetProb[24].P[32]=0.0217199;			trMetProb[24].P[33]=0.000707114;			trMetProb[24].P[34]=5.01499e-06;			trMetProb[24].P[35]=5.01499e-06;			trMetProb[24].P[36]=0.188168;			trMetProb[24].P[37]=5.01499e-06;			trMetProb[24].P[38]=5.01499e-06;			trMetProb[24].P[39]=0.000205615;			trMetProb[24].P[40]=5.01499e-06;			trMetProb[24].P[41]=5.01499e-06;			trMetProb[24].P[42]=0.00326476;			trMetProb[24].P[43]=5.01499e-06;			trMetProb[24].P[44]=5.01499e-06;			trMetProb[24].P[45]=0.000255765;			trMetProb[24].P[46]=5.01499e-06;			trMetProb[24].P[47]=5.01499e-06;			trMetProb[24].P[48]=0.235058;			trMetProb[24].P[49]=5.01499e-06;			trMetProb[24].P[50]=5.01499e-06;			trMetProb[24].P[51]=5.01499e-06;			trMetProb[24].P[52]=5.01499e-06;			trMetProb[24].P[53]=5.01499e-06;			trMetProb[24].P[54]=0.000155465;			trMetProb[24].P[55]=5.01499e-06;			trMetProb[24].P[56]=5.01499e-06;			trMetProb[24].P[57]=5.01499e-06;			trMetProb[24].P[58]=5.01499e-06;			trMetProb[24].P[59]=5.01499e-06;			trMetProb[24].P[60]=0.00120861;			trMetProb[24].P[61]=5.01499e-06;			trMetProb[24].P[62]=5.01499e-06;			trMetProb[24].P[63]=5.01499e-06;			trMetProb[24].P[64]=5.01499e-06;			trMetProb[24].P[65]=5.01499e-06;			trMetProb[24].P[66]=5.01499e-06;			trMetProb[24].P[67]=5.01499e-06;			trMetProb[24].P[68]=5.01499e-06;			trMetProb[24].P[69]=5.01499e-06;			trMetProb[24].P[70]=5.01499e-06;			trMetProb[24].P[71]=5.01499e-06;	
		trMetProb[25].P[0]=0.0138889;			trMetProb[25].P[1]=0.0138889;			trMetProb[25].P[2]=0.0138889;			trMetProb[25].P[3]=0.0138889;			trMetProb[25].P[4]=0.0138889;			trMetProb[25].P[5]=0.0138889;			trMetProb[25].P[6]=0.0138889;			trMetProb[25].P[7]=0.0138889;			trMetProb[25].P[8]=0.0138889;			trMetProb[25].P[9]=0.0138889;			trMetProb[25].P[10]=0.0138889;			trMetProb[25].P[11]=0.0138889;			trMetProb[25].P[12]=0.0138889;			trMetProb[25].P[13]=0.0138889;			trMetProb[25].P[14]=0.0138889;			trMetProb[25].P[15]=0.0138889;			trMetProb[25].P[16]=0.0138889;			trMetProb[25].P[17]=0.0138889;			trMetProb[25].P[18]=0.0138889;			trMetProb[25].P[19]=0.0138889;			trMetProb[25].P[20]=0.0138889;			trMetProb[25].P[21]=0.0138889;			trMetProb[25].P[22]=0.0138889;			trMetProb[25].P[23]=0.0138889;			trMetProb[25].P[24]=0.0138889;			trMetProb[25].P[25]=0.0138889;			trMetProb[25].P[26]=0.0138889;			trMetProb[25].P[27]=0.0138889;			trMetProb[25].P[28]=0.0138889;			trMetProb[25].P[29]=0.0138889;			trMetProb[25].P[30]=0.0138889;			trMetProb[25].P[31]=0.0138889;			trMetProb[25].P[32]=0.0138889;			trMetProb[25].P[33]=0.0138889;			trMetProb[25].P[34]=0.0138889;			trMetProb[25].P[35]=0.0138889;			trMetProb[25].P[36]=0.0138889;			trMetProb[25].P[37]=0.0138889;			trMetProb[25].P[38]=0.0138889;			trMetProb[25].P[39]=0.0138889;			trMetProb[25].P[40]=0.0138889;			trMetProb[25].P[41]=0.0138889;			trMetProb[25].P[42]=0.0138889;			trMetProb[25].P[43]=0.0138889;			trMetProb[25].P[44]=0.0138889;			trMetProb[25].P[45]=0.0138889;			trMetProb[25].P[46]=0.0138889;			trMetProb[25].P[47]=0.0138889;			trMetProb[25].P[48]=0.0138889;			trMetProb[25].P[49]=0.0138889;			trMetProb[25].P[50]=0.0138889;			trMetProb[25].P[51]=0.0138889;			trMetProb[25].P[52]=0.0138889;			trMetProb[25].P[53]=0.0138889;			trMetProb[25].P[54]=0.0138889;			trMetProb[25].P[55]=0.0138889;			trMetProb[25].P[56]=0.0138889;			trMetProb[25].P[57]=0.0138889;			trMetProb[25].P[58]=0.0138889;			trMetProb[25].P[59]=0.0138889;			trMetProb[25].P[60]=0.0138889;			trMetProb[25].P[61]=0.0138889;			trMetProb[25].P[62]=0.0138889;			trMetProb[25].P[63]=0.0138889;			trMetProb[25].P[64]=0.0138889;			trMetProb[25].P[65]=0.0138889;			trMetProb[25].P[66]=0.0138889;			trMetProb[25].P[67]=0.0138889;			trMetProb[25].P[68]=0.0138889;			trMetProb[25].P[69]=0.0138889;			trMetProb[25].P[70]=0.0138889;			trMetProb[25].P[71]=0.0138889;	
		trMetProb[26].P[0]=0.0138889;			trMetProb[26].P[1]=0.0138889;			trMetProb[26].P[2]=0.0138889;			trMetProb[26].P[3]=0.0138889;			trMetProb[26].P[4]=0.0138889;			trMetProb[26].P[5]=0.0138889;			trMetProb[26].P[6]=0.0138889;			trMetProb[26].P[7]=0.0138889;			trMetProb[26].P[8]=0.0138889;			trMetProb[26].P[9]=0.0138889;			trMetProb[26].P[10]=0.0138889;			trMetProb[26].P[11]=0.0138889;			trMetProb[26].P[12]=0.0138889;			trMetProb[26].P[13]=0.0138889;			trMetProb[26].P[14]=0.0138889;			trMetProb[26].P[15]=0.0138889;			trMetProb[26].P[16]=0.0138889;			trMetProb[26].P[17]=0.0138889;			trMetProb[26].P[18]=0.0138889;			trMetProb[26].P[19]=0.0138889;			trMetProb[26].P[20]=0.0138889;			trMetProb[26].P[21]=0.0138889;			trMetProb[26].P[22]=0.0138889;			trMetProb[26].P[23]=0.0138889;			trMetProb[26].P[24]=0.0138889;			trMetProb[26].P[25]=0.0138889;			trMetProb[26].P[26]=0.0138889;			trMetProb[26].P[27]=0.0138889;			trMetProb[26].P[28]=0.0138889;			trMetProb[26].P[29]=0.0138889;			trMetProb[26].P[30]=0.0138889;			trMetProb[26].P[31]=0.0138889;			trMetProb[26].P[32]=0.0138889;			trMetProb[26].P[33]=0.0138889;			trMetProb[26].P[34]=0.0138889;			trMetProb[26].P[35]=0.0138889;			trMetProb[26].P[36]=0.0138889;			trMetProb[26].P[37]=0.0138889;			trMetProb[26].P[38]=0.0138889;			trMetProb[26].P[39]=0.0138889;			trMetProb[26].P[40]=0.0138889;			trMetProb[26].P[41]=0.0138889;			trMetProb[26].P[42]=0.0138889;			trMetProb[26].P[43]=0.0138889;			trMetProb[26].P[44]=0.0138889;			trMetProb[26].P[45]=0.0138889;			trMetProb[26].P[46]=0.0138889;			trMetProb[26].P[47]=0.0138889;			trMetProb[26].P[48]=0.0138889;			trMetProb[26].P[49]=0.0138889;			trMetProb[26].P[50]=0.0138889;			trMetProb[26].P[51]=0.0138889;			trMetProb[26].P[52]=0.0138889;			trMetProb[26].P[53]=0.0138889;			trMetProb[26].P[54]=0.0138889;			trMetProb[26].P[55]=0.0138889;			trMetProb[26].P[56]=0.0138889;			trMetProb[26].P[57]=0.0138889;			trMetProb[26].P[58]=0.0138889;			trMetProb[26].P[59]=0.0138889;			trMetProb[26].P[60]=0.0138889;			trMetProb[26].P[61]=0.0138889;			trMetProb[26].P[62]=0.0138889;			trMetProb[26].P[63]=0.0138889;			trMetProb[26].P[64]=0.0138889;			trMetProb[26].P[65]=0.0138889;			trMetProb[26].P[66]=0.0138889;			trMetProb[26].P[67]=0.0138889;			trMetProb[26].P[68]=0.0138889;			trMetProb[26].P[69]=0.0138889;			trMetProb[26].P[70]=0.0138889;			trMetProb[26].P[71]=0.0138889;	
		trMetProb[27].P[0]=0.000636132;			trMetProb[27].P[1]=0.000636132;			trMetProb[27].P[2]=0.000636132;			trMetProb[27].P[3]=0.000636132;			trMetProb[27].P[4]=0.000636132;			trMetProb[27].P[5]=0.000636132;			trMetProb[27].P[6]=0.000636132;			trMetProb[27].P[7]=0.000636132;			trMetProb[27].P[8]=0.000636132;			trMetProb[27].P[9]=0.000636132;			trMetProb[27].P[10]=0.000636132;			trMetProb[27].P[11]=0.000636132;			trMetProb[27].P[12]=0.000636132;			trMetProb[27].P[13]=0.000636132;			trMetProb[27].P[14]=0.000636132;			trMetProb[27].P[15]=0.000636132;			trMetProb[27].P[16]=0.000636132;			trMetProb[27].P[17]=0.000636132;			trMetProb[27].P[18]=0.000636132;			trMetProb[27].P[19]=0.000636132;			trMetProb[27].P[20]=0.000636132;			trMetProb[27].P[21]=0.000636132;			trMetProb[27].P[22]=0.000636132;			trMetProb[27].P[23]=0.000636132;			trMetProb[27].P[24]=0.000636132;			trMetProb[27].P[25]=0.000636132;			trMetProb[27].P[26]=0.000636132;			trMetProb[27].P[27]=0.191476;			trMetProb[27].P[28]=0.000636132;			trMetProb[27].P[29]=0.000636132;			trMetProb[27].P[30]=0.744911;			trMetProb[27].P[31]=0.000636132;			trMetProb[27].P[32]=0.000636132;			trMetProb[27].P[33]=0.000636132;			trMetProb[27].P[34]=0.000636132;			trMetProb[27].P[35]=0.000636132;			trMetProb[27].P[36]=0.0197201;			trMetProb[27].P[37]=0.000636132;			trMetProb[27].P[38]=0.000636132;			trMetProb[27].P[39]=0.000636132;			trMetProb[27].P[40]=0.000636132;			trMetProb[27].P[41]=0.000636132;			trMetProb[27].P[42]=0.000636132;			trMetProb[27].P[43]=0.000636132;			trMetProb[27].P[44]=0.000636132;			trMetProb[27].P[45]=0.000636132;			trMetProb[27].P[46]=0.000636132;			trMetProb[27].P[47]=0.000636132;			trMetProb[27].P[48]=0.000636132;			trMetProb[27].P[49]=0.000636132;			trMetProb[27].P[50]=0.000636132;			trMetProb[27].P[51]=0.000636132;			trMetProb[27].P[52]=0.000636132;			trMetProb[27].P[53]=0.000636132;			trMetProb[27].P[54]=0.000636132;			trMetProb[27].P[55]=0.000636132;			trMetProb[27].P[56]=0.000636132;			trMetProb[27].P[57]=0.000636132;			trMetProb[27].P[58]=0.000636132;			trMetProb[27].P[59]=0.000636132;			trMetProb[27].P[60]=0.000636132;			trMetProb[27].P[61]=0.000636132;			trMetProb[27].P[62]=0.000636132;			trMetProb[27].P[63]=0.000636132;			trMetProb[27].P[64]=0.000636132;			trMetProb[27].P[65]=0.000636132;			trMetProb[27].P[66]=0.000636132;			trMetProb[27].P[67]=0.000636132;			trMetProb[27].P[68]=0.000636132;			trMetProb[27].P[69]=0.000636132;			trMetProb[27].P[70]=0.000636132;			trMetProb[27].P[71]=0.000636132;	
		trMetProb[28].P[0]=0.00140449;			trMetProb[28].P[1]=0.00140449;			trMetProb[28].P[2]=0.00140449;			trMetProb[28].P[3]=0.00140449;			trMetProb[28].P[4]=0.00140449;			trMetProb[28].P[5]=0.00140449;			trMetProb[28].P[6]=0.00140449;			trMetProb[28].P[7]=0.00140449;			trMetProb[28].P[8]=0.00140449;			trMetProb[28].P[9]=0.00140449;			trMetProb[28].P[10]=0.00140449;			trMetProb[28].P[11]=0.00140449;			trMetProb[28].P[12]=0.00140449;			trMetProb[28].P[13]=0.00140449;			trMetProb[28].P[14]=0.00140449;			trMetProb[28].P[15]=0.00140449;			trMetProb[28].P[16]=0.00140449;			trMetProb[28].P[17]=0.00140449;			trMetProb[28].P[18]=0.00140449;			trMetProb[28].P[19]=0.00140449;			trMetProb[28].P[20]=0.00140449;			trMetProb[28].P[21]=0.00140449;			trMetProb[28].P[22]=0.00140449;			trMetProb[28].P[23]=0.00140449;			trMetProb[28].P[24]=0.00140449;			trMetProb[28].P[25]=0.00140449;			trMetProb[28].P[26]=0.00140449;			trMetProb[28].P[27]=0.00140449;			trMetProb[28].P[28]=0.0154494;			trMetProb[28].P[29]=0.00140449;			trMetProb[28].P[30]=0.00140449;			trMetProb[28].P[31]=0.00140449;			trMetProb[28].P[32]=0.886236;			trMetProb[28].P[33]=0.00140449;			trMetProb[28].P[34]=0.00140449;			trMetProb[28].P[35]=0.00140449;			trMetProb[28].P[36]=0.00140449;			trMetProb[28].P[37]=0.00140449;			trMetProb[28].P[38]=0.00140449;			trMetProb[28].P[39]=0.00140449;			trMetProb[28].P[40]=0.00140449;			trMetProb[28].P[41]=0.00140449;			trMetProb[28].P[42]=0.00140449;			trMetProb[28].P[43]=0.00140449;			trMetProb[28].P[44]=0.00140449;			trMetProb[28].P[45]=0.00140449;			trMetProb[28].P[46]=0.00140449;			trMetProb[28].P[47]=0.00140449;			trMetProb[28].P[48]=0.00140449;			trMetProb[28].P[49]=0.00140449;			trMetProb[28].P[50]=0.00140449;			trMetProb[28].P[51]=0.00140449;			trMetProb[28].P[52]=0.00140449;			trMetProb[28].P[53]=0.00140449;			trMetProb[28].P[54]=0.00140449;			trMetProb[28].P[55]=0.00140449;			trMetProb[28].P[56]=0.00140449;			trMetProb[28].P[57]=0.00140449;			trMetProb[28].P[58]=0.00140449;			trMetProb[28].P[59]=0.00140449;			trMetProb[28].P[60]=0.00140449;			trMetProb[28].P[61]=0.00140449;			trMetProb[28].P[62]=0.00140449;			trMetProb[28].P[63]=0.00140449;			trMetProb[28].P[64]=0.00140449;			trMetProb[28].P[65]=0.00140449;			trMetProb[28].P[66]=0.00140449;			trMetProb[28].P[67]=0.00140449;			trMetProb[28].P[68]=0.00140449;			trMetProb[28].P[69]=0.00140449;			trMetProb[28].P[70]=0.00140449;			trMetProb[28].P[71]=0.00140449;	
		trMetProb[29].P[0]=0.0138889;			trMetProb[29].P[1]=0.0138889;			trMetProb[29].P[2]=0.0138889;			trMetProb[29].P[3]=0.0138889;			trMetProb[29].P[4]=0.0138889;			trMetProb[29].P[5]=0.0138889;			trMetProb[29].P[6]=0.0138889;			trMetProb[29].P[7]=0.0138889;			trMetProb[29].P[8]=0.0138889;			trMetProb[29].P[9]=0.0138889;			trMetProb[29].P[10]=0.0138889;			trMetProb[29].P[11]=0.0138889;			trMetProb[29].P[12]=0.0138889;			trMetProb[29].P[13]=0.0138889;			trMetProb[29].P[14]=0.0138889;			trMetProb[29].P[15]=0.0138889;			trMetProb[29].P[16]=0.0138889;			trMetProb[29].P[17]=0.0138889;			trMetProb[29].P[18]=0.0138889;			trMetProb[29].P[19]=0.0138889;			trMetProb[29].P[20]=0.0138889;			trMetProb[29].P[21]=0.0138889;			trMetProb[29].P[22]=0.0138889;			trMetProb[29].P[23]=0.0138889;			trMetProb[29].P[24]=0.0138889;			trMetProb[29].P[25]=0.0138889;			trMetProb[29].P[26]=0.0138889;			trMetProb[29].P[27]=0.0138889;			trMetProb[29].P[28]=0.0138889;			trMetProb[29].P[29]=0.0138889;			trMetProb[29].P[30]=0.0138889;			trMetProb[29].P[31]=0.0138889;			trMetProb[29].P[32]=0.0138889;			trMetProb[29].P[33]=0.0138889;			trMetProb[29].P[34]=0.0138889;			trMetProb[29].P[35]=0.0138889;			trMetProb[29].P[36]=0.0138889;			trMetProb[29].P[37]=0.0138889;			trMetProb[29].P[38]=0.0138889;			trMetProb[29].P[39]=0.0138889;			trMetProb[29].P[40]=0.0138889;			trMetProb[29].P[41]=0.0138889;			trMetProb[29].P[42]=0.0138889;			trMetProb[29].P[43]=0.0138889;			trMetProb[29].P[44]=0.0138889;			trMetProb[29].P[45]=0.0138889;			trMetProb[29].P[46]=0.0138889;			trMetProb[29].P[47]=0.0138889;			trMetProb[29].P[48]=0.0138889;			trMetProb[29].P[49]=0.0138889;			trMetProb[29].P[50]=0.0138889;			trMetProb[29].P[51]=0.0138889;			trMetProb[29].P[52]=0.0138889;			trMetProb[29].P[53]=0.0138889;			trMetProb[29].P[54]=0.0138889;			trMetProb[29].P[55]=0.0138889;			trMetProb[29].P[56]=0.0138889;			trMetProb[29].P[57]=0.0138889;			trMetProb[29].P[58]=0.0138889;			trMetProb[29].P[59]=0.0138889;			trMetProb[29].P[60]=0.0138889;			trMetProb[29].P[61]=0.0138889;			trMetProb[29].P[62]=0.0138889;			trMetProb[29].P[63]=0.0138889;			trMetProb[29].P[64]=0.0138889;			trMetProb[29].P[65]=0.0138889;			trMetProb[29].P[66]=0.0138889;			trMetProb[29].P[67]=0.0138889;			trMetProb[29].P[68]=0.0138889;			trMetProb[29].P[69]=0.0138889;			trMetProb[29].P[70]=0.0138889;			trMetProb[29].P[71]=0.0138889;	
		trMetProb[30].P[0]=0.000934421;			trMetProb[30].P[1]=8.49473e-05;			trMetProb[30].P[2]=8.49473e-05;			trMetProb[30].P[3]=8.49473e-05;			trMetProb[30].P[4]=8.49473e-05;			trMetProb[30].P[5]=8.49473e-05;			trMetProb[30].P[6]=8.49473e-05;			trMetProb[30].P[7]=8.49473e-05;			trMetProb[30].P[8]=8.49473e-05;			trMetProb[30].P[9]=8.49473e-05;			trMetProb[30].P[10]=8.49473e-05;			trMetProb[30].P[11]=8.49473e-05;			trMetProb[30].P[12]=8.49473e-05;			trMetProb[30].P[13]=8.49473e-05;			trMetProb[30].P[14]=8.49473e-05;			trMetProb[30].P[15]=8.49473e-05;			trMetProb[30].P[16]=8.49473e-05;			trMetProb[30].P[17]=8.49473e-05;			trMetProb[30].P[18]=8.49473e-05;			trMetProb[30].P[19]=8.49473e-05;			trMetProb[30].P[20]=8.49473e-05;			trMetProb[30].P[21]=8.49473e-05;			trMetProb[30].P[22]=8.49473e-05;			trMetProb[30].P[23]=8.49473e-05;			trMetProb[30].P[24]=8.49473e-05;			trMetProb[30].P[25]=8.49473e-05;			trMetProb[30].P[26]=8.49473e-05;			trMetProb[30].P[27]=8.49473e-05;			trMetProb[30].P[28]=8.49473e-05;			trMetProb[30].P[29]=8.49473e-05;			trMetProb[30].P[30]=0.226045;			trMetProb[30].P[31]=8.49473e-05;			trMetProb[30].P[32]=8.49473e-05;			trMetProb[30].P[33]=0.113065;			trMetProb[30].P[34]=8.49473e-05;			trMetProb[30].P[35]=8.49473e-05;			trMetProb[30].P[36]=0.650782;			trMetProb[30].P[37]=8.49473e-05;			trMetProb[30].P[38]=8.49473e-05;			trMetProb[30].P[39]=8.49473e-05;			trMetProb[30].P[40]=8.49473e-05;			trMetProb[30].P[41]=8.49473e-05;			trMetProb[30].P[42]=8.49473e-05;			trMetProb[30].P[43]=8.49473e-05;			trMetProb[30].P[44]=8.49473e-05;			trMetProb[30].P[45]=8.49473e-05;			trMetProb[30].P[46]=8.49473e-05;			trMetProb[30].P[47]=8.49473e-05;			trMetProb[30].P[48]=0.00348284;			trMetProb[30].P[49]=8.49473e-05;			trMetProb[30].P[50]=8.49473e-05;			trMetProb[30].P[51]=8.49473e-05;			trMetProb[30].P[52]=8.49473e-05;			trMetProb[30].P[53]=8.49473e-05;			trMetProb[30].P[54]=8.49473e-05;			trMetProb[30].P[55]=8.49473e-05;			trMetProb[30].P[56]=8.49473e-05;			trMetProb[30].P[57]=8.49473e-05;			trMetProb[30].P[58]=8.49473e-05;			trMetProb[30].P[59]=8.49473e-05;			trMetProb[30].P[60]=8.49473e-05;			trMetProb[30].P[61]=8.49473e-05;			trMetProb[30].P[62]=8.49473e-05;			trMetProb[30].P[63]=8.49473e-05;			trMetProb[30].P[64]=8.49473e-05;			trMetProb[30].P[65]=8.49473e-05;			trMetProb[30].P[66]=8.49473e-05;			trMetProb[30].P[67]=8.49473e-05;			trMetProb[30].P[68]=8.49473e-05;			trMetProb[30].P[69]=8.49473e-05;			trMetProb[30].P[70]=8.49473e-05;			trMetProb[30].P[71]=8.49473e-05;	
		trMetProb[31].P[0]=0.0138889;			trMetProb[31].P[1]=0.0138889;			trMetProb[31].P[2]=0.0138889;			trMetProb[31].P[3]=0.0138889;			trMetProb[31].P[4]=0.0138889;			trMetProb[31].P[5]=0.0138889;			trMetProb[31].P[6]=0.0138889;			trMetProb[31].P[7]=0.0138889;			trMetProb[31].P[8]=0.0138889;			trMetProb[31].P[9]=0.0138889;			trMetProb[31].P[10]=0.0138889;			trMetProb[31].P[11]=0.0138889;			trMetProb[31].P[12]=0.0138889;			trMetProb[31].P[13]=0.0138889;			trMetProb[31].P[14]=0.0138889;			trMetProb[31].P[15]=0.0138889;			trMetProb[31].P[16]=0.0138889;			trMetProb[31].P[17]=0.0138889;			trMetProb[31].P[18]=0.0138889;			trMetProb[31].P[19]=0.0138889;			trMetProb[31].P[20]=0.0138889;			trMetProb[31].P[21]=0.0138889;			trMetProb[31].P[22]=0.0138889;			trMetProb[31].P[23]=0.0138889;			trMetProb[31].P[24]=0.0138889;			trMetProb[31].P[25]=0.0138889;			trMetProb[31].P[26]=0.0138889;			trMetProb[31].P[27]=0.0138889;			trMetProb[31].P[28]=0.0138889;			trMetProb[31].P[29]=0.0138889;			trMetProb[31].P[30]=0.0138889;			trMetProb[31].P[31]=0.0138889;			trMetProb[31].P[32]=0.0138889;			trMetProb[31].P[33]=0.0138889;			trMetProb[31].P[34]=0.0138889;			trMetProb[31].P[35]=0.0138889;			trMetProb[31].P[36]=0.0138889;			trMetProb[31].P[37]=0.0138889;			trMetProb[31].P[38]=0.0138889;			trMetProb[31].P[39]=0.0138889;			trMetProb[31].P[40]=0.0138889;			trMetProb[31].P[41]=0.0138889;			trMetProb[31].P[42]=0.0138889;			trMetProb[31].P[43]=0.0138889;			trMetProb[31].P[44]=0.0138889;			trMetProb[31].P[45]=0.0138889;			trMetProb[31].P[46]=0.0138889;			trMetProb[31].P[47]=0.0138889;			trMetProb[31].P[48]=0.0138889;			trMetProb[31].P[49]=0.0138889;			trMetProb[31].P[50]=0.0138889;			trMetProb[31].P[51]=0.0138889;			trMetProb[31].P[52]=0.0138889;			trMetProb[31].P[53]=0.0138889;			trMetProb[31].P[54]=0.0138889;			trMetProb[31].P[55]=0.0138889;			trMetProb[31].P[56]=0.0138889;			trMetProb[31].P[57]=0.0138889;			trMetProb[31].P[58]=0.0138889;			trMetProb[31].P[59]=0.0138889;			trMetProb[31].P[60]=0.0138889;			trMetProb[31].P[61]=0.0138889;			trMetProb[31].P[62]=0.0138889;			trMetProb[31].P[63]=0.0138889;			trMetProb[31].P[64]=0.0138889;			trMetProb[31].P[65]=0.0138889;			trMetProb[31].P[66]=0.0138889;			trMetProb[31].P[67]=0.0138889;			trMetProb[31].P[68]=0.0138889;			trMetProb[31].P[69]=0.0138889;			trMetProb[31].P[70]=0.0138889;			trMetProb[31].P[71]=0.0138889;	
		trMetProb[32].P[0]=0.000163613;			trMetProb[32].P[1]=0.000163613;			trMetProb[32].P[2]=0.000163613;			trMetProb[32].P[3]=0.000163613;			trMetProb[32].P[4]=0.000163613;			trMetProb[32].P[5]=0.000163613;			trMetProb[32].P[6]=0.000163613;			trMetProb[32].P[7]=0.000163613;			trMetProb[32].P[8]=0.000163613;			trMetProb[32].P[9]=0.000163613;			trMetProb[32].P[10]=0.000163613;			trMetProb[32].P[11]=0.000163613;			trMetProb[32].P[12]=0.000163613;			trMetProb[32].P[13]=0.000163613;			trMetProb[32].P[14]=0.000163613;			trMetProb[32].P[15]=0.000163613;			trMetProb[32].P[16]=0.000163613;			trMetProb[32].P[17]=0.000163613;			trMetProb[32].P[18]=0.000163613;			trMetProb[32].P[19]=0.000163613;			trMetProb[32].P[20]=0.000163613;			trMetProb[32].P[21]=0.000163613;			trMetProb[32].P[22]=0.000163613;			trMetProb[32].P[23]=0.000163613;			trMetProb[32].P[24]=0.000163613;			trMetProb[32].P[25]=0.000163613;			trMetProb[32].P[26]=0.000163613;			trMetProb[32].P[27]=0.000163613;			trMetProb[32].P[28]=0.000163613;			trMetProb[32].P[29]=0.000163613;			trMetProb[32].P[30]=0.000163613;			trMetProb[32].P[31]=0.000163613;			trMetProb[32].P[32]=0.171957;			trMetProb[32].P[33]=0.00507199;			trMetProb[32].P[34]=0.000163613;			trMetProb[32].P[35]=0.000163613;			trMetProb[32].P[36]=0.113056;			trMetProb[32].P[37]=0.000163613;			trMetProb[32].P[38]=0.000163613;			trMetProb[32].P[39]=0.000163613;			trMetProb[32].P[40]=0.698789;			trMetProb[32].P[41]=0.000163613;			trMetProb[32].P[42]=0.000163613;			trMetProb[32].P[43]=0.000163613;			trMetProb[32].P[44]=0.000163613;			trMetProb[32].P[45]=0.000163613;			trMetProb[32].P[46]=0.000163613;			trMetProb[32].P[47]=0.000163613;			trMetProb[32].P[48]=0.000163613;			trMetProb[32].P[49]=0.000163613;			trMetProb[32].P[50]=0.000163613;			trMetProb[32].P[51]=0.000163613;			trMetProb[32].P[52]=0.000163613;			trMetProb[32].P[53]=0.000163613;			trMetProb[32].P[54]=0.000163613;			trMetProb[32].P[55]=0.000163613;			trMetProb[32].P[56]=0.000163613;			trMetProb[32].P[57]=0.000163613;			trMetProb[32].P[58]=0.000163613;			trMetProb[32].P[59]=0.000163613;			trMetProb[32].P[60]=0.000163613;			trMetProb[32].P[61]=0.000163613;			trMetProb[32].P[62]=0.000163613;			trMetProb[32].P[63]=0.000163613;			trMetProb[32].P[64]=0.000163613;			trMetProb[32].P[65]=0.000163613;			trMetProb[32].P[66]=0.000163613;			trMetProb[32].P[67]=0.000163613;			trMetProb[32].P[68]=0.000163613;			trMetProb[32].P[69]=0.000163613;			trMetProb[32].P[70]=0.000163613;			trMetProb[32].P[71]=0.000163613;	
		trMetProb[33].P[0]=0.000551876;			trMetProb[33].P[1]=0.000551876;			trMetProb[33].P[2]=0.000551876;			trMetProb[33].P[3]=0.000551876;			trMetProb[33].P[4]=0.000551876;			trMetProb[33].P[5]=0.000551876;			trMetProb[33].P[6]=0.000551876;			trMetProb[33].P[7]=0.000551876;			trMetProb[33].P[8]=0.000551876;			trMetProb[33].P[9]=0.000551876;			trMetProb[33].P[10]=0.000551876;			trMetProb[33].P[11]=0.000551876;			trMetProb[33].P[12]=0.000551876;			trMetProb[33].P[13]=0.000551876;			trMetProb[33].P[14]=0.000551876;			trMetProb[33].P[15]=0.000551876;			trMetProb[33].P[16]=0.000551876;			trMetProb[33].P[17]=0.000551876;			trMetProb[33].P[18]=0.000551876;			trMetProb[33].P[19]=0.000551876;			trMetProb[33].P[20]=0.000551876;			trMetProb[33].P[21]=0.000551876;			trMetProb[33].P[22]=0.000551876;			trMetProb[33].P[23]=0.000551876;			trMetProb[33].P[24]=0.000551876;			trMetProb[33].P[25]=0.000551876;			trMetProb[33].P[26]=0.000551876;			trMetProb[33].P[27]=0.000551876;			trMetProb[33].P[28]=0.000551876;			trMetProb[33].P[29]=0.000551876;			trMetProb[33].P[30]=0.000551876;			trMetProb[33].P[31]=0.000551876;			trMetProb[33].P[32]=0.000551876;			trMetProb[33].P[33]=0.166115;			trMetProb[33].P[34]=0.000551876;			trMetProb[33].P[35]=0.000551876;			trMetProb[33].P[36]=0.795254;			trMetProb[33].P[37]=0.000551876;			trMetProb[33].P[38]=0.000551876;			trMetProb[33].P[39]=0.000551876;			trMetProb[33].P[40]=0.000551876;			trMetProb[33].P[41]=0.000551876;			trMetProb[33].P[42]=0.000551876;			trMetProb[33].P[43]=0.000551876;			trMetProb[33].P[44]=0.000551876;			trMetProb[33].P[45]=0.000551876;			trMetProb[33].P[46]=0.000551876;			trMetProb[33].P[47]=0.000551876;			trMetProb[33].P[48]=0.000551876;			trMetProb[33].P[49]=0.000551876;			trMetProb[33].P[50]=0.000551876;			trMetProb[33].P[51]=0.000551876;			trMetProb[33].P[52]=0.000551876;			trMetProb[33].P[53]=0.000551876;			trMetProb[33].P[54]=0.000551876;			trMetProb[33].P[55]=0.000551876;			trMetProb[33].P[56]=0.000551876;			trMetProb[33].P[57]=0.000551876;			trMetProb[33].P[58]=0.000551876;			trMetProb[33].P[59]=0.000551876;			trMetProb[33].P[60]=0.000551876;			trMetProb[33].P[61]=0.000551876;			trMetProb[33].P[62]=0.000551876;			trMetProb[33].P[63]=0.000551876;			trMetProb[33].P[64]=0.000551876;			trMetProb[33].P[65]=0.000551876;			trMetProb[33].P[66]=0.000551876;			trMetProb[33].P[67]=0.000551876;			trMetProb[33].P[68]=0.000551876;			trMetProb[33].P[69]=0.000551876;			trMetProb[33].P[70]=0.000551876;			trMetProb[33].P[71]=0.000551876;	
		trMetProb[34].P[0]=0.0138889;			trMetProb[34].P[1]=0.0138889;			trMetProb[34].P[2]=0.0138889;			trMetProb[34].P[3]=0.0138889;			trMetProb[34].P[4]=0.0138889;			trMetProb[34].P[5]=0.0138889;			trMetProb[34].P[6]=0.0138889;			trMetProb[34].P[7]=0.0138889;			trMetProb[34].P[8]=0.0138889;			trMetProb[34].P[9]=0.0138889;			trMetProb[34].P[10]=0.0138889;			trMetProb[34].P[11]=0.0138889;			trMetProb[34].P[12]=0.0138889;			trMetProb[34].P[13]=0.0138889;			trMetProb[34].P[14]=0.0138889;			trMetProb[34].P[15]=0.0138889;			trMetProb[34].P[16]=0.0138889;			trMetProb[34].P[17]=0.0138889;			trMetProb[34].P[18]=0.0138889;			trMetProb[34].P[19]=0.0138889;			trMetProb[34].P[20]=0.0138889;			trMetProb[34].P[21]=0.0138889;			trMetProb[34].P[22]=0.0138889;			trMetProb[34].P[23]=0.0138889;			trMetProb[34].P[24]=0.0138889;			trMetProb[34].P[25]=0.0138889;			trMetProb[34].P[26]=0.0138889;			trMetProb[34].P[27]=0.0138889;			trMetProb[34].P[28]=0.0138889;			trMetProb[34].P[29]=0.0138889;			trMetProb[34].P[30]=0.0138889;			trMetProb[34].P[31]=0.0138889;			trMetProb[34].P[32]=0.0138889;			trMetProb[34].P[33]=0.0138889;			trMetProb[34].P[34]=0.0138889;			trMetProb[34].P[35]=0.0138889;			trMetProb[34].P[36]=0.0138889;			trMetProb[34].P[37]=0.0138889;			trMetProb[34].P[38]=0.0138889;			trMetProb[34].P[39]=0.0138889;			trMetProb[34].P[40]=0.0138889;			trMetProb[34].P[41]=0.0138889;			trMetProb[34].P[42]=0.0138889;			trMetProb[34].P[43]=0.0138889;			trMetProb[34].P[44]=0.0138889;			trMetProb[34].P[45]=0.0138889;			trMetProb[34].P[46]=0.0138889;			trMetProb[34].P[47]=0.0138889;			trMetProb[34].P[48]=0.0138889;			trMetProb[34].P[49]=0.0138889;			trMetProb[34].P[50]=0.0138889;			trMetProb[34].P[51]=0.0138889;			trMetProb[34].P[52]=0.0138889;			trMetProb[34].P[53]=0.0138889;			trMetProb[34].P[54]=0.0138889;			trMetProb[34].P[55]=0.0138889;			trMetProb[34].P[56]=0.0138889;			trMetProb[34].P[57]=0.0138889;			trMetProb[34].P[58]=0.0138889;			trMetProb[34].P[59]=0.0138889;			trMetProb[34].P[60]=0.0138889;			trMetProb[34].P[61]=0.0138889;			trMetProb[34].P[62]=0.0138889;			trMetProb[34].P[63]=0.0138889;			trMetProb[34].P[64]=0.0138889;			trMetProb[34].P[65]=0.0138889;			trMetProb[34].P[66]=0.0138889;			trMetProb[34].P[67]=0.0138889;			trMetProb[34].P[68]=0.0138889;			trMetProb[34].P[69]=0.0138889;			trMetProb[34].P[70]=0.0138889;			trMetProb[34].P[71]=0.0138889;	
		trMetProb[35].P[0]=0.0138889;			trMetProb[35].P[1]=0.0138889;			trMetProb[35].P[2]=0.0138889;			trMetProb[35].P[3]=0.0138889;			trMetProb[35].P[4]=0.0138889;			trMetProb[35].P[5]=0.0138889;			trMetProb[35].P[6]=0.0138889;			trMetProb[35].P[7]=0.0138889;			trMetProb[35].P[8]=0.0138889;			trMetProb[35].P[9]=0.0138889;			trMetProb[35].P[10]=0.0138889;			trMetProb[35].P[11]=0.0138889;			trMetProb[35].P[12]=0.0138889;			trMetProb[35].P[13]=0.0138889;			trMetProb[35].P[14]=0.0138889;			trMetProb[35].P[15]=0.0138889;			trMetProb[35].P[16]=0.0138889;			trMetProb[35].P[17]=0.0138889;			trMetProb[35].P[18]=0.0138889;			trMetProb[35].P[19]=0.0138889;			trMetProb[35].P[20]=0.0138889;			trMetProb[35].P[21]=0.0138889;			trMetProb[35].P[22]=0.0138889;			trMetProb[35].P[23]=0.0138889;			trMetProb[35].P[24]=0.0138889;			trMetProb[35].P[25]=0.0138889;			trMetProb[35].P[26]=0.0138889;			trMetProb[35].P[27]=0.0138889;			trMetProb[35].P[28]=0.0138889;			trMetProb[35].P[29]=0.0138889;			trMetProb[35].P[30]=0.0138889;			trMetProb[35].P[31]=0.0138889;			trMetProb[35].P[32]=0.0138889;			trMetProb[35].P[33]=0.0138889;			trMetProb[35].P[34]=0.0138889;			trMetProb[35].P[35]=0.0138889;			trMetProb[35].P[36]=0.0138889;			trMetProb[35].P[37]=0.0138889;			trMetProb[35].P[38]=0.0138889;			trMetProb[35].P[39]=0.0138889;			trMetProb[35].P[40]=0.0138889;			trMetProb[35].P[41]=0.0138889;			trMetProb[35].P[42]=0.0138889;			trMetProb[35].P[43]=0.0138889;			trMetProb[35].P[44]=0.0138889;			trMetProb[35].P[45]=0.0138889;			trMetProb[35].P[46]=0.0138889;			trMetProb[35].P[47]=0.0138889;			trMetProb[35].P[48]=0.0138889;			trMetProb[35].P[49]=0.0138889;			trMetProb[35].P[50]=0.0138889;			trMetProb[35].P[51]=0.0138889;			trMetProb[35].P[52]=0.0138889;			trMetProb[35].P[53]=0.0138889;			trMetProb[35].P[54]=0.0138889;			trMetProb[35].P[55]=0.0138889;			trMetProb[35].P[56]=0.0138889;			trMetProb[35].P[57]=0.0138889;			trMetProb[35].P[58]=0.0138889;			trMetProb[35].P[59]=0.0138889;			trMetProb[35].P[60]=0.0138889;			trMetProb[35].P[61]=0.0138889;			trMetProb[35].P[62]=0.0138889;			trMetProb[35].P[63]=0.0138889;			trMetProb[35].P[64]=0.0138889;			trMetProb[35].P[65]=0.0138889;			trMetProb[35].P[66]=0.0138889;			trMetProb[35].P[67]=0.0138889;			trMetProb[35].P[68]=0.0138889;			trMetProb[35].P[69]=0.0138889;			trMetProb[35].P[70]=0.0138889;			trMetProb[35].P[71]=0.0138889;	
		trMetProb[36].P[0]=1.36702e-05;			trMetProb[36].P[1]=1.36702e-05;			trMetProb[36].P[2]=1.36702e-05;			trMetProb[36].P[3]=1.36702e-05;			trMetProb[36].P[4]=1.36702e-05;			trMetProb[36].P[5]=1.36702e-05;			trMetProb[36].P[6]=1.36702e-05;			trMetProb[36].P[7]=1.36702e-05;			trMetProb[36].P[8]=1.36702e-05;			trMetProb[36].P[9]=1.36702e-05;			trMetProb[36].P[10]=1.36702e-05;			trMetProb[36].P[11]=1.36702e-05;			trMetProb[36].P[12]=1.36702e-05;			trMetProb[36].P[13]=1.36702e-05;			trMetProb[36].P[14]=1.36702e-05;			trMetProb[36].P[15]=1.36702e-05;			trMetProb[36].P[16]=1.36702e-05;			trMetProb[36].P[17]=1.36702e-05;			trMetProb[36].P[18]=1.36702e-05;			trMetProb[36].P[19]=1.36702e-05;			trMetProb[36].P[20]=1.36702e-05;			trMetProb[36].P[21]=1.36702e-05;			trMetProb[36].P[22]=1.36702e-05;			trMetProb[36].P[23]=1.36702e-05;			trMetProb[36].P[24]=1.36702e-05;			trMetProb[36].P[25]=1.36702e-05;			trMetProb[36].P[26]=1.36702e-05;			trMetProb[36].P[27]=1.36702e-05;			trMetProb[36].P[28]=1.36702e-05;			trMetProb[36].P[29]=1.36702e-05;			trMetProb[36].P[30]=1.36702e-05;			trMetProb[36].P[31]=1.36702e-05;			trMetProb[36].P[32]=1.36702e-05;			trMetProb[36].P[33]=1.36702e-05;			trMetProb[36].P[34]=1.36702e-05;			trMetProb[36].P[35]=1.36702e-05;			trMetProb[36].P[36]=0.32468;			trMetProb[36].P[37]=1.36702e-05;			trMetProb[36].P[38]=1.36702e-05;			trMetProb[36].P[39]=0.0205189;			trMetProb[36].P[40]=0.0105397;			trMetProb[36].P[41]=1.36702e-05;			trMetProb[36].P[42]=0.112929;			trMetProb[36].P[43]=1.36702e-05;			trMetProb[36].P[44]=1.36702e-05;			trMetProb[36].P[45]=0.0022009;			trMetProb[36].P[46]=1.36702e-05;			trMetProb[36].P[47]=1.36702e-05;			trMetProb[36].P[48]=0.527955;			trMetProb[36].P[49]=1.36702e-05;			trMetProb[36].P[50]=1.36702e-05;			trMetProb[36].P[51]=1.36702e-05;			trMetProb[36].P[52]=1.36702e-05;			trMetProb[36].P[53]=1.36702e-05;			trMetProb[36].P[54]=0.000150372;			trMetProb[36].P[55]=1.36702e-05;			trMetProb[36].P[56]=1.36702e-05;			trMetProb[36].P[57]=1.36702e-05;			trMetProb[36].P[58]=1.36702e-05;			trMetProb[36].P[59]=1.36702e-05;			trMetProb[36].P[60]=0.000150372;			trMetProb[36].P[61]=1.36702e-05;			trMetProb[36].P[62]=1.36702e-05;			trMetProb[36].P[63]=1.36702e-05;			trMetProb[36].P[64]=1.36702e-05;			trMetProb[36].P[65]=1.36702e-05;			trMetProb[36].P[66]=1.36702e-05;			trMetProb[36].P[67]=1.36702e-05;			trMetProb[36].P[68]=1.36702e-05;			trMetProb[36].P[69]=1.36702e-05;			trMetProb[36].P[70]=1.36702e-05;			trMetProb[36].P[71]=1.36702e-05;	
		trMetProb[37].P[0]=0.0138889;			trMetProb[37].P[1]=0.0138889;			trMetProb[37].P[2]=0.0138889;			trMetProb[37].P[3]=0.0138889;			trMetProb[37].P[4]=0.0138889;			trMetProb[37].P[5]=0.0138889;			trMetProb[37].P[6]=0.0138889;			trMetProb[37].P[7]=0.0138889;			trMetProb[37].P[8]=0.0138889;			trMetProb[37].P[9]=0.0138889;			trMetProb[37].P[10]=0.0138889;			trMetProb[37].P[11]=0.0138889;			trMetProb[37].P[12]=0.0138889;			trMetProb[37].P[13]=0.0138889;			trMetProb[37].P[14]=0.0138889;			trMetProb[37].P[15]=0.0138889;			trMetProb[37].P[16]=0.0138889;			trMetProb[37].P[17]=0.0138889;			trMetProb[37].P[18]=0.0138889;			trMetProb[37].P[19]=0.0138889;			trMetProb[37].P[20]=0.0138889;			trMetProb[37].P[21]=0.0138889;			trMetProb[37].P[22]=0.0138889;			trMetProb[37].P[23]=0.0138889;			trMetProb[37].P[24]=0.0138889;			trMetProb[37].P[25]=0.0138889;			trMetProb[37].P[26]=0.0138889;			trMetProb[37].P[27]=0.0138889;			trMetProb[37].P[28]=0.0138889;			trMetProb[37].P[29]=0.0138889;			trMetProb[37].P[30]=0.0138889;			trMetProb[37].P[31]=0.0138889;			trMetProb[37].P[32]=0.0138889;			trMetProb[37].P[33]=0.0138889;			trMetProb[37].P[34]=0.0138889;			trMetProb[37].P[35]=0.0138889;			trMetProb[37].P[36]=0.0138889;			trMetProb[37].P[37]=0.0138889;			trMetProb[37].P[38]=0.0138889;			trMetProb[37].P[39]=0.0138889;			trMetProb[37].P[40]=0.0138889;			trMetProb[37].P[41]=0.0138889;			trMetProb[37].P[42]=0.0138889;			trMetProb[37].P[43]=0.0138889;			trMetProb[37].P[44]=0.0138889;			trMetProb[37].P[45]=0.0138889;			trMetProb[37].P[46]=0.0138889;			trMetProb[37].P[47]=0.0138889;			trMetProb[37].P[48]=0.0138889;			trMetProb[37].P[49]=0.0138889;			trMetProb[37].P[50]=0.0138889;			trMetProb[37].P[51]=0.0138889;			trMetProb[37].P[52]=0.0138889;			trMetProb[37].P[53]=0.0138889;			trMetProb[37].P[54]=0.0138889;			trMetProb[37].P[55]=0.0138889;			trMetProb[37].P[56]=0.0138889;			trMetProb[37].P[57]=0.0138889;			trMetProb[37].P[58]=0.0138889;			trMetProb[37].P[59]=0.0138889;			trMetProb[37].P[60]=0.0138889;			trMetProb[37].P[61]=0.0138889;			trMetProb[37].P[62]=0.0138889;			trMetProb[37].P[63]=0.0138889;			trMetProb[37].P[64]=0.0138889;			trMetProb[37].P[65]=0.0138889;			trMetProb[37].P[66]=0.0138889;			trMetProb[37].P[67]=0.0138889;			trMetProb[37].P[68]=0.0138889;			trMetProb[37].P[69]=0.0138889;			trMetProb[37].P[70]=0.0138889;			trMetProb[37].P[71]=0.0138889;	
		trMetProb[38].P[0]=0.0138889;			trMetProb[38].P[1]=0.0138889;			trMetProb[38].P[2]=0.0138889;			trMetProb[38].P[3]=0.0138889;			trMetProb[38].P[4]=0.0138889;			trMetProb[38].P[5]=0.0138889;			trMetProb[38].P[6]=0.0138889;			trMetProb[38].P[7]=0.0138889;			trMetProb[38].P[8]=0.0138889;			trMetProb[38].P[9]=0.0138889;			trMetProb[38].P[10]=0.0138889;			trMetProb[38].P[11]=0.0138889;			trMetProb[38].P[12]=0.0138889;			trMetProb[38].P[13]=0.0138889;			trMetProb[38].P[14]=0.0138889;			trMetProb[38].P[15]=0.0138889;			trMetProb[38].P[16]=0.0138889;			trMetProb[38].P[17]=0.0138889;			trMetProb[38].P[18]=0.0138889;			trMetProb[38].P[19]=0.0138889;			trMetProb[38].P[20]=0.0138889;			trMetProb[38].P[21]=0.0138889;			trMetProb[38].P[22]=0.0138889;			trMetProb[38].P[23]=0.0138889;			trMetProb[38].P[24]=0.0138889;			trMetProb[38].P[25]=0.0138889;			trMetProb[38].P[26]=0.0138889;			trMetProb[38].P[27]=0.0138889;			trMetProb[38].P[28]=0.0138889;			trMetProb[38].P[29]=0.0138889;			trMetProb[38].P[30]=0.0138889;			trMetProb[38].P[31]=0.0138889;			trMetProb[38].P[32]=0.0138889;			trMetProb[38].P[33]=0.0138889;			trMetProb[38].P[34]=0.0138889;			trMetProb[38].P[35]=0.0138889;			trMetProb[38].P[36]=0.0138889;			trMetProb[38].P[37]=0.0138889;			trMetProb[38].P[38]=0.0138889;			trMetProb[38].P[39]=0.0138889;			trMetProb[38].P[40]=0.0138889;			trMetProb[38].P[41]=0.0138889;			trMetProb[38].P[42]=0.0138889;			trMetProb[38].P[43]=0.0138889;			trMetProb[38].P[44]=0.0138889;			trMetProb[38].P[45]=0.0138889;			trMetProb[38].P[46]=0.0138889;			trMetProb[38].P[47]=0.0138889;			trMetProb[38].P[48]=0.0138889;			trMetProb[38].P[49]=0.0138889;			trMetProb[38].P[50]=0.0138889;			trMetProb[38].P[51]=0.0138889;			trMetProb[38].P[52]=0.0138889;			trMetProb[38].P[53]=0.0138889;			trMetProb[38].P[54]=0.0138889;			trMetProb[38].P[55]=0.0138889;			trMetProb[38].P[56]=0.0138889;			trMetProb[38].P[57]=0.0138889;			trMetProb[38].P[58]=0.0138889;			trMetProb[38].P[59]=0.0138889;			trMetProb[38].P[60]=0.0138889;			trMetProb[38].P[61]=0.0138889;			trMetProb[38].P[62]=0.0138889;			trMetProb[38].P[63]=0.0138889;			trMetProb[38].P[64]=0.0138889;			trMetProb[38].P[65]=0.0138889;			trMetProb[38].P[66]=0.0138889;			trMetProb[38].P[67]=0.0138889;			trMetProb[38].P[68]=0.0138889;			trMetProb[38].P[69]=0.0138889;			trMetProb[38].P[70]=0.0138889;			trMetProb[38].P[71]=0.0138889;	
		trMetProb[39].P[0]=0.000517598;			trMetProb[39].P[1]=0.000517598;			trMetProb[39].P[2]=0.000517598;			trMetProb[39].P[3]=0.000517598;			trMetProb[39].P[4]=0.000517598;			trMetProb[39].P[5]=0.000517598;			trMetProb[39].P[6]=0.000517598;			trMetProb[39].P[7]=0.000517598;			trMetProb[39].P[8]=0.000517598;			trMetProb[39].P[9]=0.000517598;			trMetProb[39].P[10]=0.000517598;			trMetProb[39].P[11]=0.000517598;			trMetProb[39].P[12]=0.000517598;			trMetProb[39].P[13]=0.000517598;			trMetProb[39].P[14]=0.000517598;			trMetProb[39].P[15]=0.000517598;			trMetProb[39].P[16]=0.000517598;			trMetProb[39].P[17]=0.000517598;			trMetProb[39].P[18]=0.000517598;			trMetProb[39].P[19]=0.000517598;			trMetProb[39].P[20]=0.000517598;			trMetProb[39].P[21]=0.000517598;			trMetProb[39].P[22]=0.000517598;			trMetProb[39].P[23]=0.000517598;			trMetProb[39].P[24]=0.000517598;			trMetProb[39].P[25]=0.000517598;			trMetProb[39].P[26]=0.000517598;			trMetProb[39].P[27]=0.000517598;			trMetProb[39].P[28]=0.000517598;			trMetProb[39].P[29]=0.000517598;			trMetProb[39].P[30]=0.000517598;			trMetProb[39].P[31]=0.000517598;			trMetProb[39].P[32]=0.000517598;			trMetProb[39].P[33]=0.000517598;			trMetProb[39].P[34]=0.000517598;			trMetProb[39].P[35]=0.000517598;			trMetProb[39].P[36]=0.000517598;			trMetProb[39].P[37]=0.000517598;			trMetProb[39].P[38]=0.000517598;			trMetProb[39].P[39]=0.160973;			trMetProb[39].P[40]=0.0160455;			trMetProb[39].P[41]=0.000517598;			trMetProb[39].P[42]=0.756211;			trMetProb[39].P[43]=0.000517598;			trMetProb[39].P[44]=0.000517598;			trMetProb[39].P[45]=0.000517598;			trMetProb[39].P[46]=0.000517598;			trMetProb[39].P[47]=0.000517598;			trMetProb[39].P[48]=0.0315735;			trMetProb[39].P[49]=0.000517598;			trMetProb[39].P[50]=0.000517598;			trMetProb[39].P[51]=0.000517598;			trMetProb[39].P[52]=0.000517598;			trMetProb[39].P[53]=0.000517598;			trMetProb[39].P[54]=0.000517598;			trMetProb[39].P[55]=0.000517598;			trMetProb[39].P[56]=0.000517598;			trMetProb[39].P[57]=0.000517598;			trMetProb[39].P[58]=0.000517598;			trMetProb[39].P[59]=0.000517598;			trMetProb[39].P[60]=0.000517598;			trMetProb[39].P[61]=0.000517598;			trMetProb[39].P[62]=0.000517598;			trMetProb[39].P[63]=0.000517598;			trMetProb[39].P[64]=0.000517598;			trMetProb[39].P[65]=0.000517598;			trMetProb[39].P[66]=0.000517598;			trMetProb[39].P[67]=0.000517598;			trMetProb[39].P[68]=0.000517598;			trMetProb[39].P[69]=0.000517598;			trMetProb[39].P[70]=0.000517598;			trMetProb[39].P[71]=0.000517598;	
		trMetProb[40].P[0]=0.000162813;			trMetProb[40].P[1]=0.000162813;			trMetProb[40].P[2]=0.000162813;			trMetProb[40].P[3]=0.000162813;			trMetProb[40].P[4]=0.000162813;			trMetProb[40].P[5]=0.000162813;			trMetProb[40].P[6]=0.000162813;			trMetProb[40].P[7]=0.000162813;			trMetProb[40].P[8]=0.000162813;			trMetProb[40].P[9]=0.000162813;			trMetProb[40].P[10]=0.000162813;			trMetProb[40].P[11]=0.000162813;			trMetProb[40].P[12]=0.000162813;			trMetProb[40].P[13]=0.000162813;			trMetProb[40].P[14]=0.000162813;			trMetProb[40].P[15]=0.000162813;			trMetProb[40].P[16]=0.000162813;			trMetProb[40].P[17]=0.000162813;			trMetProb[40].P[18]=0.000162813;			trMetProb[40].P[19]=0.000162813;			trMetProb[40].P[20]=0.000162813;			trMetProb[40].P[21]=0.000162813;			trMetProb[40].P[22]=0.000162813;			trMetProb[40].P[23]=0.000162813;			trMetProb[40].P[24]=0.000162813;			trMetProb[40].P[25]=0.000162813;			trMetProb[40].P[26]=0.000162813;			trMetProb[40].P[27]=0.000162813;			trMetProb[40].P[28]=0.000162813;			trMetProb[40].P[29]=0.000162813;			trMetProb[40].P[30]=0.000162813;			trMetProb[40].P[31]=0.000162813;			trMetProb[40].P[32]=0.000162813;			trMetProb[40].P[33]=0.000162813;			trMetProb[40].P[34]=0.000162813;			trMetProb[40].P[35]=0.000162813;			trMetProb[40].P[36]=0.000162813;			trMetProb[40].P[37]=0.000162813;			trMetProb[40].P[38]=0.000162813;			trMetProb[40].P[39]=0.000162813;			trMetProb[40].P[40]=0.167861;			trMetProb[40].P[41]=0.000162813;			trMetProb[40].P[42]=0.0115598;			trMetProb[40].P[43]=0.000162813;			trMetProb[40].P[44]=0.109248;			trMetProb[40].P[45]=0.000162813;			trMetProb[40].P[46]=0.000162813;			trMetProb[40].P[47]=0.000162813;			trMetProb[40].P[48]=0.698632;			trMetProb[40].P[49]=0.000162813;			trMetProb[40].P[50]=0.000162813;			trMetProb[40].P[51]=0.000162813;			trMetProb[40].P[52]=0.000162813;			trMetProb[40].P[53]=0.000162813;			trMetProb[40].P[54]=0.000162813;			trMetProb[40].P[55]=0.000162813;			trMetProb[40].P[56]=0.00179095;			trMetProb[40].P[57]=0.000162813;			trMetProb[40].P[58]=0.000162813;			trMetProb[40].P[59]=0.000162813;			trMetProb[40].P[60]=0.000162813;			trMetProb[40].P[61]=0.000162813;			trMetProb[40].P[62]=0.000162813;			trMetProb[40].P[63]=0.000162813;			trMetProb[40].P[64]=0.000162813;			trMetProb[40].P[65]=0.000162813;			trMetProb[40].P[66]=0.000162813;			trMetProb[40].P[67]=0.000162813;			trMetProb[40].P[68]=0.000162813;			trMetProb[40].P[69]=0.000162813;			trMetProb[40].P[70]=0.000162813;			trMetProb[40].P[71]=0.000162813;	
		trMetProb[41].P[0]=0.0138889;			trMetProb[41].P[1]=0.0138889;			trMetProb[41].P[2]=0.0138889;			trMetProb[41].P[3]=0.0138889;			trMetProb[41].P[4]=0.0138889;			trMetProb[41].P[5]=0.0138889;			trMetProb[41].P[6]=0.0138889;			trMetProb[41].P[7]=0.0138889;			trMetProb[41].P[8]=0.0138889;			trMetProb[41].P[9]=0.0138889;			trMetProb[41].P[10]=0.0138889;			trMetProb[41].P[11]=0.0138889;			trMetProb[41].P[12]=0.0138889;			trMetProb[41].P[13]=0.0138889;			trMetProb[41].P[14]=0.0138889;			trMetProb[41].P[15]=0.0138889;			trMetProb[41].P[16]=0.0138889;			trMetProb[41].P[17]=0.0138889;			trMetProb[41].P[18]=0.0138889;			trMetProb[41].P[19]=0.0138889;			trMetProb[41].P[20]=0.0138889;			trMetProb[41].P[21]=0.0138889;			trMetProb[41].P[22]=0.0138889;			trMetProb[41].P[23]=0.0138889;			trMetProb[41].P[24]=0.0138889;			trMetProb[41].P[25]=0.0138889;			trMetProb[41].P[26]=0.0138889;			trMetProb[41].P[27]=0.0138889;			trMetProb[41].P[28]=0.0138889;			trMetProb[41].P[29]=0.0138889;			trMetProb[41].P[30]=0.0138889;			trMetProb[41].P[31]=0.0138889;			trMetProb[41].P[32]=0.0138889;			trMetProb[41].P[33]=0.0138889;			trMetProb[41].P[34]=0.0138889;			trMetProb[41].P[35]=0.0138889;			trMetProb[41].P[36]=0.0138889;			trMetProb[41].P[37]=0.0138889;			trMetProb[41].P[38]=0.0138889;			trMetProb[41].P[39]=0.0138889;			trMetProb[41].P[40]=0.0138889;			trMetProb[41].P[41]=0.0138889;			trMetProb[41].P[42]=0.0138889;			trMetProb[41].P[43]=0.0138889;			trMetProb[41].P[44]=0.0138889;			trMetProb[41].P[45]=0.0138889;			trMetProb[41].P[46]=0.0138889;			trMetProb[41].P[47]=0.0138889;			trMetProb[41].P[48]=0.0138889;			trMetProb[41].P[49]=0.0138889;			trMetProb[41].P[50]=0.0138889;			trMetProb[41].P[51]=0.0138889;			trMetProb[41].P[52]=0.0138889;			trMetProb[41].P[53]=0.0138889;			trMetProb[41].P[54]=0.0138889;			trMetProb[41].P[55]=0.0138889;			trMetProb[41].P[56]=0.0138889;			trMetProb[41].P[57]=0.0138889;			trMetProb[41].P[58]=0.0138889;			trMetProb[41].P[59]=0.0138889;			trMetProb[41].P[60]=0.0138889;			trMetProb[41].P[61]=0.0138889;			trMetProb[41].P[62]=0.0138889;			trMetProb[41].P[63]=0.0138889;			trMetProb[41].P[64]=0.0138889;			trMetProb[41].P[65]=0.0138889;			trMetProb[41].P[66]=0.0138889;			trMetProb[41].P[67]=0.0138889;			trMetProb[41].P[68]=0.0138889;			trMetProb[41].P[69]=0.0138889;			trMetProb[41].P[70]=0.0138889;			trMetProb[41].P[71]=0.0138889;	
		trMetProb[42].P[0]=0.00213322;			trMetProb[42].P[1]=6.88137e-05;			trMetProb[42].P[2]=6.88137e-05;			trMetProb[42].P[3]=6.88137e-05;			trMetProb[42].P[4]=6.88137e-05;			trMetProb[42].P[5]=6.88137e-05;			trMetProb[42].P[6]=6.88137e-05;			trMetProb[42].P[7]=6.88137e-05;			trMetProb[42].P[8]=6.88137e-05;			trMetProb[42].P[9]=6.88137e-05;			trMetProb[42].P[10]=6.88137e-05;			trMetProb[42].P[11]=6.88137e-05;			trMetProb[42].P[12]=6.88137e-05;			trMetProb[42].P[13]=6.88137e-05;			trMetProb[42].P[14]=6.88137e-05;			trMetProb[42].P[15]=6.88137e-05;			trMetProb[42].P[16]=6.88137e-05;			trMetProb[42].P[17]=6.88137e-05;			trMetProb[42].P[18]=6.88137e-05;			trMetProb[42].P[19]=6.88137e-05;			trMetProb[42].P[20]=6.88137e-05;			trMetProb[42].P[21]=6.88137e-05;			trMetProb[42].P[22]=6.88137e-05;			trMetProb[42].P[23]=6.88137e-05;			trMetProb[42].P[24]=6.88137e-05;			trMetProb[42].P[25]=6.88137e-05;			trMetProb[42].P[26]=6.88137e-05;			trMetProb[42].P[27]=6.88137e-05;			trMetProb[42].P[28]=6.88137e-05;			trMetProb[42].P[29]=6.88137e-05;			trMetProb[42].P[30]=6.88137e-05;			trMetProb[42].P[31]=6.88137e-05;			trMetProb[42].P[32]=6.88137e-05;			trMetProb[42].P[33]=6.88137e-05;			trMetProb[42].P[34]=6.88137e-05;			trMetProb[42].P[35]=6.88137e-05;			trMetProb[42].P[36]=6.88137e-05;			trMetProb[42].P[37]=6.88137e-05;			trMetProb[42].P[38]=6.88137e-05;			trMetProb[42].P[39]=6.88137e-05;			trMetProb[42].P[40]=6.88137e-05;			trMetProb[42].P[41]=6.88137e-05;			trMetProb[42].P[42]=0.261561;			trMetProb[42].P[43]=6.88137e-05;			trMetProb[42].P[44]=0.0035095;			trMetProb[42].P[45]=0.119805;			trMetProb[42].P[46]=6.88137e-05;			trMetProb[42].P[47]=6.88137e-05;			trMetProb[42].P[48]=0.607693;			trMetProb[42].P[49]=6.88137e-05;			trMetProb[42].P[50]=6.88137e-05;			trMetProb[42].P[51]=6.88137e-05;			trMetProb[42].P[52]=6.88137e-05;			trMetProb[42].P[53]=6.88137e-05;			trMetProb[42].P[54]=0.00075695;			trMetProb[42].P[55]=6.88137e-05;			trMetProb[42].P[56]=6.88137e-05;			trMetProb[42].P[57]=6.88137e-05;			trMetProb[42].P[58]=6.88137e-05;			trMetProb[42].P[59]=6.88137e-05;			trMetProb[42].P[60]=6.88137e-05;			trMetProb[42].P[61]=6.88137e-05;			trMetProb[42].P[62]=6.88137e-05;			trMetProb[42].P[63]=6.88137e-05;			trMetProb[42].P[64]=6.88137e-05;			trMetProb[42].P[65]=6.88137e-05;			trMetProb[42].P[66]=6.88137e-05;			trMetProb[42].P[67]=6.88137e-05;			trMetProb[42].P[68]=6.88137e-05;			trMetProb[42].P[69]=6.88137e-05;			trMetProb[42].P[70]=6.88137e-05;			trMetProb[42].P[71]=6.88137e-05;	
		trMetProb[43].P[0]=0.0138889;			trMetProb[43].P[1]=0.0138889;			trMetProb[43].P[2]=0.0138889;			trMetProb[43].P[3]=0.0138889;			trMetProb[43].P[4]=0.0138889;			trMetProb[43].P[5]=0.0138889;			trMetProb[43].P[6]=0.0138889;			trMetProb[43].P[7]=0.0138889;			trMetProb[43].P[8]=0.0138889;			trMetProb[43].P[9]=0.0138889;			trMetProb[43].P[10]=0.0138889;			trMetProb[43].P[11]=0.0138889;			trMetProb[43].P[12]=0.0138889;			trMetProb[43].P[13]=0.0138889;			trMetProb[43].P[14]=0.0138889;			trMetProb[43].P[15]=0.0138889;			trMetProb[43].P[16]=0.0138889;			trMetProb[43].P[17]=0.0138889;			trMetProb[43].P[18]=0.0138889;			trMetProb[43].P[19]=0.0138889;			trMetProb[43].P[20]=0.0138889;			trMetProb[43].P[21]=0.0138889;			trMetProb[43].P[22]=0.0138889;			trMetProb[43].P[23]=0.0138889;			trMetProb[43].P[24]=0.0138889;			trMetProb[43].P[25]=0.0138889;			trMetProb[43].P[26]=0.0138889;			trMetProb[43].P[27]=0.0138889;			trMetProb[43].P[28]=0.0138889;			trMetProb[43].P[29]=0.0138889;			trMetProb[43].P[30]=0.0138889;			trMetProb[43].P[31]=0.0138889;			trMetProb[43].P[32]=0.0138889;			trMetProb[43].P[33]=0.0138889;			trMetProb[43].P[34]=0.0138889;			trMetProb[43].P[35]=0.0138889;			trMetProb[43].P[36]=0.0138889;			trMetProb[43].P[37]=0.0138889;			trMetProb[43].P[38]=0.0138889;			trMetProb[43].P[39]=0.0138889;			trMetProb[43].P[40]=0.0138889;			trMetProb[43].P[41]=0.0138889;			trMetProb[43].P[42]=0.0138889;			trMetProb[43].P[43]=0.0138889;			trMetProb[43].P[44]=0.0138889;			trMetProb[43].P[45]=0.0138889;			trMetProb[43].P[46]=0.0138889;			trMetProb[43].P[47]=0.0138889;			trMetProb[43].P[48]=0.0138889;			trMetProb[43].P[49]=0.0138889;			trMetProb[43].P[50]=0.0138889;			trMetProb[43].P[51]=0.0138889;			trMetProb[43].P[52]=0.0138889;			trMetProb[43].P[53]=0.0138889;			trMetProb[43].P[54]=0.0138889;			trMetProb[43].P[55]=0.0138889;			trMetProb[43].P[56]=0.0138889;			trMetProb[43].P[57]=0.0138889;			trMetProb[43].P[58]=0.0138889;			trMetProb[43].P[59]=0.0138889;			trMetProb[43].P[60]=0.0138889;			trMetProb[43].P[61]=0.0138889;			trMetProb[43].P[62]=0.0138889;			trMetProb[43].P[63]=0.0138889;			trMetProb[43].P[64]=0.0138889;			trMetProb[43].P[65]=0.0138889;			trMetProb[43].P[66]=0.0138889;			trMetProb[43].P[67]=0.0138889;			trMetProb[43].P[68]=0.0138889;			trMetProb[43].P[69]=0.0138889;			trMetProb[43].P[70]=0.0138889;			trMetProb[43].P[71]=0.0138889;	
		trMetProb[44].P[0]=0.00116009;			trMetProb[44].P[1]=0.00116009;			trMetProb[44].P[2]=0.00116009;			trMetProb[44].P[3]=0.00116009;			trMetProb[44].P[4]=0.00116009;			trMetProb[44].P[5]=0.00116009;			trMetProb[44].P[6]=0.00116009;			trMetProb[44].P[7]=0.00116009;			trMetProb[44].P[8]=0.00116009;			trMetProb[44].P[9]=0.00116009;			trMetProb[44].P[10]=0.00116009;			trMetProb[44].P[11]=0.00116009;			trMetProb[44].P[12]=0.00116009;			trMetProb[44].P[13]=0.00116009;			trMetProb[44].P[14]=0.00116009;			trMetProb[44].P[15]=0.00116009;			trMetProb[44].P[16]=0.00116009;			trMetProb[44].P[17]=0.00116009;			trMetProb[44].P[18]=0.00116009;			trMetProb[44].P[19]=0.00116009;			trMetProb[44].P[20]=0.00116009;			trMetProb[44].P[21]=0.00116009;			trMetProb[44].P[22]=0.00116009;			trMetProb[44].P[23]=0.00116009;			trMetProb[44].P[24]=0.00116009;			trMetProb[44].P[25]=0.00116009;			trMetProb[44].P[26]=0.00116009;			trMetProb[44].P[27]=0.00116009;			trMetProb[44].P[28]=0.00116009;			trMetProb[44].P[29]=0.00116009;			trMetProb[44].P[30]=0.00116009;			trMetProb[44].P[31]=0.00116009;			trMetProb[44].P[32]=0.00116009;			trMetProb[44].P[33]=0.00116009;			trMetProb[44].P[34]=0.00116009;			trMetProb[44].P[35]=0.00116009;			trMetProb[44].P[36]=0.00116009;			trMetProb[44].P[37]=0.00116009;			trMetProb[44].P[38]=0.00116009;			trMetProb[44].P[39]=0.00116009;			trMetProb[44].P[40]=0.00116009;			trMetProb[44].P[41]=0.00116009;			trMetProb[44].P[42]=0.00116009;			trMetProb[44].P[43]=0.00116009;			trMetProb[44].P[44]=0.0823666;			trMetProb[44].P[45]=0.0707657;			trMetProb[44].P[46]=0.012761;			trMetProb[44].P[47]=0.00116009;			trMetProb[44].P[48]=0.75522;			trMetProb[44].P[49]=0.00116009;			trMetProb[44].P[50]=0.00116009;			trMetProb[44].P[51]=0.00116009;			trMetProb[44].P[52]=0.00116009;			trMetProb[44].P[53]=0.00116009;			trMetProb[44].P[54]=0.00116009;			trMetProb[44].P[55]=0.00116009;			trMetProb[44].P[56]=0.00116009;			trMetProb[44].P[57]=0.00116009;			trMetProb[44].P[58]=0.00116009;			trMetProb[44].P[59]=0.00116009;			trMetProb[44].P[60]=0.00116009;			trMetProb[44].P[61]=0.00116009;			trMetProb[44].P[62]=0.00116009;			trMetProb[44].P[63]=0.00116009;			trMetProb[44].P[64]=0.00116009;			trMetProb[44].P[65]=0.00116009;			trMetProb[44].P[66]=0.00116009;			trMetProb[44].P[67]=0.00116009;			trMetProb[44].P[68]=0.00116009;			trMetProb[44].P[69]=0.00116009;			trMetProb[44].P[70]=0.00116009;			trMetProb[44].P[71]=0.00116009;	
		trMetProb[45].P[0]=0.000393391;			trMetProb[45].P[1]=0.000393391;			trMetProb[45].P[2]=0.000393391;			trMetProb[45].P[3]=0.000393391;			trMetProb[45].P[4]=0.000393391;			trMetProb[45].P[5]=0.000393391;			trMetProb[45].P[6]=0.000393391;			trMetProb[45].P[7]=0.000393391;			trMetProb[45].P[8]=0.000393391;			trMetProb[45].P[9]=0.000393391;			trMetProb[45].P[10]=0.000393391;			trMetProb[45].P[11]=0.000393391;			trMetProb[45].P[12]=0.000393391;			trMetProb[45].P[13]=0.000393391;			trMetProb[45].P[14]=0.000393391;			trMetProb[45].P[15]=0.000393391;			trMetProb[45].P[16]=0.000393391;			trMetProb[45].P[17]=0.000393391;			trMetProb[45].P[18]=0.000393391;			trMetProb[45].P[19]=0.000393391;			trMetProb[45].P[20]=0.000393391;			trMetProb[45].P[21]=0.000393391;			trMetProb[45].P[22]=0.000393391;			trMetProb[45].P[23]=0.000393391;			trMetProb[45].P[24]=0.000393391;			trMetProb[45].P[25]=0.000393391;			trMetProb[45].P[26]=0.000393391;			trMetProb[45].P[27]=0.000393391;			trMetProb[45].P[28]=0.000393391;			trMetProb[45].P[29]=0.000393391;			trMetProb[45].P[30]=0.000393391;			trMetProb[45].P[31]=0.000393391;			trMetProb[45].P[32]=0.000393391;			trMetProb[45].P[33]=0.000393391;			trMetProb[45].P[34]=0.000393391;			trMetProb[45].P[35]=0.000393391;			trMetProb[45].P[36]=0.000393391;			trMetProb[45].P[37]=0.000393391;			trMetProb[45].P[38]=0.000393391;			trMetProb[45].P[39]=0.000393391;			trMetProb[45].P[40]=0.000393391;			trMetProb[45].P[41]=0.000393391;			trMetProb[45].P[42]=0.000393391;			trMetProb[45].P[43]=0.000393391;			trMetProb[45].P[44]=0.000393391;			trMetProb[45].P[45]=0.169552;			trMetProb[45].P[46]=0.000393391;			trMetProb[45].P[47]=0.000393391;			trMetProb[45].P[48]=0.798977;			trMetProb[45].P[49]=0.000393391;			trMetProb[45].P[50]=0.000393391;			trMetProb[45].P[51]=0.000393391;			trMetProb[45].P[52]=0.000393391;			trMetProb[45].P[53]=0.000393391;			trMetProb[45].P[54]=0.0043273;			trMetProb[45].P[55]=0.000393391;			trMetProb[45].P[56]=0.000393391;			trMetProb[45].P[57]=0.000393391;			trMetProb[45].P[58]=0.000393391;			trMetProb[45].P[59]=0.000393391;			trMetProb[45].P[60]=0.000393391;			trMetProb[45].P[61]=0.000393391;			trMetProb[45].P[62]=0.000393391;			trMetProb[45].P[63]=0.000393391;			trMetProb[45].P[64]=0.000393391;			trMetProb[45].P[65]=0.000393391;			trMetProb[45].P[66]=0.000393391;			trMetProb[45].P[67]=0.000393391;			trMetProb[45].P[68]=0.000393391;			trMetProb[45].P[69]=0.000393391;			trMetProb[45].P[70]=0.000393391;			trMetProb[45].P[71]=0.000393391;	
		trMetProb[46].P[0]=0.0121951;			trMetProb[46].P[1]=0.0121951;			trMetProb[46].P[2]=0.0121951;			trMetProb[46].P[3]=0.0121951;			trMetProb[46].P[4]=0.0121951;			trMetProb[46].P[5]=0.0121951;			trMetProb[46].P[6]=0.0121951;			trMetProb[46].P[7]=0.0121951;			trMetProb[46].P[8]=0.0121951;			trMetProb[46].P[9]=0.0121951;			trMetProb[46].P[10]=0.0121951;			trMetProb[46].P[11]=0.0121951;			trMetProb[46].P[12]=0.0121951;			trMetProb[46].P[13]=0.0121951;			trMetProb[46].P[14]=0.0121951;			trMetProb[46].P[15]=0.0121951;			trMetProb[46].P[16]=0.0121951;			trMetProb[46].P[17]=0.0121951;			trMetProb[46].P[18]=0.0121951;			trMetProb[46].P[19]=0.0121951;			trMetProb[46].P[20]=0.0121951;			trMetProb[46].P[21]=0.0121951;			trMetProb[46].P[22]=0.0121951;			trMetProb[46].P[23]=0.0121951;			trMetProb[46].P[24]=0.0121951;			trMetProb[46].P[25]=0.0121951;			trMetProb[46].P[26]=0.0121951;			trMetProb[46].P[27]=0.0121951;			trMetProb[46].P[28]=0.0121951;			trMetProb[46].P[29]=0.0121951;			trMetProb[46].P[30]=0.0121951;			trMetProb[46].P[31]=0.0121951;			trMetProb[46].P[32]=0.0121951;			trMetProb[46].P[33]=0.0121951;			trMetProb[46].P[34]=0.0121951;			trMetProb[46].P[35]=0.0121951;			trMetProb[46].P[36]=0.0121951;			trMetProb[46].P[37]=0.0121951;			trMetProb[46].P[38]=0.0121951;			trMetProb[46].P[39]=0.0121951;			trMetProb[46].P[40]=0.0121951;			trMetProb[46].P[41]=0.0121951;			trMetProb[46].P[42]=0.0121951;			trMetProb[46].P[43]=0.0121951;			trMetProb[46].P[44]=0.0121951;			trMetProb[46].P[45]=0.0121951;			trMetProb[46].P[46]=0.0121951;			trMetProb[46].P[47]=0.0121951;			trMetProb[46].P[48]=0.134146;			trMetProb[46].P[49]=0.0121951;			trMetProb[46].P[50]=0.0121951;			trMetProb[46].P[51]=0.0121951;			trMetProb[46].P[52]=0.0121951;			trMetProb[46].P[53]=0.0121951;			trMetProb[46].P[54]=0.0121951;			trMetProb[46].P[55]=0.0121951;			trMetProb[46].P[56]=0.0121951;			trMetProb[46].P[57]=0.0121951;			trMetProb[46].P[58]=0.0121951;			trMetProb[46].P[59]=0.0121951;			trMetProb[46].P[60]=0.0121951;			trMetProb[46].P[61]=0.0121951;			trMetProb[46].P[62]=0.0121951;			trMetProb[46].P[63]=0.0121951;			trMetProb[46].P[64]=0.0121951;			trMetProb[46].P[65]=0.0121951;			trMetProb[46].P[66]=0.0121951;			trMetProb[46].P[67]=0.0121951;			trMetProb[46].P[68]=0.0121951;			trMetProb[46].P[69]=0.0121951;			trMetProb[46].P[70]=0.0121951;			trMetProb[46].P[71]=0.0121951;	
		trMetProb[47].P[0]=0.0138889;			trMetProb[47].P[1]=0.0138889;			trMetProb[47].P[2]=0.0138889;			trMetProb[47].P[3]=0.0138889;			trMetProb[47].P[4]=0.0138889;			trMetProb[47].P[5]=0.0138889;			trMetProb[47].P[6]=0.0138889;			trMetProb[47].P[7]=0.0138889;			trMetProb[47].P[8]=0.0138889;			trMetProb[47].P[9]=0.0138889;			trMetProb[47].P[10]=0.0138889;			trMetProb[47].P[11]=0.0138889;			trMetProb[47].P[12]=0.0138889;			trMetProb[47].P[13]=0.0138889;			trMetProb[47].P[14]=0.0138889;			trMetProb[47].P[15]=0.0138889;			trMetProb[47].P[16]=0.0138889;			trMetProb[47].P[17]=0.0138889;			trMetProb[47].P[18]=0.0138889;			trMetProb[47].P[19]=0.0138889;			trMetProb[47].P[20]=0.0138889;			trMetProb[47].P[21]=0.0138889;			trMetProb[47].P[22]=0.0138889;			trMetProb[47].P[23]=0.0138889;			trMetProb[47].P[24]=0.0138889;			trMetProb[47].P[25]=0.0138889;			trMetProb[47].P[26]=0.0138889;			trMetProb[47].P[27]=0.0138889;			trMetProb[47].P[28]=0.0138889;			trMetProb[47].P[29]=0.0138889;			trMetProb[47].P[30]=0.0138889;			trMetProb[47].P[31]=0.0138889;			trMetProb[47].P[32]=0.0138889;			trMetProb[47].P[33]=0.0138889;			trMetProb[47].P[34]=0.0138889;			trMetProb[47].P[35]=0.0138889;			trMetProb[47].P[36]=0.0138889;			trMetProb[47].P[37]=0.0138889;			trMetProb[47].P[38]=0.0138889;			trMetProb[47].P[39]=0.0138889;			trMetProb[47].P[40]=0.0138889;			trMetProb[47].P[41]=0.0138889;			trMetProb[47].P[42]=0.0138889;			trMetProb[47].P[43]=0.0138889;			trMetProb[47].P[44]=0.0138889;			trMetProb[47].P[45]=0.0138889;			trMetProb[47].P[46]=0.0138889;			trMetProb[47].P[47]=0.0138889;			trMetProb[47].P[48]=0.0138889;			trMetProb[47].P[49]=0.0138889;			trMetProb[47].P[50]=0.0138889;			trMetProb[47].P[51]=0.0138889;			trMetProb[47].P[52]=0.0138889;			trMetProb[47].P[53]=0.0138889;			trMetProb[47].P[54]=0.0138889;			trMetProb[47].P[55]=0.0138889;			trMetProb[47].P[56]=0.0138889;			trMetProb[47].P[57]=0.0138889;			trMetProb[47].P[58]=0.0138889;			trMetProb[47].P[59]=0.0138889;			trMetProb[47].P[60]=0.0138889;			trMetProb[47].P[61]=0.0138889;			trMetProb[47].P[62]=0.0138889;			trMetProb[47].P[63]=0.0138889;			trMetProb[47].P[64]=0.0138889;			trMetProb[47].P[65]=0.0138889;			trMetProb[47].P[66]=0.0138889;			trMetProb[47].P[67]=0.0138889;			trMetProb[47].P[68]=0.0138889;			trMetProb[47].P[69]=0.0138889;			trMetProb[47].P[70]=0.0138889;			trMetProb[47].P[71]=0.0138889;	
		trMetProb[48].P[0]=0.210981;			trMetProb[48].P[1]=3.67685e-06;			trMetProb[48].P[2]=3.67685e-06;			trMetProb[48].P[3]=3.67685e-06;			trMetProb[48].P[4]=3.67685e-06;			trMetProb[48].P[5]=3.67685e-06;			trMetProb[48].P[6]=3.67685e-06;			trMetProb[48].P[7]=3.67685e-06;			trMetProb[48].P[8]=3.67685e-06;			trMetProb[48].P[9]=3.67685e-06;			trMetProb[48].P[10]=3.67685e-06;			trMetProb[48].P[11]=3.67685e-06;			trMetProb[48].P[12]=0.000150751;			trMetProb[48].P[13]=3.67685e-06;			trMetProb[48].P[14]=3.67685e-06;			trMetProb[48].P[15]=3.67685e-06;			trMetProb[48].P[16]=3.67685e-06;			trMetProb[48].P[17]=3.67685e-06;			trMetProb[48].P[18]=3.67685e-06;			trMetProb[48].P[19]=3.67685e-06;			trMetProb[48].P[20]=3.67685e-06;			trMetProb[48].P[21]=3.67685e-06;			trMetProb[48].P[22]=3.67685e-06;			trMetProb[48].P[23]=3.67685e-06;			trMetProb[48].P[24]=0.000812584;			trMetProb[48].P[25]=3.67685e-06;			trMetProb[48].P[26]=3.67685e-06;			trMetProb[48].P[27]=3.67685e-06;			trMetProb[48].P[28]=3.67685e-06;			trMetProb[48].P[29]=3.67685e-06;			trMetProb[48].P[30]=3.67685e-06;			trMetProb[48].P[31]=3.67685e-06;			trMetProb[48].P[32]=3.67685e-06;			trMetProb[48].P[33]=3.67685e-06;			trMetProb[48].P[34]=3.67685e-06;			trMetProb[48].P[35]=3.67685e-06;			trMetProb[48].P[36]=3.67685e-06;			trMetProb[48].P[37]=3.67685e-06;			trMetProb[48].P[38]=3.67685e-06;			trMetProb[48].P[39]=3.67685e-06;			trMetProb[48].P[40]=3.67685e-06;			trMetProb[48].P[41]=3.67685e-06;			trMetProb[48].P[42]=3.67685e-06;			trMetProb[48].P[43]=3.67685e-06;			trMetProb[48].P[44]=3.67685e-06;			trMetProb[48].P[45]=3.67685e-06;			trMetProb[48].P[46]=3.67685e-06;			trMetProb[48].P[47]=3.67685e-06;			trMetProb[48].P[48]=0.579696;			trMetProb[48].P[49]=4.04453e-05;			trMetProb[48].P[50]=0.000555204;			trMetProb[48].P[51]=0.00537188;			trMetProb[48].P[52]=0.00235686;			trMetProb[48].P[53]=3.67685e-06;			trMetProb[48].P[54]=0.0356691;			trMetProb[48].P[55]=3.67685e-06;			trMetProb[48].P[56]=0.0155935;			trMetProb[48].P[57]=0.000555204;			trMetProb[48].P[58]=3.67685e-06;			trMetProb[48].P[59]=3.67685e-06;			trMetProb[48].P[60]=0.141158;			trMetProb[48].P[61]=3.67685e-06;			trMetProb[48].P[62]=3.67685e-06;			trMetProb[48].P[63]=3.67685e-06;			trMetProb[48].P[64]=3.67685e-06;			trMetProb[48].P[65]=3.67685e-06;			trMetProb[48].P[66]=0.00658524;			trMetProb[48].P[67]=3.67685e-06;			trMetProb[48].P[68]=3.67685e-06;			trMetProb[48].P[69]=0.000261056;			trMetProb[48].P[70]=3.67685e-06;			trMetProb[48].P[71]=3.67685e-06;	
		trMetProb[49].P[0]=0.0121951;			trMetProb[49].P[1]=0.0121951;			trMetProb[49].P[2]=0.0121951;			trMetProb[49].P[3]=0.0121951;			trMetProb[49].P[4]=0.0121951;			trMetProb[49].P[5]=0.0121951;			trMetProb[49].P[6]=0.0121951;			trMetProb[49].P[7]=0.0121951;			trMetProb[49].P[8]=0.0121951;			trMetProb[49].P[9]=0.0121951;			trMetProb[49].P[10]=0.0121951;			trMetProb[49].P[11]=0.0121951;			trMetProb[49].P[12]=0.0121951;			trMetProb[49].P[13]=0.0121951;			trMetProb[49].P[14]=0.0121951;			trMetProb[49].P[15]=0.0121951;			trMetProb[49].P[16]=0.0121951;			trMetProb[49].P[17]=0.0121951;			trMetProb[49].P[18]=0.0121951;			trMetProb[49].P[19]=0.0121951;			trMetProb[49].P[20]=0.0121951;			trMetProb[49].P[21]=0.0121951;			trMetProb[49].P[22]=0.0121951;			trMetProb[49].P[23]=0.0121951;			trMetProb[49].P[24]=0.0121951;			trMetProb[49].P[25]=0.0121951;			trMetProb[49].P[26]=0.0121951;			trMetProb[49].P[27]=0.0121951;			trMetProb[49].P[28]=0.0121951;			trMetProb[49].P[29]=0.0121951;			trMetProb[49].P[30]=0.0121951;			trMetProb[49].P[31]=0.0121951;			trMetProb[49].P[32]=0.0121951;			trMetProb[49].P[33]=0.0121951;			trMetProb[49].P[34]=0.0121951;			trMetProb[49].P[35]=0.0121951;			trMetProb[49].P[36]=0.0121951;			trMetProb[49].P[37]=0.0121951;			trMetProb[49].P[38]=0.0121951;			trMetProb[49].P[39]=0.0121951;			trMetProb[49].P[40]=0.0121951;			trMetProb[49].P[41]=0.0121951;			trMetProb[49].P[42]=0.0121951;			trMetProb[49].P[43]=0.0121951;			trMetProb[49].P[44]=0.0121951;			trMetProb[49].P[45]=0.0121951;			trMetProb[49].P[46]=0.0121951;			trMetProb[49].P[47]=0.0121951;			trMetProb[49].P[48]=0.0121951;			trMetProb[49].P[49]=0.0121951;			trMetProb[49].P[50]=0.134146;			trMetProb[49].P[51]=0.0121951;			trMetProb[49].P[52]=0.0121951;			trMetProb[49].P[53]=0.0121951;			trMetProb[49].P[54]=0.0121951;			trMetProb[49].P[55]=0.0121951;			trMetProb[49].P[56]=0.0121951;			trMetProb[49].P[57]=0.0121951;			trMetProb[49].P[58]=0.0121951;			trMetProb[49].P[59]=0.0121951;			trMetProb[49].P[60]=0.0121951;			trMetProb[49].P[61]=0.0121951;			trMetProb[49].P[62]=0.0121951;			trMetProb[49].P[63]=0.0121951;			trMetProb[49].P[64]=0.0121951;			trMetProb[49].P[65]=0.0121951;			trMetProb[49].P[66]=0.0121951;			trMetProb[49].P[67]=0.0121951;			trMetProb[49].P[68]=0.0121951;			trMetProb[49].P[69]=0.0121951;			trMetProb[49].P[70]=0.0121951;			trMetProb[49].P[71]=0.0121951;	
		trMetProb[50].P[0]=0.00431034;			trMetProb[50].P[1]=0.00431034;			trMetProb[50].P[2]=0.00431034;			trMetProb[50].P[3]=0.00431034;			trMetProb[50].P[4]=0.00431034;			trMetProb[50].P[5]=0.00431034;			trMetProb[50].P[6]=0.00431034;			trMetProb[50].P[7]=0.00431034;			trMetProb[50].P[8]=0.00431034;			trMetProb[50].P[9]=0.00431034;			trMetProb[50].P[10]=0.00431034;			trMetProb[50].P[11]=0.00431034;			trMetProb[50].P[12]=0.00431034;			trMetProb[50].P[13]=0.00431034;			trMetProb[50].P[14]=0.00431034;			trMetProb[50].P[15]=0.00431034;			trMetProb[50].P[16]=0.00431034;			trMetProb[50].P[17]=0.00431034;			trMetProb[50].P[18]=0.00431034;			trMetProb[50].P[19]=0.00431034;			trMetProb[50].P[20]=0.00431034;			trMetProb[50].P[21]=0.00431034;			trMetProb[50].P[22]=0.00431034;			trMetProb[50].P[23]=0.00431034;			trMetProb[50].P[24]=0.00431034;			trMetProb[50].P[25]=0.00431034;			trMetProb[50].P[26]=0.00431034;			trMetProb[50].P[27]=0.00431034;			trMetProb[50].P[28]=0.00431034;			trMetProb[50].P[29]=0.00431034;			trMetProb[50].P[30]=0.00431034;			trMetProb[50].P[31]=0.00431034;			trMetProb[50].P[32]=0.00431034;			trMetProb[50].P[33]=0.00431034;			trMetProb[50].P[34]=0.00431034;			trMetProb[50].P[35]=0.00431034;			trMetProb[50].P[36]=0.00431034;			trMetProb[50].P[37]=0.00431034;			trMetProb[50].P[38]=0.00431034;			trMetProb[50].P[39]=0.00431034;			trMetProb[50].P[40]=0.00431034;			trMetProb[50].P[41]=0.00431034;			trMetProb[50].P[42]=0.00431034;			trMetProb[50].P[43]=0.00431034;			trMetProb[50].P[44]=0.00431034;			trMetProb[50].P[45]=0.00431034;			trMetProb[50].P[46]=0.00431034;			trMetProb[50].P[47]=0.00431034;			trMetProb[50].P[48]=0.00431034;			trMetProb[50].P[49]=0.00431034;			trMetProb[50].P[50]=0.00431034;			trMetProb[50].P[51]=0.0474138;			trMetProb[50].P[52]=0.650862;			trMetProb[50].P[53]=0.00431034;			trMetProb[50].P[54]=0.00431034;			trMetProb[50].P[55]=0.00431034;			trMetProb[50].P[56]=0.00431034;			trMetProb[50].P[57]=0.00431034;			trMetProb[50].P[58]=0.00431034;			trMetProb[50].P[59]=0.00431034;			trMetProb[50].P[60]=0.00431034;			trMetProb[50].P[61]=0.00431034;			trMetProb[50].P[62]=0.00431034;			trMetProb[50].P[63]=0.00431034;			trMetProb[50].P[64]=0.00431034;			trMetProb[50].P[65]=0.00431034;			trMetProb[50].P[66]=0.00431034;			trMetProb[50].P[67]=0.00431034;			trMetProb[50].P[68]=0.00431034;			trMetProb[50].P[69]=0.00431034;			trMetProb[50].P[70]=0.00431034;			trMetProb[50].P[71]=0.00431034;	
		trMetProb[51].P[0]=0.000558036;			trMetProb[51].P[1]=0.000558036;			trMetProb[51].P[2]=0.000558036;			trMetProb[51].P[3]=0.000558036;			trMetProb[51].P[4]=0.000558036;			trMetProb[51].P[5]=0.000558036;			trMetProb[51].P[6]=0.000558036;			trMetProb[51].P[7]=0.000558036;			trMetProb[51].P[8]=0.000558036;			trMetProb[51].P[9]=0.000558036;			trMetProb[51].P[10]=0.000558036;			trMetProb[51].P[11]=0.000558036;			trMetProb[51].P[12]=0.000558036;			trMetProb[51].P[13]=0.000558036;			trMetProb[51].P[14]=0.000558036;			trMetProb[51].P[15]=0.000558036;			trMetProb[51].P[16]=0.000558036;			trMetProb[51].P[17]=0.000558036;			trMetProb[51].P[18]=0.000558036;			trMetProb[51].P[19]=0.000558036;			trMetProb[51].P[20]=0.000558036;			trMetProb[51].P[21]=0.000558036;			trMetProb[51].P[22]=0.000558036;			trMetProb[51].P[23]=0.000558036;			trMetProb[51].P[24]=0.000558036;			trMetProb[51].P[25]=0.000558036;			trMetProb[51].P[26]=0.000558036;			trMetProb[51].P[27]=0.000558036;			trMetProb[51].P[28]=0.000558036;			trMetProb[51].P[29]=0.000558036;			trMetProb[51].P[30]=0.000558036;			trMetProb[51].P[31]=0.000558036;			trMetProb[51].P[32]=0.000558036;			trMetProb[51].P[33]=0.000558036;			trMetProb[51].P[34]=0.000558036;			trMetProb[51].P[35]=0.000558036;			trMetProb[51].P[36]=0.000558036;			trMetProb[51].P[37]=0.000558036;			trMetProb[51].P[38]=0.000558036;			trMetProb[51].P[39]=0.000558036;			trMetProb[51].P[40]=0.000558036;			trMetProb[51].P[41]=0.000558036;			trMetProb[51].P[42]=0.000558036;			trMetProb[51].P[43]=0.000558036;			trMetProb[51].P[44]=0.000558036;			trMetProb[51].P[45]=0.000558036;			trMetProb[51].P[46]=0.000558036;			trMetProb[51].P[47]=0.000558036;			trMetProb[51].P[48]=0.000558036;			trMetProb[51].P[49]=0.000558036;			trMetProb[51].P[50]=0.000558036;			trMetProb[51].P[51]=0.156808;			trMetProb[51].P[52]=0.00613839;			trMetProb[51].P[53]=0.000558036;			trMetProb[51].P[54]=0.765067;			trMetProb[51].P[55]=0.000558036;			trMetProb[51].P[56]=0.000558036;			trMetProb[51].P[57]=0.000558036;			trMetProb[51].P[58]=0.000558036;			trMetProb[51].P[59]=0.000558036;			trMetProb[51].P[60]=0.0340402;			trMetProb[51].P[61]=0.000558036;			trMetProb[51].P[62]=0.000558036;			trMetProb[51].P[63]=0.000558036;			trMetProb[51].P[64]=0.000558036;			trMetProb[51].P[65]=0.000558036;			trMetProb[51].P[66]=0.000558036;			trMetProb[51].P[67]=0.000558036;			trMetProb[51].P[68]=0.000558036;			trMetProb[51].P[69]=0.000558036;			trMetProb[51].P[70]=0.000558036;			trMetProb[51].P[71]=0.000558036;	
		trMetProb[52].P[0]=0.00113379;			trMetProb[52].P[1]=0.00113379;			trMetProb[52].P[2]=0.00113379;			trMetProb[52].P[3]=0.00113379;			trMetProb[52].P[4]=0.00113379;			trMetProb[52].P[5]=0.00113379;			trMetProb[52].P[6]=0.00113379;			trMetProb[52].P[7]=0.00113379;			trMetProb[52].P[8]=0.00113379;			trMetProb[52].P[9]=0.00113379;			trMetProb[52].P[10]=0.00113379;			trMetProb[52].P[11]=0.00113379;			trMetProb[52].P[12]=0.00113379;			trMetProb[52].P[13]=0.00113379;			trMetProb[52].P[14]=0.00113379;			trMetProb[52].P[15]=0.00113379;			trMetProb[52].P[16]=0.00113379;			trMetProb[52].P[17]=0.00113379;			trMetProb[52].P[18]=0.00113379;			trMetProb[52].P[19]=0.00113379;			trMetProb[52].P[20]=0.00113379;			trMetProb[52].P[21]=0.00113379;			trMetProb[52].P[22]=0.00113379;			trMetProb[52].P[23]=0.00113379;			trMetProb[52].P[24]=0.00113379;			trMetProb[52].P[25]=0.00113379;			trMetProb[52].P[26]=0.00113379;			trMetProb[52].P[27]=0.00113379;			trMetProb[52].P[28]=0.00113379;			trMetProb[52].P[29]=0.00113379;			trMetProb[52].P[30]=0.00113379;			trMetProb[52].P[31]=0.00113379;			trMetProb[52].P[32]=0.00113379;			trMetProb[52].P[33]=0.00113379;			trMetProb[52].P[34]=0.00113379;			trMetProb[52].P[35]=0.00113379;			trMetProb[52].P[36]=0.00113379;			trMetProb[52].P[37]=0.00113379;			trMetProb[52].P[38]=0.00113379;			trMetProb[52].P[39]=0.00113379;			trMetProb[52].P[40]=0.00113379;			trMetProb[52].P[41]=0.00113379;			trMetProb[52].P[42]=0.00113379;			trMetProb[52].P[43]=0.00113379;			trMetProb[52].P[44]=0.00113379;			trMetProb[52].P[45]=0.00113379;			trMetProb[52].P[46]=0.00113379;			trMetProb[52].P[47]=0.00113379;			trMetProb[52].P[48]=0.00113379;			trMetProb[52].P[49]=0.00113379;			trMetProb[52].P[50]=0.00113379;			trMetProb[52].P[51]=0.00113379;			trMetProb[52].P[52]=0.0124717;			trMetProb[52].P[53]=0.0124717;			trMetProb[52].P[54]=0.193878;			trMetProb[52].P[55]=0.00113379;			trMetProb[52].P[56]=0.704082;			trMetProb[52].P[57]=0.00113379;			trMetProb[52].P[58]=0.00113379;			trMetProb[52].P[59]=0.00113379;			trMetProb[52].P[60]=0.00113379;			trMetProb[52].P[61]=0.00113379;			trMetProb[52].P[62]=0.00113379;			trMetProb[52].P[63]=0.00113379;			trMetProb[52].P[64]=0.00113379;			trMetProb[52].P[65]=0.00113379;			trMetProb[52].P[66]=0.00113379;			trMetProb[52].P[67]=0.00113379;			trMetProb[52].P[68]=0.00113379;			trMetProb[52].P[69]=0.00113379;			trMetProb[52].P[70]=0.00113379;			trMetProb[52].P[71]=0.00113379;	
		trMetProb[53].P[0]=0.0121951;			trMetProb[53].P[1]=0.0121951;			trMetProb[53].P[2]=0.0121951;			trMetProb[53].P[3]=0.0121951;			trMetProb[53].P[4]=0.0121951;			trMetProb[53].P[5]=0.0121951;			trMetProb[53].P[6]=0.0121951;			trMetProb[53].P[7]=0.0121951;			trMetProb[53].P[8]=0.0121951;			trMetProb[53].P[9]=0.0121951;			trMetProb[53].P[10]=0.0121951;			trMetProb[53].P[11]=0.0121951;			trMetProb[53].P[12]=0.0121951;			trMetProb[53].P[13]=0.0121951;			trMetProb[53].P[14]=0.0121951;			trMetProb[53].P[15]=0.0121951;			trMetProb[53].P[16]=0.0121951;			trMetProb[53].P[17]=0.0121951;			trMetProb[53].P[18]=0.0121951;			trMetProb[53].P[19]=0.0121951;			trMetProb[53].P[20]=0.0121951;			trMetProb[53].P[21]=0.0121951;			trMetProb[53].P[22]=0.0121951;			trMetProb[53].P[23]=0.0121951;			trMetProb[53].P[24]=0.0121951;			trMetProb[53].P[25]=0.0121951;			trMetProb[53].P[26]=0.0121951;			trMetProb[53].P[27]=0.0121951;			trMetProb[53].P[28]=0.0121951;			trMetProb[53].P[29]=0.0121951;			trMetProb[53].P[30]=0.0121951;			trMetProb[53].P[31]=0.0121951;			trMetProb[53].P[32]=0.0121951;			trMetProb[53].P[33]=0.0121951;			trMetProb[53].P[34]=0.0121951;			trMetProb[53].P[35]=0.0121951;			trMetProb[53].P[36]=0.0121951;			trMetProb[53].P[37]=0.0121951;			trMetProb[53].P[38]=0.0121951;			trMetProb[53].P[39]=0.0121951;			trMetProb[53].P[40]=0.0121951;			trMetProb[53].P[41]=0.0121951;			trMetProb[53].P[42]=0.0121951;			trMetProb[53].P[43]=0.0121951;			trMetProb[53].P[44]=0.0121951;			trMetProb[53].P[45]=0.0121951;			trMetProb[53].P[46]=0.0121951;			trMetProb[53].P[47]=0.0121951;			trMetProb[53].P[48]=0.0121951;			trMetProb[53].P[49]=0.0121951;			trMetProb[53].P[50]=0.0121951;			trMetProb[53].P[51]=0.0121951;			trMetProb[53].P[52]=0.0121951;			trMetProb[53].P[53]=0.0121951;			trMetProb[53].P[54]=0.134146;			trMetProb[53].P[55]=0.0121951;			trMetProb[53].P[56]=0.0121951;			trMetProb[53].P[57]=0.0121951;			trMetProb[53].P[58]=0.0121951;			trMetProb[53].P[59]=0.0121951;			trMetProb[53].P[60]=0.0121951;			trMetProb[53].P[61]=0.0121951;			trMetProb[53].P[62]=0.0121951;			trMetProb[53].P[63]=0.0121951;			trMetProb[53].P[64]=0.0121951;			trMetProb[53].P[65]=0.0121951;			trMetProb[53].P[66]=0.0121951;			trMetProb[53].P[67]=0.0121951;			trMetProb[53].P[68]=0.0121951;			trMetProb[53].P[69]=0.0121951;			trMetProb[53].P[70]=0.0121951;			trMetProb[53].P[71]=0.0121951;	
		trMetProb[54].P[0]=0.066815;			trMetProb[54].P[1]=6.74218e-05;			trMetProb[54].P[2]=6.74218e-05;			trMetProb[54].P[3]=6.74218e-05;			trMetProb[54].P[4]=6.74218e-05;			trMetProb[54].P[5]=6.74218e-05;			trMetProb[54].P[6]=6.74218e-05;			trMetProb[54].P[7]=6.74218e-05;			trMetProb[54].P[8]=6.74218e-05;			trMetProb[54].P[9]=6.74218e-05;			trMetProb[54].P[10]=6.74218e-05;			trMetProb[54].P[11]=6.74218e-05;			trMetProb[54].P[12]=6.74218e-05;			trMetProb[54].P[13]=6.74218e-05;			trMetProb[54].P[14]=6.74218e-05;			trMetProb[54].P[15]=6.74218e-05;			trMetProb[54].P[16]=6.74218e-05;			trMetProb[54].P[17]=6.74218e-05;			trMetProb[54].P[18]=6.74218e-05;			trMetProb[54].P[19]=6.74218e-05;			trMetProb[54].P[20]=6.74218e-05;			trMetProb[54].P[21]=6.74218e-05;			trMetProb[54].P[22]=6.74218e-05;			trMetProb[54].P[23]=6.74218e-05;			trMetProb[54].P[24]=6.74218e-05;			trMetProb[54].P[25]=6.74218e-05;			trMetProb[54].P[26]=6.74218e-05;			trMetProb[54].P[27]=6.74218e-05;			trMetProb[54].P[28]=6.74218e-05;			trMetProb[54].P[29]=6.74218e-05;			trMetProb[54].P[30]=6.74218e-05;			trMetProb[54].P[31]=6.74218e-05;			trMetProb[54].P[32]=6.74218e-05;			trMetProb[54].P[33]=6.74218e-05;			trMetProb[54].P[34]=6.74218e-05;			trMetProb[54].P[35]=6.74218e-05;			trMetProb[54].P[36]=6.74218e-05;			trMetProb[54].P[37]=6.74218e-05;			trMetProb[54].P[38]=6.74218e-05;			trMetProb[54].P[39]=6.74218e-05;			trMetProb[54].P[40]=6.74218e-05;			trMetProb[54].P[41]=6.74218e-05;			trMetProb[54].P[42]=6.74218e-05;			trMetProb[54].P[43]=6.74218e-05;			trMetProb[54].P[44]=6.74218e-05;			trMetProb[54].P[45]=6.74218e-05;			trMetProb[54].P[46]=6.74218e-05;			trMetProb[54].P[47]=6.74218e-05;			trMetProb[54].P[48]=6.74218e-05;			trMetProb[54].P[49]=6.74218e-05;			trMetProb[54].P[50]=6.74218e-05;			trMetProb[54].P[51]=6.74218e-05;			trMetProb[54].P[52]=6.74218e-05;			trMetProb[54].P[53]=6.74218e-05;			trMetProb[54].P[54]=0.234695;			trMetProb[54].P[55]=0.00074164;			trMetProb[54].P[56]=0.0149002;			trMetProb[54].P[57]=0.10592;			trMetProb[54].P[58]=6.74218e-05;			trMetProb[54].P[59]=6.74218e-05;			trMetProb[54].P[60]=0.571804;			trMetProb[54].P[61]=6.74218e-05;			trMetProb[54].P[62]=6.74218e-05;			trMetProb[54].P[63]=0.00074164;			trMetProb[54].P[64]=6.74218e-05;			trMetProb[54].P[65]=6.74218e-05;			trMetProb[54].P[66]=6.74218e-05;			trMetProb[54].P[67]=6.74218e-05;			trMetProb[54].P[68]=6.74218e-05;			trMetProb[54].P[69]=6.74218e-05;			trMetProb[54].P[70]=6.74218e-05;			trMetProb[54].P[71]=6.74218e-05;	
		trMetProb[55].P[0]=0.0121951;			trMetProb[55].P[1]=0.0121951;			trMetProb[55].P[2]=0.0121951;			trMetProb[55].P[3]=0.0121951;			trMetProb[55].P[4]=0.0121951;			trMetProb[55].P[5]=0.0121951;			trMetProb[55].P[6]=0.0121951;			trMetProb[55].P[7]=0.0121951;			trMetProb[55].P[8]=0.0121951;			trMetProb[55].P[9]=0.0121951;			trMetProb[55].P[10]=0.0121951;			trMetProb[55].P[11]=0.0121951;			trMetProb[55].P[12]=0.0121951;			trMetProb[55].P[13]=0.0121951;			trMetProb[55].P[14]=0.0121951;			trMetProb[55].P[15]=0.0121951;			trMetProb[55].P[16]=0.0121951;			trMetProb[55].P[17]=0.0121951;			trMetProb[55].P[18]=0.0121951;			trMetProb[55].P[19]=0.0121951;			trMetProb[55].P[20]=0.0121951;			trMetProb[55].P[21]=0.0121951;			trMetProb[55].P[22]=0.0121951;			trMetProb[55].P[23]=0.0121951;			trMetProb[55].P[24]=0.0121951;			trMetProb[55].P[25]=0.0121951;			trMetProb[55].P[26]=0.0121951;			trMetProb[55].P[27]=0.0121951;			trMetProb[55].P[28]=0.0121951;			trMetProb[55].P[29]=0.0121951;			trMetProb[55].P[30]=0.0121951;			trMetProb[55].P[31]=0.0121951;			trMetProb[55].P[32]=0.0121951;			trMetProb[55].P[33]=0.0121951;			trMetProb[55].P[34]=0.0121951;			trMetProb[55].P[35]=0.0121951;			trMetProb[55].P[36]=0.0121951;			trMetProb[55].P[37]=0.0121951;			trMetProb[55].P[38]=0.0121951;			trMetProb[55].P[39]=0.0121951;			trMetProb[55].P[40]=0.0121951;			trMetProb[55].P[41]=0.0121951;			trMetProb[55].P[42]=0.0121951;			trMetProb[55].P[43]=0.0121951;			trMetProb[55].P[44]=0.0121951;			trMetProb[55].P[45]=0.0121951;			trMetProb[55].P[46]=0.0121951;			trMetProb[55].P[47]=0.0121951;			trMetProb[55].P[48]=0.0121951;			trMetProb[55].P[49]=0.0121951;			trMetProb[55].P[50]=0.0121951;			trMetProb[55].P[51]=0.0121951;			trMetProb[55].P[52]=0.0121951;			trMetProb[55].P[53]=0.0121951;			trMetProb[55].P[54]=0.0121951;			trMetProb[55].P[55]=0.0121951;			trMetProb[55].P[56]=0.134146;			trMetProb[55].P[57]=0.0121951;			trMetProb[55].P[58]=0.0121951;			trMetProb[55].P[59]=0.0121951;			trMetProb[55].P[60]=0.0121951;			trMetProb[55].P[61]=0.0121951;			trMetProb[55].P[62]=0.0121951;			trMetProb[55].P[63]=0.0121951;			trMetProb[55].P[64]=0.0121951;			trMetProb[55].P[65]=0.0121951;			trMetProb[55].P[66]=0.0121951;			trMetProb[55].P[67]=0.0121951;			trMetProb[55].P[68]=0.0121951;			trMetProb[55].P[69]=0.0121951;			trMetProb[55].P[70]=0.0121951;			trMetProb[55].P[71]=0.0121951;	
		trMetProb[56].P[0]=0.000158932;			trMetProb[56].P[1]=0.000158932;			trMetProb[56].P[2]=0.000158932;			trMetProb[56].P[3]=0.000158932;			trMetProb[56].P[4]=0.000158932;			trMetProb[56].P[5]=0.000158932;			trMetProb[56].P[6]=0.000158932;			trMetProb[56].P[7]=0.000158932;			trMetProb[56].P[8]=0.000158932;			trMetProb[56].P[9]=0.000158932;			trMetProb[56].P[10]=0.000158932;			trMetProb[56].P[11]=0.000158932;			trMetProb[56].P[12]=0.000158932;			trMetProb[56].P[13]=0.000158932;			trMetProb[56].P[14]=0.000158932;			trMetProb[56].P[15]=0.000158932;			trMetProb[56].P[16]=0.000158932;			trMetProb[56].P[17]=0.000158932;			trMetProb[56].P[18]=0.000158932;			trMetProb[56].P[19]=0.000158932;			trMetProb[56].P[20]=0.000158932;			trMetProb[56].P[21]=0.000158932;			trMetProb[56].P[22]=0.000158932;			trMetProb[56].P[23]=0.000158932;			trMetProb[56].P[24]=0.000158932;			trMetProb[56].P[25]=0.000158932;			trMetProb[56].P[26]=0.000158932;			trMetProb[56].P[27]=0.000158932;			trMetProb[56].P[28]=0.000158932;			trMetProb[56].P[29]=0.000158932;			trMetProb[56].P[30]=0.000158932;			trMetProb[56].P[31]=0.000158932;			trMetProb[56].P[32]=0.000158932;			trMetProb[56].P[33]=0.000158932;			trMetProb[56].P[34]=0.000158932;			trMetProb[56].P[35]=0.000158932;			trMetProb[56].P[36]=0.000158932;			trMetProb[56].P[37]=0.000158932;			trMetProb[56].P[38]=0.000158932;			trMetProb[56].P[39]=0.000158932;			trMetProb[56].P[40]=0.000158932;			trMetProb[56].P[41]=0.000158932;			trMetProb[56].P[42]=0.000158932;			trMetProb[56].P[43]=0.000158932;			trMetProb[56].P[44]=0.000158932;			trMetProb[56].P[45]=0.000158932;			trMetProb[56].P[46]=0.000158932;			trMetProb[56].P[47]=0.000158932;			trMetProb[56].P[48]=0.000158932;			trMetProb[56].P[49]=0.000158932;			trMetProb[56].P[50]=0.000158932;			trMetProb[56].P[51]=0.000158932;			trMetProb[56].P[52]=0.000158932;			trMetProb[56].P[53]=0.000158932;			trMetProb[56].P[54]=0.000158932;			trMetProb[56].P[55]=0.000158932;			trMetProb[56].P[56]=0.171805;			trMetProb[56].P[57]=0.00810553;			trMetProb[56].P[58]=0.0287667;			trMetProb[56].P[59]=0.000158932;			trMetProb[56].P[60]=0.159091;			trMetProb[56].P[61]=0.000158932;			trMetProb[56].P[62]=0.000158932;			trMetProb[56].P[63]=0.000158932;			trMetProb[56].P[64]=0.621583;			trMetProb[56].P[65]=0.000158932;			trMetProb[56].P[66]=0.000158932;			trMetProb[56].P[67]=0.000158932;			trMetProb[56].P[68]=0.000158932;			trMetProb[56].P[69]=0.000158932;			trMetProb[56].P[70]=0.000158932;			trMetProb[56].P[71]=0.000158932;	
		trMetProb[57].P[0]=0.000482625;			trMetProb[57].P[1]=0.000482625;			trMetProb[57].P[2]=0.000482625;			trMetProb[57].P[3]=0.000482625;			trMetProb[57].P[4]=0.000482625;			trMetProb[57].P[5]=0.000482625;			trMetProb[57].P[6]=0.000482625;			trMetProb[57].P[7]=0.000482625;			trMetProb[57].P[8]=0.000482625;			trMetProb[57].P[9]=0.000482625;			trMetProb[57].P[10]=0.000482625;			trMetProb[57].P[11]=0.000482625;			trMetProb[57].P[12]=0.000482625;			trMetProb[57].P[13]=0.000482625;			trMetProb[57].P[14]=0.000482625;			trMetProb[57].P[15]=0.000482625;			trMetProb[57].P[16]=0.000482625;			trMetProb[57].P[17]=0.000482625;			trMetProb[57].P[18]=0.000482625;			trMetProb[57].P[19]=0.000482625;			trMetProb[57].P[20]=0.000482625;			trMetProb[57].P[21]=0.000482625;			trMetProb[57].P[22]=0.000482625;			trMetProb[57].P[23]=0.000482625;			trMetProb[57].P[24]=0.000482625;			trMetProb[57].P[25]=0.000482625;			trMetProb[57].P[26]=0.000482625;			trMetProb[57].P[27]=0.000482625;			trMetProb[57].P[28]=0.000482625;			trMetProb[57].P[29]=0.000482625;			trMetProb[57].P[30]=0.000482625;			trMetProb[57].P[31]=0.000482625;			trMetProb[57].P[32]=0.000482625;			trMetProb[57].P[33]=0.000482625;			trMetProb[57].P[34]=0.000482625;			trMetProb[57].P[35]=0.000482625;			trMetProb[57].P[36]=0.000482625;			trMetProb[57].P[37]=0.000482625;			trMetProb[57].P[38]=0.000482625;			trMetProb[57].P[39]=0.000482625;			trMetProb[57].P[40]=0.000482625;			trMetProb[57].P[41]=0.000482625;			trMetProb[57].P[42]=0.000482625;			trMetProb[57].P[43]=0.000482625;			trMetProb[57].P[44]=0.000482625;			trMetProb[57].P[45]=0.000482625;			trMetProb[57].P[46]=0.000482625;			trMetProb[57].P[47]=0.000482625;			trMetProb[57].P[48]=0.000482625;			trMetProb[57].P[49]=0.000482625;			trMetProb[57].P[50]=0.000482625;			trMetProb[57].P[51]=0.000482625;			trMetProb[57].P[52]=0.000482625;			trMetProb[57].P[53]=0.000482625;			trMetProb[57].P[54]=0.000482625;			trMetProb[57].P[55]=0.000482625;			trMetProb[57].P[56]=0.000482625;			trMetProb[57].P[57]=0.135618;			trMetProb[57].P[58]=0.000482625;			trMetProb[57].P[59]=0.000482625;			trMetProb[57].P[60]=0.830598;			trMetProb[57].P[61]=0.000482625;			trMetProb[57].P[62]=0.000482625;			trMetProb[57].P[63]=0.000482625;			trMetProb[57].P[64]=0.000482625;			trMetProb[57].P[65]=0.000482625;			trMetProb[57].P[66]=0.000482625;			trMetProb[57].P[67]=0.000482625;			trMetProb[57].P[68]=0.000482625;			trMetProb[57].P[69]=0.000482625;			trMetProb[57].P[70]=0.000482625;			trMetProb[57].P[71]=0.000482625;	
		trMetProb[58].P[0]=0.00396825;			trMetProb[58].P[1]=0.00396825;			trMetProb[58].P[2]=0.00396825;			trMetProb[58].P[3]=0.00396825;			trMetProb[58].P[4]=0.00396825;			trMetProb[58].P[5]=0.00396825;			trMetProb[58].P[6]=0.00396825;			trMetProb[58].P[7]=0.00396825;			trMetProb[58].P[8]=0.00396825;			trMetProb[58].P[9]=0.00396825;			trMetProb[58].P[10]=0.00396825;			trMetProb[58].P[11]=0.00396825;			trMetProb[58].P[12]=0.00396825;			trMetProb[58].P[13]=0.00396825;			trMetProb[58].P[14]=0.00396825;			trMetProb[58].P[15]=0.00396825;			trMetProb[58].P[16]=0.00396825;			trMetProb[58].P[17]=0.00396825;			trMetProb[58].P[18]=0.00396825;			trMetProb[58].P[19]=0.00396825;			trMetProb[58].P[20]=0.00396825;			trMetProb[58].P[21]=0.00396825;			trMetProb[58].P[22]=0.00396825;			trMetProb[58].P[23]=0.00396825;			trMetProb[58].P[24]=0.00396825;			trMetProb[58].P[25]=0.00396825;			trMetProb[58].P[26]=0.00396825;			trMetProb[58].P[27]=0.00396825;			trMetProb[58].P[28]=0.00396825;			trMetProb[58].P[29]=0.00396825;			trMetProb[58].P[30]=0.00396825;			trMetProb[58].P[31]=0.00396825;			trMetProb[58].P[32]=0.00396825;			trMetProb[58].P[33]=0.00396825;			trMetProb[58].P[34]=0.00396825;			trMetProb[58].P[35]=0.00396825;			trMetProb[58].P[36]=0.00396825;			trMetProb[58].P[37]=0.00396825;			trMetProb[58].P[38]=0.00396825;			trMetProb[58].P[39]=0.00396825;			trMetProb[58].P[40]=0.00396825;			trMetProb[58].P[41]=0.00396825;			trMetProb[58].P[42]=0.00396825;			trMetProb[58].P[43]=0.00396825;			trMetProb[58].P[44]=0.00396825;			trMetProb[58].P[45]=0.00396825;			trMetProb[58].P[46]=0.00396825;			trMetProb[58].P[47]=0.00396825;			trMetProb[58].P[48]=0.00396825;			trMetProb[58].P[49]=0.00396825;			trMetProb[58].P[50]=0.00396825;			trMetProb[58].P[51]=0.00396825;			trMetProb[58].P[52]=0.00396825;			trMetProb[58].P[53]=0.00396825;			trMetProb[58].P[54]=0.00396825;			trMetProb[58].P[55]=0.00396825;			trMetProb[58].P[56]=0.00396825;			trMetProb[58].P[57]=0.00396825;			trMetProb[58].P[58]=0.00396825;			trMetProb[58].P[59]=0.00396825;			trMetProb[58].P[60]=0.718254;			trMetProb[58].P[61]=0.00396825;			trMetProb[58].P[62]=0.00396825;			trMetProb[58].P[63]=0.00396825;			trMetProb[58].P[64]=0.00396825;			trMetProb[58].P[65]=0.00396825;			trMetProb[58].P[66]=0.00396825;			trMetProb[58].P[67]=0.00396825;			trMetProb[58].P[68]=0.00396825;			trMetProb[58].P[69]=0.00396825;			trMetProb[58].P[70]=0.00396825;			trMetProb[58].P[71]=0.00396825;	
		trMetProb[59].P[0]=0.0138889;			trMetProb[59].P[1]=0.0138889;			trMetProb[59].P[2]=0.0138889;			trMetProb[59].P[3]=0.0138889;			trMetProb[59].P[4]=0.0138889;			trMetProb[59].P[5]=0.0138889;			trMetProb[59].P[6]=0.0138889;			trMetProb[59].P[7]=0.0138889;			trMetProb[59].P[8]=0.0138889;			trMetProb[59].P[9]=0.0138889;			trMetProb[59].P[10]=0.0138889;			trMetProb[59].P[11]=0.0138889;			trMetProb[59].P[12]=0.0138889;			trMetProb[59].P[13]=0.0138889;			trMetProb[59].P[14]=0.0138889;			trMetProb[59].P[15]=0.0138889;			trMetProb[59].P[16]=0.0138889;			trMetProb[59].P[17]=0.0138889;			trMetProb[59].P[18]=0.0138889;			trMetProb[59].P[19]=0.0138889;			trMetProb[59].P[20]=0.0138889;			trMetProb[59].P[21]=0.0138889;			trMetProb[59].P[22]=0.0138889;			trMetProb[59].P[23]=0.0138889;			trMetProb[59].P[24]=0.0138889;			trMetProb[59].P[25]=0.0138889;			trMetProb[59].P[26]=0.0138889;			trMetProb[59].P[27]=0.0138889;			trMetProb[59].P[28]=0.0138889;			trMetProb[59].P[29]=0.0138889;			trMetProb[59].P[30]=0.0138889;			trMetProb[59].P[31]=0.0138889;			trMetProb[59].P[32]=0.0138889;			trMetProb[59].P[33]=0.0138889;			trMetProb[59].P[34]=0.0138889;			trMetProb[59].P[35]=0.0138889;			trMetProb[59].P[36]=0.0138889;			trMetProb[59].P[37]=0.0138889;			trMetProb[59].P[38]=0.0138889;			trMetProb[59].P[39]=0.0138889;			trMetProb[59].P[40]=0.0138889;			trMetProb[59].P[41]=0.0138889;			trMetProb[59].P[42]=0.0138889;			trMetProb[59].P[43]=0.0138889;			trMetProb[59].P[44]=0.0138889;			trMetProb[59].P[45]=0.0138889;			trMetProb[59].P[46]=0.0138889;			trMetProb[59].P[47]=0.0138889;			trMetProb[59].P[48]=0.0138889;			trMetProb[59].P[49]=0.0138889;			trMetProb[59].P[50]=0.0138889;			trMetProb[59].P[51]=0.0138889;			trMetProb[59].P[52]=0.0138889;			trMetProb[59].P[53]=0.0138889;			trMetProb[59].P[54]=0.0138889;			trMetProb[59].P[55]=0.0138889;			trMetProb[59].P[56]=0.0138889;			trMetProb[59].P[57]=0.0138889;			trMetProb[59].P[58]=0.0138889;			trMetProb[59].P[59]=0.0138889;			trMetProb[59].P[60]=0.0138889;			trMetProb[59].P[61]=0.0138889;			trMetProb[59].P[62]=0.0138889;			trMetProb[59].P[63]=0.0138889;			trMetProb[59].P[64]=0.0138889;			trMetProb[59].P[65]=0.0138889;			trMetProb[59].P[66]=0.0138889;			trMetProb[59].P[67]=0.0138889;			trMetProb[59].P[68]=0.0138889;			trMetProb[59].P[69]=0.0138889;			trMetProb[59].P[70]=0.0138889;			trMetProb[59].P[71]=0.0138889;	
		trMetProb[60].P[0]=0.493566;			trMetProb[60].P[1]=1.31299e-05;			trMetProb[60].P[2]=1.31299e-05;			trMetProb[60].P[3]=1.31299e-05;			trMetProb[60].P[4]=1.31299e-05;			trMetProb[60].P[5]=1.31299e-05;			trMetProb[60].P[6]=1.31299e-05;			trMetProb[60].P[7]=1.31299e-05;			trMetProb[60].P[8]=1.31299e-05;			trMetProb[60].P[9]=1.31299e-05;			trMetProb[60].P[10]=1.31299e-05;			trMetProb[60].P[11]=1.31299e-05;			trMetProb[60].P[12]=0.000407027;			trMetProb[60].P[13]=1.31299e-05;			trMetProb[60].P[14]=1.31299e-05;			trMetProb[60].P[15]=1.31299e-05;			trMetProb[60].P[16]=1.31299e-05;			trMetProb[60].P[17]=1.31299e-05;			trMetProb[60].P[18]=1.31299e-05;			trMetProb[60].P[19]=1.31299e-05;			trMetProb[60].P[20]=1.31299e-05;			trMetProb[60].P[21]=1.31299e-05;			trMetProb[60].P[22]=1.31299e-05;			trMetProb[60].P[23]=1.31299e-05;			trMetProb[60].P[24]=0.000669625;			trMetProb[60].P[25]=1.31299e-05;			trMetProb[60].P[26]=1.31299e-05;			trMetProb[60].P[27]=1.31299e-05;			trMetProb[60].P[28]=1.31299e-05;			trMetProb[60].P[29]=1.31299e-05;			trMetProb[60].P[30]=1.31299e-05;			trMetProb[60].P[31]=1.31299e-05;			trMetProb[60].P[32]=1.31299e-05;			trMetProb[60].P[33]=1.31299e-05;			trMetProb[60].P[34]=1.31299e-05;			trMetProb[60].P[35]=1.31299e-05;			trMetProb[60].P[36]=0.000538326;			trMetProb[60].P[37]=1.31299e-05;			trMetProb[60].P[38]=1.31299e-05;			trMetProb[60].P[39]=1.31299e-05;			trMetProb[60].P[40]=1.31299e-05;			trMetProb[60].P[41]=1.31299e-05;			trMetProb[60].P[42]=1.31299e-05;			trMetProb[60].P[43]=1.31299e-05;			trMetProb[60].P[44]=1.31299e-05;			trMetProb[60].P[45]=1.31299e-05;			trMetProb[60].P[46]=1.31299e-05;			trMetProb[60].P[47]=1.31299e-05;			trMetProb[60].P[48]=1.31299e-05;			trMetProb[60].P[49]=1.31299e-05;			trMetProb[60].P[50]=1.31299e-05;			trMetProb[60].P[51]=1.31299e-05;			trMetProb[60].P[52]=1.31299e-05;			trMetProb[60].P[53]=1.31299e-05;			trMetProb[60].P[54]=1.31299e-05;			trMetProb[60].P[55]=1.31299e-05;			trMetProb[60].P[56]=1.31299e-05;			trMetProb[60].P[57]=1.31299e-05;			trMetProb[60].P[58]=1.31299e-05;			trMetProb[60].P[59]=1.31299e-05;			trMetProb[60].P[60]=0.343098;			trMetProb[60].P[61]=0.000144429;			trMetProb[60].P[62]=0.000932223;			trMetProb[60].P[63]=0.0185263;			trMetProb[60].P[64]=0.0135369;			trMetProb[60].P[65]=1.31299e-05;			trMetProb[60].P[66]=0.125666;			trMetProb[60].P[67]=1.31299e-05;			trMetProb[60].P[68]=1.31299e-05;			trMetProb[60].P[69]=0.00211392;			trMetProb[60].P[70]=1.31299e-05;			trMetProb[60].P[71]=1.31299e-05;	
		trMetProb[61].P[0]=0.0121951;			trMetProb[61].P[1]=0.0121951;			trMetProb[61].P[2]=0.0121951;			trMetProb[61].P[3]=0.0121951;			trMetProb[61].P[4]=0.0121951;			trMetProb[61].P[5]=0.0121951;			trMetProb[61].P[6]=0.0121951;			trMetProb[61].P[7]=0.0121951;			trMetProb[61].P[8]=0.0121951;			trMetProb[61].P[9]=0.0121951;			trMetProb[61].P[10]=0.0121951;			trMetProb[61].P[11]=0.0121951;			trMetProb[61].P[12]=0.0121951;			trMetProb[61].P[13]=0.0121951;			trMetProb[61].P[14]=0.0121951;			trMetProb[61].P[15]=0.0121951;			trMetProb[61].P[16]=0.0121951;			trMetProb[61].P[17]=0.0121951;			trMetProb[61].P[18]=0.0121951;			trMetProb[61].P[19]=0.0121951;			trMetProb[61].P[20]=0.0121951;			trMetProb[61].P[21]=0.0121951;			trMetProb[61].P[22]=0.0121951;			trMetProb[61].P[23]=0.0121951;			trMetProb[61].P[24]=0.0121951;			trMetProb[61].P[25]=0.0121951;			trMetProb[61].P[26]=0.0121951;			trMetProb[61].P[27]=0.0121951;			trMetProb[61].P[28]=0.0121951;			trMetProb[61].P[29]=0.0121951;			trMetProb[61].P[30]=0.0121951;			trMetProb[61].P[31]=0.0121951;			trMetProb[61].P[32]=0.0121951;			trMetProb[61].P[33]=0.0121951;			trMetProb[61].P[34]=0.0121951;			trMetProb[61].P[35]=0.0121951;			trMetProb[61].P[36]=0.0121951;			trMetProb[61].P[37]=0.0121951;			trMetProb[61].P[38]=0.0121951;			trMetProb[61].P[39]=0.0121951;			trMetProb[61].P[40]=0.0121951;			trMetProb[61].P[41]=0.0121951;			trMetProb[61].P[42]=0.0121951;			trMetProb[61].P[43]=0.0121951;			trMetProb[61].P[44]=0.0121951;			trMetProb[61].P[45]=0.0121951;			trMetProb[61].P[46]=0.0121951;			trMetProb[61].P[47]=0.0121951;			trMetProb[61].P[48]=0.0121951;			trMetProb[61].P[49]=0.0121951;			trMetProb[61].P[50]=0.0121951;			trMetProb[61].P[51]=0.0121951;			trMetProb[61].P[52]=0.0121951;			trMetProb[61].P[53]=0.0121951;			trMetProb[61].P[54]=0.0121951;			trMetProb[61].P[55]=0.0121951;			trMetProb[61].P[56]=0.0121951;			trMetProb[61].P[57]=0.0121951;			trMetProb[61].P[58]=0.0121951;			trMetProb[61].P[59]=0.0121951;			trMetProb[61].P[60]=0.0121951;			trMetProb[61].P[61]=0.0121951;			trMetProb[61].P[62]=0.134146;			trMetProb[61].P[63]=0.0121951;			trMetProb[61].P[64]=0.0121951;			trMetProb[61].P[65]=0.0121951;			trMetProb[61].P[66]=0.0121951;			trMetProb[61].P[67]=0.0121951;			trMetProb[61].P[68]=0.0121951;			trMetProb[61].P[69]=0.0121951;			trMetProb[61].P[70]=0.0121951;			trMetProb[61].P[71]=0.0121951;	
		trMetProb[62].P[0]=0.00657895;			trMetProb[62].P[1]=0.00657895;			trMetProb[62].P[2]=0.00657895;			trMetProb[62].P[3]=0.00657895;			trMetProb[62].P[4]=0.00657895;			trMetProb[62].P[5]=0.00657895;			trMetProb[62].P[6]=0.00657895;			trMetProb[62].P[7]=0.00657895;			trMetProb[62].P[8]=0.00657895;			trMetProb[62].P[9]=0.00657895;			trMetProb[62].P[10]=0.00657895;			trMetProb[62].P[11]=0.00657895;			trMetProb[62].P[12]=0.00657895;			trMetProb[62].P[13]=0.00657895;			trMetProb[62].P[14]=0.00657895;			trMetProb[62].P[15]=0.00657895;			trMetProb[62].P[16]=0.00657895;			trMetProb[62].P[17]=0.00657895;			trMetProb[62].P[18]=0.00657895;			trMetProb[62].P[19]=0.00657895;			trMetProb[62].P[20]=0.00657895;			trMetProb[62].P[21]=0.00657895;			trMetProb[62].P[22]=0.00657895;			trMetProb[62].P[23]=0.00657895;			trMetProb[62].P[24]=0.00657895;			trMetProb[62].P[25]=0.00657895;			trMetProb[62].P[26]=0.00657895;			trMetProb[62].P[27]=0.00657895;			trMetProb[62].P[28]=0.00657895;			trMetProb[62].P[29]=0.00657895;			trMetProb[62].P[30]=0.00657895;			trMetProb[62].P[31]=0.00657895;			trMetProb[62].P[32]=0.00657895;			trMetProb[62].P[33]=0.00657895;			trMetProb[62].P[34]=0.00657895;			trMetProb[62].P[35]=0.00657895;			trMetProb[62].P[36]=0.00657895;			trMetProb[62].P[37]=0.00657895;			trMetProb[62].P[38]=0.00657895;			trMetProb[62].P[39]=0.00657895;			trMetProb[62].P[40]=0.00657895;			trMetProb[62].P[41]=0.00657895;			trMetProb[62].P[42]=0.00657895;			trMetProb[62].P[43]=0.00657895;			trMetProb[62].P[44]=0.00657895;			trMetProb[62].P[45]=0.00657895;			trMetProb[62].P[46]=0.00657895;			trMetProb[62].P[47]=0.00657895;			trMetProb[62].P[48]=0.00657895;			trMetProb[62].P[49]=0.00657895;			trMetProb[62].P[50]=0.00657895;			trMetProb[62].P[51]=0.00657895;			trMetProb[62].P[52]=0.00657895;			trMetProb[62].P[53]=0.00657895;			trMetProb[62].P[54]=0.00657895;			trMetProb[62].P[55]=0.00657895;			trMetProb[62].P[56]=0.00657895;			trMetProb[62].P[57]=0.00657895;			trMetProb[62].P[58]=0.00657895;			trMetProb[62].P[59]=0.00657895;			trMetProb[62].P[60]=0.00657895;			trMetProb[62].P[61]=0.00657895;			trMetProb[62].P[62]=0.00657895;			trMetProb[62].P[63]=0.0723684;			trMetProb[62].P[64]=0.467105;			trMetProb[62].P[65]=0.00657895;			trMetProb[62].P[66]=0.00657895;			trMetProb[62].P[67]=0.00657895;			trMetProb[62].P[68]=0.00657895;			trMetProb[62].P[69]=0.00657895;			trMetProb[62].P[70]=0.00657895;			trMetProb[62].P[71]=0.00657895;	
		trMetProb[63].P[0]=0.0398429;			trMetProb[63].P[1]=0.000561167;			trMetProb[63].P[2]=0.000561167;			trMetProb[63].P[3]=0.000561167;			trMetProb[63].P[4]=0.000561167;			trMetProb[63].P[5]=0.000561167;			trMetProb[63].P[6]=0.000561167;			trMetProb[63].P[7]=0.000561167;			trMetProb[63].P[8]=0.000561167;			trMetProb[63].P[9]=0.000561167;			trMetProb[63].P[10]=0.000561167;			trMetProb[63].P[11]=0.000561167;			trMetProb[63].P[12]=0.000561167;			trMetProb[63].P[13]=0.000561167;			trMetProb[63].P[14]=0.000561167;			trMetProb[63].P[15]=0.000561167;			trMetProb[63].P[16]=0.000561167;			trMetProb[63].P[17]=0.000561167;			trMetProb[63].P[18]=0.000561167;			trMetProb[63].P[19]=0.000561167;			trMetProb[63].P[20]=0.000561167;			trMetProb[63].P[21]=0.000561167;			trMetProb[63].P[22]=0.000561167;			trMetProb[63].P[23]=0.000561167;			trMetProb[63].P[24]=0.000561167;			trMetProb[63].P[25]=0.000561167;			trMetProb[63].P[26]=0.000561167;			trMetProb[63].P[27]=0.000561167;			trMetProb[63].P[28]=0.000561167;			trMetProb[63].P[29]=0.000561167;			trMetProb[63].P[30]=0.000561167;			trMetProb[63].P[31]=0.000561167;			trMetProb[63].P[32]=0.000561167;			trMetProb[63].P[33]=0.000561167;			trMetProb[63].P[34]=0.000561167;			trMetProb[63].P[35]=0.000561167;			trMetProb[63].P[36]=0.000561167;			trMetProb[63].P[37]=0.000561167;			trMetProb[63].P[38]=0.000561167;			trMetProb[63].P[39]=0.000561167;			trMetProb[63].P[40]=0.000561167;			trMetProb[63].P[41]=0.000561167;			trMetProb[63].P[42]=0.000561167;			trMetProb[63].P[43]=0.000561167;			trMetProb[63].P[44]=0.000561167;			trMetProb[63].P[45]=0.000561167;			trMetProb[63].P[46]=0.000561167;			trMetProb[63].P[47]=0.000561167;			trMetProb[63].P[48]=0.000561167;			trMetProb[63].P[49]=0.000561167;			trMetProb[63].P[50]=0.000561167;			trMetProb[63].P[51]=0.000561167;			trMetProb[63].P[52]=0.000561167;			trMetProb[63].P[53]=0.000561167;			trMetProb[63].P[54]=0.000561167;			trMetProb[63].P[55]=0.000561167;			trMetProb[63].P[56]=0.000561167;			trMetProb[63].P[57]=0.000561167;			trMetProb[63].P[58]=0.000561167;			trMetProb[63].P[59]=0.000561167;			trMetProb[63].P[60]=0.000561167;			trMetProb[63].P[61]=0.000561167;			trMetProb[63].P[62]=0.000561167;			trMetProb[63].P[63]=0.146465;			trMetProb[63].P[64]=0.0286195;			trMetProb[63].P[65]=0.000561167;			trMetProb[63].P[66]=0.746914;			trMetProb[63].P[67]=0.000561167;			trMetProb[63].P[68]=0.000561167;			trMetProb[63].P[69]=0.000561167;			trMetProb[63].P[70]=0.000561167;			trMetProb[63].P[71]=0.000561167;	
		trMetProb[64].P[0]=0.670399;			trMetProb[64].P[1]=0.000162285;			trMetProb[64].P[2]=0.000162285;			trMetProb[64].P[3]=0.000162285;			trMetProb[64].P[4]=0.000162285;			trMetProb[64].P[5]=0.000162285;			trMetProb[64].P[6]=0.000162285;			trMetProb[64].P[7]=0.000162285;			trMetProb[64].P[8]=0.000162285;			trMetProb[64].P[9]=0.000162285;			trMetProb[64].P[10]=0.000162285;			trMetProb[64].P[11]=0.000162285;			trMetProb[64].P[12]=0.000162285;			trMetProb[64].P[13]=0.000162285;			trMetProb[64].P[14]=0.000162285;			trMetProb[64].P[15]=0.000162285;			trMetProb[64].P[16]=0.000162285;			trMetProb[64].P[17]=0.000162285;			trMetProb[64].P[18]=0.000162285;			trMetProb[64].P[19]=0.000162285;			trMetProb[64].P[20]=0.000162285;			trMetProb[64].P[21]=0.000162285;			trMetProb[64].P[22]=0.000162285;			trMetProb[64].P[23]=0.000162285;			trMetProb[64].P[24]=0.000162285;			trMetProb[64].P[25]=0.000162285;			trMetProb[64].P[26]=0.000162285;			trMetProb[64].P[27]=0.000162285;			trMetProb[64].P[28]=0.000162285;			trMetProb[64].P[29]=0.000162285;			trMetProb[64].P[30]=0.000162285;			trMetProb[64].P[31]=0.000162285;			trMetProb[64].P[32]=0.000162285;			trMetProb[64].P[33]=0.000162285;			trMetProb[64].P[34]=0.000162285;			trMetProb[64].P[35]=0.000162285;			trMetProb[64].P[36]=0.000162285;			trMetProb[64].P[37]=0.000162285;			trMetProb[64].P[38]=0.000162285;			trMetProb[64].P[39]=0.000162285;			trMetProb[64].P[40]=0.000162285;			trMetProb[64].P[41]=0.000162285;			trMetProb[64].P[42]=0.000162285;			trMetProb[64].P[43]=0.000162285;			trMetProb[64].P[44]=0.000162285;			trMetProb[64].P[45]=0.000162285;			trMetProb[64].P[46]=0.000162285;			trMetProb[64].P[47]=0.000162285;			trMetProb[64].P[48]=0.000162285;			trMetProb[64].P[49]=0.000162285;			trMetProb[64].P[50]=0.000162285;			trMetProb[64].P[51]=0.000162285;			trMetProb[64].P[52]=0.000162285;			trMetProb[64].P[53]=0.000162285;			trMetProb[64].P[54]=0.000162285;			trMetProb[64].P[55]=0.000162285;			trMetProb[64].P[56]=0.000162285;			trMetProb[64].P[57]=0.000162285;			trMetProb[64].P[58]=0.000162285;			trMetProb[64].P[59]=0.000162285;			trMetProb[64].P[60]=0.000162285;			trMetProb[64].P[61]=0.000162285;			trMetProb[64].P[62]=0.000162285;			trMetProb[64].P[63]=0.000162285;			trMetProb[64].P[64]=0.177053;			trMetProb[64].P[65]=0.00178513;			trMetProb[64].P[66]=0.0439792;			trMetProb[64].P[67]=0.000162285;			trMetProb[64].P[68]=0.0959104;			trMetProb[64].P[69]=0.000162285;			trMetProb[64].P[70]=0.000162285;			trMetProb[64].P[71]=0.000162285;	
		trMetProb[65].P[0]=0.0121951;			trMetProb[65].P[1]=0.0121951;			trMetProb[65].P[2]=0.0121951;			trMetProb[65].P[3]=0.0121951;			trMetProb[65].P[4]=0.0121951;			trMetProb[65].P[5]=0.0121951;			trMetProb[65].P[6]=0.0121951;			trMetProb[65].P[7]=0.0121951;			trMetProb[65].P[8]=0.0121951;			trMetProb[65].P[9]=0.0121951;			trMetProb[65].P[10]=0.0121951;			trMetProb[65].P[11]=0.0121951;			trMetProb[65].P[12]=0.0121951;			trMetProb[65].P[13]=0.0121951;			trMetProb[65].P[14]=0.0121951;			trMetProb[65].P[15]=0.0121951;			trMetProb[65].P[16]=0.0121951;			trMetProb[65].P[17]=0.0121951;			trMetProb[65].P[18]=0.0121951;			trMetProb[65].P[19]=0.0121951;			trMetProb[65].P[20]=0.0121951;			trMetProb[65].P[21]=0.0121951;			trMetProb[65].P[22]=0.0121951;			trMetProb[65].P[23]=0.0121951;			trMetProb[65].P[24]=0.0121951;			trMetProb[65].P[25]=0.0121951;			trMetProb[65].P[26]=0.0121951;			trMetProb[65].P[27]=0.0121951;			trMetProb[65].P[28]=0.0121951;			trMetProb[65].P[29]=0.0121951;			trMetProb[65].P[30]=0.0121951;			trMetProb[65].P[31]=0.0121951;			trMetProb[65].P[32]=0.0121951;			trMetProb[65].P[33]=0.0121951;			trMetProb[65].P[34]=0.0121951;			trMetProb[65].P[35]=0.0121951;			trMetProb[65].P[36]=0.0121951;			trMetProb[65].P[37]=0.0121951;			trMetProb[65].P[38]=0.0121951;			trMetProb[65].P[39]=0.0121951;			trMetProb[65].P[40]=0.0121951;			trMetProb[65].P[41]=0.0121951;			trMetProb[65].P[42]=0.0121951;			trMetProb[65].P[43]=0.0121951;			trMetProb[65].P[44]=0.0121951;			trMetProb[65].P[45]=0.0121951;			trMetProb[65].P[46]=0.0121951;			trMetProb[65].P[47]=0.0121951;			trMetProb[65].P[48]=0.0121951;			trMetProb[65].P[49]=0.0121951;			trMetProb[65].P[50]=0.0121951;			trMetProb[65].P[51]=0.0121951;			trMetProb[65].P[52]=0.0121951;			trMetProb[65].P[53]=0.0121951;			trMetProb[65].P[54]=0.0121951;			trMetProb[65].P[55]=0.0121951;			trMetProb[65].P[56]=0.0121951;			trMetProb[65].P[57]=0.0121951;			trMetProb[65].P[58]=0.0121951;			trMetProb[65].P[59]=0.0121951;			trMetProb[65].P[60]=0.0121951;			trMetProb[65].P[61]=0.0121951;			trMetProb[65].P[62]=0.0121951;			trMetProb[65].P[63]=0.0121951;			trMetProb[65].P[64]=0.0121951;			trMetProb[65].P[65]=0.0121951;			trMetProb[65].P[66]=0.134146;			trMetProb[65].P[67]=0.0121951;			trMetProb[65].P[68]=0.0121951;			trMetProb[65].P[69]=0.0121951;			trMetProb[65].P[70]=0.0121951;			trMetProb[65].P[71]=0.0121951;	
		trMetProb[66].P[0]=0.596781;			trMetProb[66].P[1]=5.34702e-05;			trMetProb[66].P[2]=5.34702e-05;			trMetProb[66].P[3]=5.34702e-05;			trMetProb[66].P[4]=5.34702e-05;			trMetProb[66].P[5]=5.34702e-05;			trMetProb[66].P[6]=0.00112287;			trMetProb[66].P[7]=5.34702e-05;			trMetProb[66].P[8]=5.34702e-05;			trMetProb[66].P[9]=5.34702e-05;			trMetProb[66].P[10]=5.34702e-05;			trMetProb[66].P[11]=5.34702e-05;			trMetProb[66].P[12]=5.34702e-05;			trMetProb[66].P[13]=5.34702e-05;			trMetProb[66].P[14]=5.34702e-05;			trMetProb[66].P[15]=5.34702e-05;			trMetProb[66].P[16]=5.34702e-05;			trMetProb[66].P[17]=5.34702e-05;			trMetProb[66].P[18]=5.34702e-05;			trMetProb[66].P[19]=5.34702e-05;			trMetProb[66].P[20]=5.34702e-05;			trMetProb[66].P[21]=5.34702e-05;			trMetProb[66].P[22]=5.34702e-05;			trMetProb[66].P[23]=5.34702e-05;			trMetProb[66].P[24]=5.34702e-05;			trMetProb[66].P[25]=5.34702e-05;			trMetProb[66].P[26]=5.34702e-05;			trMetProb[66].P[27]=5.34702e-05;			trMetProb[66].P[28]=5.34702e-05;			trMetProb[66].P[29]=5.34702e-05;			trMetProb[66].P[30]=5.34702e-05;			trMetProb[66].P[31]=5.34702e-05;			trMetProb[66].P[32]=5.34702e-05;			trMetProb[66].P[33]=5.34702e-05;			trMetProb[66].P[34]=5.34702e-05;			trMetProb[66].P[35]=5.34702e-05;			trMetProb[66].P[36]=5.34702e-05;			trMetProb[66].P[37]=5.34702e-05;			trMetProb[66].P[38]=5.34702e-05;			trMetProb[66].P[39]=5.34702e-05;			trMetProb[66].P[40]=5.34702e-05;			trMetProb[66].P[41]=5.34702e-05;			trMetProb[66].P[42]=5.34702e-05;			trMetProb[66].P[43]=5.34702e-05;			trMetProb[66].P[44]=5.34702e-05;			trMetProb[66].P[45]=5.34702e-05;			trMetProb[66].P[46]=5.34702e-05;			trMetProb[66].P[47]=5.34702e-05;			trMetProb[66].P[48]=5.34702e-05;			trMetProb[66].P[49]=5.34702e-05;			trMetProb[66].P[50]=5.34702e-05;			trMetProb[66].P[51]=5.34702e-05;			trMetProb[66].P[52]=5.34702e-05;			trMetProb[66].P[53]=5.34702e-05;			trMetProb[66].P[54]=5.34702e-05;			trMetProb[66].P[55]=5.34702e-05;			trMetProb[66].P[56]=5.34702e-05;			trMetProb[66].P[57]=5.34702e-05;			trMetProb[66].P[58]=5.34702e-05;			trMetProb[66].P[59]=5.34702e-05;			trMetProb[66].P[60]=5.34702e-05;			trMetProb[66].P[61]=5.34702e-05;			trMetProb[66].P[62]=5.34702e-05;			trMetProb[66].P[63]=5.34702e-05;			trMetProb[66].P[64]=5.34702e-05;			trMetProb[66].P[65]=5.34702e-05;			trMetProb[66].P[66]=0.288793;			trMetProb[66].P[67]=0.000588172;			trMetProb[66].P[68]=0.00486579;			trMetProb[66].P[69]=0.103251;			trMetProb[66].P[70]=0.00112287;			trMetProb[66].P[71]=5.34702e-05;	
		trMetProb[67].P[0]=0.0121951;			trMetProb[67].P[1]=0.0121951;			trMetProb[67].P[2]=0.0121951;			trMetProb[67].P[3]=0.0121951;			trMetProb[67].P[4]=0.0121951;			trMetProb[67].P[5]=0.0121951;			trMetProb[67].P[6]=0.0121951;			trMetProb[67].P[7]=0.0121951;			trMetProb[67].P[8]=0.0121951;			trMetProb[67].P[9]=0.0121951;			trMetProb[67].P[10]=0.0121951;			trMetProb[67].P[11]=0.0121951;			trMetProb[67].P[12]=0.0121951;			trMetProb[67].P[13]=0.0121951;			trMetProb[67].P[14]=0.0121951;			trMetProb[67].P[15]=0.0121951;			trMetProb[67].P[16]=0.0121951;			trMetProb[67].P[17]=0.0121951;			trMetProb[67].P[18]=0.0121951;			trMetProb[67].P[19]=0.0121951;			trMetProb[67].P[20]=0.0121951;			trMetProb[67].P[21]=0.0121951;			trMetProb[67].P[22]=0.0121951;			trMetProb[67].P[23]=0.0121951;			trMetProb[67].P[24]=0.0121951;			trMetProb[67].P[25]=0.0121951;			trMetProb[67].P[26]=0.0121951;			trMetProb[67].P[27]=0.0121951;			trMetProb[67].P[28]=0.0121951;			trMetProb[67].P[29]=0.0121951;			trMetProb[67].P[30]=0.0121951;			trMetProb[67].P[31]=0.0121951;			trMetProb[67].P[32]=0.0121951;			trMetProb[67].P[33]=0.0121951;			trMetProb[67].P[34]=0.0121951;			trMetProb[67].P[35]=0.0121951;			trMetProb[67].P[36]=0.0121951;			trMetProb[67].P[37]=0.0121951;			trMetProb[67].P[38]=0.0121951;			trMetProb[67].P[39]=0.0121951;			trMetProb[67].P[40]=0.0121951;			trMetProb[67].P[41]=0.0121951;			trMetProb[67].P[42]=0.0121951;			trMetProb[67].P[43]=0.0121951;			trMetProb[67].P[44]=0.0121951;			trMetProb[67].P[45]=0.0121951;			trMetProb[67].P[46]=0.0121951;			trMetProb[67].P[47]=0.0121951;			trMetProb[67].P[48]=0.0121951;			trMetProb[67].P[49]=0.0121951;			trMetProb[67].P[50]=0.0121951;			trMetProb[67].P[51]=0.0121951;			trMetProb[67].P[52]=0.0121951;			trMetProb[67].P[53]=0.0121951;			trMetProb[67].P[54]=0.0121951;			trMetProb[67].P[55]=0.0121951;			trMetProb[67].P[56]=0.0121951;			trMetProb[67].P[57]=0.0121951;			trMetProb[67].P[58]=0.0121951;			trMetProb[67].P[59]=0.0121951;			trMetProb[67].P[60]=0.0121951;			trMetProb[67].P[61]=0.0121951;			trMetProb[67].P[62]=0.0121951;			trMetProb[67].P[63]=0.0121951;			trMetProb[67].P[64]=0.0121951;			trMetProb[67].P[65]=0.0121951;			trMetProb[67].P[66]=0.0121951;			trMetProb[67].P[67]=0.0121951;			trMetProb[67].P[68]=0.134146;			trMetProb[67].P[69]=0.0121951;			trMetProb[67].P[70]=0.0121951;			trMetProb[67].P[71]=0.0121951;	
		trMetProb[68].P[0]=0.758413;			trMetProb[68].P[1]=0.00120192;			trMetProb[68].P[2]=0.00120192;			trMetProb[68].P[3]=0.00120192;			trMetProb[68].P[4]=0.00120192;			trMetProb[68].P[5]=0.00120192;			trMetProb[68].P[6]=0.00120192;			trMetProb[68].P[7]=0.00120192;			trMetProb[68].P[8]=0.00120192;			trMetProb[68].P[9]=0.00120192;			trMetProb[68].P[10]=0.00120192;			trMetProb[68].P[11]=0.00120192;			trMetProb[68].P[12]=0.00120192;			trMetProb[68].P[13]=0.00120192;			trMetProb[68].P[14]=0.00120192;			trMetProb[68].P[15]=0.00120192;			trMetProb[68].P[16]=0.00120192;			trMetProb[68].P[17]=0.00120192;			trMetProb[68].P[18]=0.00120192;			trMetProb[68].P[19]=0.00120192;			trMetProb[68].P[20]=0.00120192;			trMetProb[68].P[21]=0.00120192;			trMetProb[68].P[22]=0.00120192;			trMetProb[68].P[23]=0.00120192;			trMetProb[68].P[24]=0.00120192;			trMetProb[68].P[25]=0.00120192;			trMetProb[68].P[26]=0.00120192;			trMetProb[68].P[27]=0.00120192;			trMetProb[68].P[28]=0.00120192;			trMetProb[68].P[29]=0.00120192;			trMetProb[68].P[30]=0.00120192;			trMetProb[68].P[31]=0.00120192;			trMetProb[68].P[32]=0.00120192;			trMetProb[68].P[33]=0.00120192;			trMetProb[68].P[34]=0.00120192;			trMetProb[68].P[35]=0.00120192;			trMetProb[68].P[36]=0.00120192;			trMetProb[68].P[37]=0.00120192;			trMetProb[68].P[38]=0.00120192;			trMetProb[68].P[39]=0.00120192;			trMetProb[68].P[40]=0.00120192;			trMetProb[68].P[41]=0.00120192;			trMetProb[68].P[42]=0.00120192;			trMetProb[68].P[43]=0.00120192;			trMetProb[68].P[44]=0.00120192;			trMetProb[68].P[45]=0.00120192;			trMetProb[68].P[46]=0.00120192;			trMetProb[68].P[47]=0.00120192;			trMetProb[68].P[48]=0.00120192;			trMetProb[68].P[49]=0.00120192;			trMetProb[68].P[50]=0.00120192;			trMetProb[68].P[51]=0.00120192;			trMetProb[68].P[52]=0.00120192;			trMetProb[68].P[53]=0.00120192;			trMetProb[68].P[54]=0.00120192;			trMetProb[68].P[55]=0.00120192;			trMetProb[68].P[56]=0.00120192;			trMetProb[68].P[57]=0.00120192;			trMetProb[68].P[58]=0.00120192;			trMetProb[68].P[59]=0.00120192;			trMetProb[68].P[60]=0.00120192;			trMetProb[68].P[61]=0.00120192;			trMetProb[68].P[62]=0.00120192;			trMetProb[68].P[63]=0.00120192;			trMetProb[68].P[64]=0.00120192;			trMetProb[68].P[65]=0.00120192;			trMetProb[68].P[66]=0.00120192;			trMetProb[68].P[67]=0.00120192;			trMetProb[68].P[68]=0.0853365;			trMetProb[68].P[69]=0.0612981;			trMetProb[68].P[70]=0.0132212;			trMetProb[68].P[71]=0.00120192;	
		trMetProb[69].P[0]=0.788324;			trMetProb[69].P[1]=0.000358166;			trMetProb[69].P[2]=0.000358166;			trMetProb[69].P[3]=0.000358166;			trMetProb[69].P[4]=0.000358166;			trMetProb[69].P[5]=0.000358166;			trMetProb[69].P[6]=0.000358166;			trMetProb[69].P[7]=0.000358166;			trMetProb[69].P[8]=0.000358166;			trMetProb[69].P[9]=0.000358166;			trMetProb[69].P[10]=0.000358166;			trMetProb[69].P[11]=0.000358166;			trMetProb[69].P[12]=0.000358166;			trMetProb[69].P[13]=0.000358166;			trMetProb[69].P[14]=0.000358166;			trMetProb[69].P[15]=0.000358166;			trMetProb[69].P[16]=0.000358166;			trMetProb[69].P[17]=0.000358166;			trMetProb[69].P[18]=0.000358166;			trMetProb[69].P[19]=0.000358166;			trMetProb[69].P[20]=0.000358166;			trMetProb[69].P[21]=0.000358166;			trMetProb[69].P[22]=0.000358166;			trMetProb[69].P[23]=0.000358166;			trMetProb[69].P[24]=0.000358166;			trMetProb[69].P[25]=0.000358166;			trMetProb[69].P[26]=0.000358166;			trMetProb[69].P[27]=0.000358166;			trMetProb[69].P[28]=0.000358166;			trMetProb[69].P[29]=0.000358166;			trMetProb[69].P[30]=0.000358166;			trMetProb[69].P[31]=0.000358166;			trMetProb[69].P[32]=0.000358166;			trMetProb[69].P[33]=0.000358166;			trMetProb[69].P[34]=0.000358166;			trMetProb[69].P[35]=0.000358166;			trMetProb[69].P[36]=0.000358166;			trMetProb[69].P[37]=0.000358166;			trMetProb[69].P[38]=0.000358166;			trMetProb[69].P[39]=0.000358166;			trMetProb[69].P[40]=0.000358166;			trMetProb[69].P[41]=0.000358166;			trMetProb[69].P[42]=0.000358166;			trMetProb[69].P[43]=0.000358166;			trMetProb[69].P[44]=0.000358166;			trMetProb[69].P[45]=0.000358166;			trMetProb[69].P[46]=0.000358166;			trMetProb[69].P[47]=0.000358166;			trMetProb[69].P[48]=0.000358166;			trMetProb[69].P[49]=0.000358166;			trMetProb[69].P[50]=0.000358166;			trMetProb[69].P[51]=0.000358166;			trMetProb[69].P[52]=0.000358166;			trMetProb[69].P[53]=0.000358166;			trMetProb[69].P[54]=0.000358166;			trMetProb[69].P[55]=0.000358166;			trMetProb[69].P[56]=0.000358166;			trMetProb[69].P[57]=0.000358166;			trMetProb[69].P[58]=0.000358166;			trMetProb[69].P[59]=0.000358166;			trMetProb[69].P[60]=0.000358166;			trMetProb[69].P[61]=0.000358166;			trMetProb[69].P[62]=0.000358166;			trMetProb[69].P[63]=0.000358166;			trMetProb[69].P[64]=0.000358166;			trMetProb[69].P[65]=0.000358166;			trMetProb[69].P[66]=0.000358166;			trMetProb[69].P[67]=0.000358166;			trMetProb[69].P[68]=0.000358166;			trMetProb[69].P[69]=0.186605;			trMetProb[69].P[70]=0.000358166;			trMetProb[69].P[71]=0.000358166;	
		trMetProb[70].P[0]=0.254098;			trMetProb[70].P[1]=0.00819672;			trMetProb[70].P[2]=0.00819672;			trMetProb[70].P[3]=0.00819672;			trMetProb[70].P[4]=0.00819672;			trMetProb[70].P[5]=0.00819672;			trMetProb[70].P[6]=0.00819672;			trMetProb[70].P[7]=0.00819672;			trMetProb[70].P[8]=0.00819672;			trMetProb[70].P[9]=0.00819672;			trMetProb[70].P[10]=0.00819672;			trMetProb[70].P[11]=0.00819672;			trMetProb[70].P[12]=0.00819672;			trMetProb[70].P[13]=0.00819672;			trMetProb[70].P[14]=0.00819672;			trMetProb[70].P[15]=0.00819672;			trMetProb[70].P[16]=0.00819672;			trMetProb[70].P[17]=0.00819672;			trMetProb[70].P[18]=0.00819672;			trMetProb[70].P[19]=0.00819672;			trMetProb[70].P[20]=0.00819672;			trMetProb[70].P[21]=0.00819672;			trMetProb[70].P[22]=0.00819672;			trMetProb[70].P[23]=0.00819672;			trMetProb[70].P[24]=0.00819672;			trMetProb[70].P[25]=0.00819672;			trMetProb[70].P[26]=0.00819672;			trMetProb[70].P[27]=0.00819672;			trMetProb[70].P[28]=0.00819672;			trMetProb[70].P[29]=0.00819672;			trMetProb[70].P[30]=0.00819672;			trMetProb[70].P[31]=0.00819672;			trMetProb[70].P[32]=0.00819672;			trMetProb[70].P[33]=0.00819672;			trMetProb[70].P[34]=0.00819672;			trMetProb[70].P[35]=0.00819672;			trMetProb[70].P[36]=0.00819672;			trMetProb[70].P[37]=0.00819672;			trMetProb[70].P[38]=0.00819672;			trMetProb[70].P[39]=0.00819672;			trMetProb[70].P[40]=0.00819672;			trMetProb[70].P[41]=0.00819672;			trMetProb[70].P[42]=0.00819672;			trMetProb[70].P[43]=0.00819672;			trMetProb[70].P[44]=0.00819672;			trMetProb[70].P[45]=0.00819672;			trMetProb[70].P[46]=0.00819672;			trMetProb[70].P[47]=0.00819672;			trMetProb[70].P[48]=0.00819672;			trMetProb[70].P[49]=0.00819672;			trMetProb[70].P[50]=0.00819672;			trMetProb[70].P[51]=0.00819672;			trMetProb[70].P[52]=0.00819672;			trMetProb[70].P[53]=0.00819672;			trMetProb[70].P[54]=0.00819672;			trMetProb[70].P[55]=0.00819672;			trMetProb[70].P[56]=0.00819672;			trMetProb[70].P[57]=0.00819672;			trMetProb[70].P[58]=0.00819672;			trMetProb[70].P[59]=0.00819672;			trMetProb[70].P[60]=0.00819672;			trMetProb[70].P[61]=0.00819672;			trMetProb[70].P[62]=0.00819672;			trMetProb[70].P[63]=0.00819672;			trMetProb[70].P[64]=0.00819672;			trMetProb[70].P[65]=0.00819672;			trMetProb[70].P[66]=0.00819672;			trMetProb[70].P[67]=0.00819672;			trMetProb[70].P[68]=0.00819672;			trMetProb[70].P[69]=0.00819672;			trMetProb[70].P[70]=0.172131;			trMetProb[70].P[71]=0.00819672;	
		trMetProb[71].P[0]=0.00892857;			trMetProb[71].P[1]=0.00892857;			trMetProb[71].P[2]=0.00892857;			trMetProb[71].P[3]=0.00892857;			trMetProb[71].P[4]=0.00892857;			trMetProb[71].P[5]=0.00892857;			trMetProb[71].P[6]=0.00892857;			trMetProb[71].P[7]=0.00892857;			trMetProb[71].P[8]=0.00892857;			trMetProb[71].P[9]=0.00892857;			trMetProb[71].P[10]=0.00892857;			trMetProb[71].P[11]=0.00892857;			trMetProb[71].P[12]=0.00892857;			trMetProb[71].P[13]=0.00892857;			trMetProb[71].P[14]=0.00892857;			trMetProb[71].P[15]=0.00892857;			trMetProb[71].P[16]=0.00892857;			trMetProb[71].P[17]=0.00892857;			trMetProb[71].P[18]=0.00892857;			trMetProb[71].P[19]=0.00892857;			trMetProb[71].P[20]=0.00892857;			trMetProb[71].P[21]=0.00892857;			trMetProb[71].P[22]=0.00892857;			trMetProb[71].P[23]=0.00892857;			trMetProb[71].P[24]=0.00892857;			trMetProb[71].P[25]=0.00892857;			trMetProb[71].P[26]=0.00892857;			trMetProb[71].P[27]=0.00892857;			trMetProb[71].P[28]=0.00892857;			trMetProb[71].P[29]=0.00892857;			trMetProb[71].P[30]=0.00892857;			trMetProb[71].P[31]=0.00892857;			trMetProb[71].P[32]=0.00892857;			trMetProb[71].P[33]=0.00892857;			trMetProb[71].P[34]=0.00892857;			trMetProb[71].P[35]=0.00892857;			trMetProb[71].P[36]=0.00892857;			trMetProb[71].P[37]=0.00892857;			trMetProb[71].P[38]=0.00892857;			trMetProb[71].P[39]=0.00892857;			trMetProb[71].P[40]=0.00892857;			trMetProb[71].P[41]=0.00892857;			trMetProb[71].P[42]=0.00892857;			trMetProb[71].P[43]=0.00892857;			trMetProb[71].P[44]=0.00892857;			trMetProb[71].P[45]=0.00892857;			trMetProb[71].P[46]=0.00892857;			trMetProb[71].P[47]=0.00892857;			trMetProb[71].P[48]=0.00892857;			trMetProb[71].P[49]=0.00892857;			trMetProb[71].P[50]=0.00892857;			trMetProb[71].P[51]=0.00892857;			trMetProb[71].P[52]=0.00892857;			trMetProb[71].P[53]=0.00892857;			trMetProb[71].P[54]=0.00892857;			trMetProb[71].P[55]=0.00892857;			trMetProb[71].P[56]=0.00892857;			trMetProb[71].P[57]=0.00892857;			trMetProb[71].P[58]=0.00892857;			trMetProb[71].P[59]=0.00892857;			trMetProb[71].P[60]=0.00892857;			trMetProb[71].P[61]=0.00892857;			trMetProb[71].P[62]=0.00892857;			trMetProb[71].P[63]=0.00892857;			trMetProb[71].P[64]=0.00892857;			trMetProb[71].P[65]=0.00892857;			trMetProb[71].P[66]=0.00892857;			trMetProb[71].P[67]=0.00892857;			trMetProb[71].P[68]=0.00892857;			trMetProb[71].P[69]=0.00892857;			trMetProb[71].P[70]=0.00892857;			trMetProb[71].P[71]=0.366071;	

    for(int i=0;i<numMetricalPos;i+=1){
      trMetProb[i].Normalize();
    }//endfor i
    barJumpProb.Normalize();

    for(int i=0;i<numStates;i+=1){
      for(int j=0;j<numStates;j+=1){
        trProb[i].P[j]=trMetProb[i%numMetricalPos].P[j%numMetricalPos]*barJumpProb.P[j/numMetricalPos];
      }//endfor j
      trProb[i].Normalize();
    }//endfor i

  effGrids.clear();
  for(int i=0;i<numStates;i+=1){
    if(i%2!=0 && i%3!=0){continue;}
    effGrids.push_back(i);
  }//endfor i
  effGridIntervals.clear();
  effGridIntervals.resize(effGrids.size());
  for(int i=0;i<effGrids.size();i+=1){
    for(int j=0;j<effGrids.size();j+=1){//j->i
      effGridIntervals[i].push_back(effGrids[j]);
    }//endfor j
  }//endfor i
//cout<<effGrids.size()<<"\t"<<effGridIntervals[0].size()<<endl;

//////Calculate and set initial probabilites
    vector<double> stationaryProb;
    for(int i=0;i<numStates;i+=1){
      stationaryProb.push_back((1.*rand())/(1.*RAND_MAX));
    }//endfor i
    Norm(stationaryProb);
    for(int iter=0;iter<100;iter+=1){
      vector<double> prevVec(stationaryProb);
      for(int i=0;i<numStates;i+=1){
        stationaryProb[i]=0;
        for(int j=0;j<numStates;j+=1){
          stationaryProb[i]+=prevVec[j]*trProb[j].P[i];
        }//endfor j
      }//endfor i
    }//endfor iter
    Norm(stationaryProb);
    trIniProb.P=stationaryProb;
    trIniProb.Normalize();

//////Init tempo model
    Sigma_t=0.02;
    lambda=0.0101;
    minSecPerQN=0.3;//BPM=200
    maxSeqPerQN=1.5;//BPM=40
    numTempoState=50;
    truncatedWidth=6;
    double SigmaV=1.;
    fac_t=-0.5*log(2*M_PI*Sigma_t*Sigma_t);

    double eps=log(maxSeqPerQN/minSecPerQN)/numTempoState;
    for(int i=0;i<numTempoState;i+=1){
      secPerQN.push_back(minSecPerQN*exp(i*eps));
    }//endfor i

    tempoTrProb.resize(numTempoState);
    for(int i=0;i<numTempoState;i+=1){
      tempoTrProb[i].P.resize(numTempoState);
      for(int j=0;j<numTempoState;j+=1){
        tempoTrProb[i].P[j]=exp(-0.5*pow((i-j)/SigmaV,2.));
      }//endfor j
      tempoTrProb[i].Normalize();
    }//endfor i

    tempoTrIniProb.P.resize(numTempoState);
    for(int i=0;i<numTempoState;i+=1){
      tempoTrIniProb.P[i]=exp(-0.5*pow((i-numTempoState/2)/(3*SigmaV),2.));
    }//endfor i
    tempoTrIniProb.Normalize();


if(printOn){cout<<"###Init END###"<<endl;}
  }//end Init

  void ReadData_Transcr(string filename){
    data.ReadFile(filename);
    data.TPQN=24;
    for(int n=0;n<data.evts.size();n+=1){data.evts[n].chan=0;}
  }//end ReadData_Transcr

  double OutputLP(int pos_pre,int pos,int tempoID,double ioi_){
    int nv=pos%numMetricalPos-pos_pre%numMetricalPos+(pos/numMetricalPos)*numMetricalPos;
    if(nv<0){
      return fac_t-0.5*pow((ioi_-1*secPerQN[tempoID]/double(TPQN))/Sigma_t,2.)-1E10;
    }else if(nv==0){
      return -log(lambda)-ioi_/lambda;
    }else{
      return fac_t-0.5*pow((ioi_-nv*secPerQN[tempoID]/double(TPQN))/Sigma_t,2.);
    }//endif
  }//end OutputLP


  void Viterbi(){
if(printOn){cout<<"###Viterbi###"<<endl;}

    vector<double> iois;
    for(int n=1;n<data.evts.size();n+=1){
      iois.push_back(data.evts[n].ontime-data.evts[n-1].ontime);
    }//endfor n

    vector<vector<double> > LP;//pos X tempoID
    vector<vector<vector<vector<int> > > > amax;//amax[n][pos][tempoID][0]と...[1]は(pos,tempoID)に対応。
    double logP;

////初期確率
    LP.resize(numStates);
    for(int iN=0;iN<numStates;iN+=1){
      LP[iN].resize(numTempoState);
      for(int iT=0;iT<numTempoState;iT+=1){
        LP[iN][iT]=trIniProb.LP[iN]+tempoTrIniProb.LP[iT];
      }//endfor iT
    }//endfor iN
    amax.resize(iois.size());
    for(int n=0;n<iois.size();n+=1){
      amax[n].resize(numStates);
      for(int iN=0;iN<numStates;iN+=1){
        amax[n][iN].resize(numTempoState);
        for(int iT=0;iT<numTempoState;iT+=1){
          amax[n][iN][iT].resize(2);
        }//endfor iT
      }//endfor iN
    }//endfor n

    for(int n=0;n<iois.size();n+=1){
cout<<"###### data sample "<<(n+1)<<"/"<<iois.size()<<endl;
      vector<vector<double> > preLP=LP;

      int jN,iN;
      for(int i=0;i<effGrids.size();i+=1){//jN,jT -> iN,iT
      for(int iT=0;iT<numTempoState;iT+=1){

        iN=effGrids[i];
        LP[iN][iT]=preLP[0][0]+trProb[0].LP[iN]+tempoTrProb[0].LP[iT]+OutputLP(0,iN,iT,iois[n]);
        amax[n][iN][iT][0]=0;
        amax[n][iN][iT][1]=0;

        for(int j=0;j<effGridIntervals[i].size();j+=1){
        for(int jT=0;jT<numTempoState;jT+=1){
            jN=effGrids[j];
            logP=preLP[jN][jT]+trProb[jN].LP[iN]+tempoTrProb[jT].LP[iT]+OutputLP(jN,iN,iT,iois[n]);
            if(logP>LP[iN][iT]){
              LP[iN][iT]=logP;
              amax[n][iN][iT][0]=jN;
              amax[n][iN][iT][1]=jT;
            }//endif

        }//endfor jT
        }//endfor jN

      }//endfor iT
      }//endfor iN
    }//endfor n

    vector<vector<int> > maxPath;//(maxPath[n][0],maxPath[n][1])は(pos,tempoID)を表す

    maxPath.resize(iois.size()+1);
    for(int n=0;n<iois.size()+1;n+=1){
      maxPath[n].resize(2);
    }//endfor n
    double max=LP[effGrids[0]][0];
    maxPath[iois.size()][0]=effGrids[0];
    maxPath[iois.size()][1]=0;
    for(int i=0;i<effGrids.size();i+=1){
    for(int iT=0;iT<numTempoState;iT+=1){
      int iN=effGrids[i];
      if(LP[iN][iT]>max){
        max=LP[iN][iT];
        maxPath[iois.size()][0]=iN;
        maxPath[iois.size()][1]=iT;
      }//endif
    }//endfor iT
    }//endfor iN
    for(int n=iois.size()-1;n>=0;n-=1){
      maxPath[n][0]=amax[n][maxPath[n+1][0]][maxPath[n+1][1]][0];
      maxPath[n][1]=amax[n][maxPath[n+1][0]][maxPath[n+1][1]][1];
    }//endfor n
  data.logP=max;
  data.evts[0].stime=0;
  data.evts[0].dur=-1;
  for(int n=1;n<iois.size()+1;n+=1){
    int nv=maxPath[n][0]%numMetricalPos-maxPath[n-1][0]%numMetricalPos+(maxPath[n][0]/numMetricalPos)*numMetricalPos;
    data.evts[n].stime=data.evts[n-1].stime+nv;
    data.evts[n].dur=-1;
  }//endfor n

if(printOn){cout<<"###Viterbi END###"<<endl;}
  }//end Viterbi

  void WriteFile(string filename){
    data.WriteFile(filename);
  }//end WriteFile

};//end class MetricalHMM_triple


class MetricalHMM{
public:
  int TPQN;
  Transcr data;
  MetricalHMM_duple hmm_duple;
  MetricalHMM_triple hmm_triple;

  MetricalHMM(){
    Init();
  }//end MetricalHMM
  ~MetricalHMM(){
  }//end ~MetricalHMM

  void Init(){
  }//end Init

  void ReadData_Transcr(string filename){
    data.ReadFile(filename);
    data.TPQN=24;
    hmm_duple.ReadData_Transcr(filename);
    hmm_triple.ReadData_Transcr(filename);
  }//end ReadData_Transcr

  void Viterbi(){

    hmm_duple.Viterbi();
    hmm_triple.Viterbi();

    if(hmm_duple.data.logP>hmm_triple.data.logP){
      data=hmm_duple.data;
    }else{
      data=hmm_triple.data;
    }//endif

  }//end Viterbi


  void WriteFile(string filename){
    data.WriteFile(filename);
  }//end WriteFile


};//end class MetricalHMM


#endif // METRICALHMM_HPP
